# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`powerstore_email_notify_destination`](#powerstore_email_notify_destination): rubocop:disable Style/StringLiterals
* [`powerstore_file_dns`](#powerstore_file_dns): rubocop:disable Style/StringLiterals
* [`powerstore_file_ftp`](#powerstore_file_ftp): rubocop:disable Style/StringLiterals
* [`powerstore_file_interface`](#powerstore_file_interface): rubocop:disable Style/StringLiterals
* [`powerstore_file_interface_route`](#powerstore_file_interface_route): rubocop:disable Style/StringLiterals
* [`powerstore_file_kerberos`](#powerstore_file_kerberos): rubocop:disable Style/StringLiterals
* [`powerstore_file_ldap`](#powerstore_file_ldap): rubocop:disable Style/StringLiterals
* [`powerstore_file_ndmp`](#powerstore_file_ndmp): rubocop:disable Style/StringLiterals
* [`powerstore_file_nis`](#powerstore_file_nis): rubocop:disable Style/StringLiterals
* [`powerstore_file_system`](#powerstore_file_system): rubocop:disable Style/StringLiterals
* [`powerstore_file_tree_quota`](#powerstore_file_tree_quota): rubocop:disable Style/StringLiterals
* [`powerstore_file_virus_checker`](#powerstore_file_virus_checker): rubocop:disable Style/StringLiterals
* [`powerstore_host`](#powerstore_host): rubocop:disable Style/StringLiterals
* [`powerstore_host_group`](#powerstore_host_group): rubocop:disable Style/StringLiterals
* [`powerstore_import_host_system`](#powerstore_import_host_system): rubocop:disable Style/StringLiterals
* [`powerstore_import_session`](#powerstore_import_session): rubocop:disable Style/StringLiterals
* [`powerstore_local_user`](#powerstore_local_user): rubocop:disable Style/StringLiterals
* [`powerstore_migration_session`](#powerstore_migration_session): rubocop:disable Style/StringLiterals
* [`powerstore_nas_server`](#powerstore_nas_server): rubocop:disable Style/StringLiterals
* [`powerstore_nfs_export`](#powerstore_nfs_export): rubocop:disable Style/StringLiterals
* [`powerstore_physical_switch`](#powerstore_physical_switch): rubocop:disable Style/StringLiterals
* [`powerstore_policy`](#powerstore_policy): rubocop:disable Style/StringLiterals
* [`powerstore_remote_system`](#powerstore_remote_system): rubocop:disable Style/StringLiterals
* [`powerstore_replication_rule`](#powerstore_replication_rule): rubocop:disable Style/StringLiterals
* [`powerstore_smb_share`](#powerstore_smb_share): rubocop:disable Style/StringLiterals
* [`powerstore_snapshot_rule`](#powerstore_snapshot_rule): rubocop:disable Style/StringLiterals
* [`powerstore_storage_container`](#powerstore_storage_container): rubocop:disable Style/StringLiterals
* [`powerstore_vcenter`](#powerstore_vcenter): rubocop:disable Style/StringLiterals
* [`powerstore_volume`](#powerstore_volume): rubocop:disable Style/StringLiterals
* [`powerstore_volume_group`](#powerstore_volume_group): rubocop:disable Style/StringLiterals

### Functions

* [`format_bytes`](#format_bytes): Converts the bytes argument into a human-readable form, for example 1000000000 bytes becomes 1GB.
* [`to_bytes`](#to_bytes): Converts the argument into bytes, for example 4kB becomes 4096. Takes a single string value as an argument.

### Tasks

* [`alert_collection_query`](#alert_collection_query): Query all alerts.
* [`alert_instance_query`](#alert_instance_query): Query a specific alert.
* [`alert_modify`](#alert_modify): Modify an alert. acknowledged_severity parameter, if included, will cause the request to fail when the alert's severity is higher than the ac
* [`appliance_collection_query`](#appliance_collection_query): Query the appliances in a cluster.
* [`appliance_forecast`](#appliance_forecast): Forecast capacity usage for an appliance.
* [`appliance_instance_query`](#appliance_instance_query): Query a specific appliance in a cluster.
* [`appliance_modify`](#appliance_modify): Modify an appliance's name.
* [`appliance_time_to_full`](#appliance_time_to_full): Returns information about when an appliance is forecast to reach 100% capacity usage.
* [`audit_event_collection_query`](#audit_event_collection_query): Query audit log entries.
* [`bond_collection_query`](#bond_collection_query): Query bond configurations.
* [`bond_instance_query`](#bond_instance_query): Query a specific bond configuration.
* [`chap_config_collection_query`](#chap_config_collection_query): Query the list of (one) CHAP configuration settings objects. This resource type collection query does not support filtering, sorting or pagin
* [`chap_config_instance_query`](#chap_config_instance_query): Query the CHAP configuration settings object.
* [`chap_config_modify`](#chap_config_modify): Modify the CHAP configuration settings object. To enable either Single or Mutual CHAP modes, the username and password must already be set, o
* [`cluster_collection_query`](#cluster_collection_query): Get details about the cluster. This resource type collection query does not support filtering, sorting or pagination
* [`cluster_forecast`](#cluster_forecast): Forecast capacity usage for the cluster.
* [`cluster_instance_query`](#cluster_instance_query): Get details about the cluster. This does not support the following standard query functionality: property selection, and nested query embeddi
* [`cluster_modifyclusterproperties`](#cluster_modifyclusterproperties): Modify cluster properties, such as physical MTU.
* [`cluster_time_to_full`](#cluster_time_to_full): Returns information about when the cluster is forecast to reach 100% capacity usage.
* [`discovered_initiator_collection_query`](#discovered_initiator_collection_query): Returns connected initiators that are not associated with a host. This resource type collection query does not support filtering, sorting or 
* [`dns_collection_query`](#dns_collection_query): Query DNS settings for a cluster.
* [`dns_instance_query`](#dns_instance_query): Query a specific DNS setting.
* [`dns_modify`](#dns_modify): Modify a DNS setting.
* [`email_notify_destination_collection_query`](#email_notify_destination_collection_query): Query all email notification destinations.
* [`email_notify_destination_create`](#email_notify_destination_create): Add an email address to receive notifications.
* [`email_notify_destination_delete`](#email_notify_destination_delete): Delete an email notification destination.
* [`email_notify_destination_instance_query`](#email_notify_destination_instance_query): Query a specific email notification destination.
* [`email_notify_destination_modify`](#email_notify_destination_modify): Modify an email notification destination.
* [`email_notify_destination_test`](#email_notify_destination_test): Send a test email to an email address.
* [`eth_port_collection_query`](#eth_port_collection_query): Get Ethernet front-end port configuration for all cluster nodes.
* [`eth_port_instance_query`](#eth_port_instance_query): Get Ethernet front-end port configuration by instance identifier.
* [`eth_port_modify`](#eth_port_modify): Change the properties of the front-end port. Note that setting the port's requested speed may not cause the port speed to change immediately.
* [`event_eventsummary`](#event_eventsummary): Get event by Event Id.
* [`event_getevents`](#event_getevents): Returns all events in the database.
* [`fc_port_collection_query`](#fc_port_collection_query): Query the FC front-end port configurations for all cluster nodes.
* [`fc_port_instance_query`](#fc_port_instance_query): Query a specific FC front-end port configuration.
* [`fc_port_modify`](#fc_port_modify): Modify an FC front-end port's speed. Setting the port's requested speed might not cause the port speed to change immediately. In cases where 
* [`file_dns_collection_query`](#file_dns_collection_query): Query of the DNS settings of NAS Servers.
* [`file_dns_create`](#file_dns_create): Create a new DNS Server configuration for a NAS Server. Only one object can be created per NAS Server.
* [`file_dns_delete`](#file_dns_delete): Delete DNS settings of a NAS Server.
* [`file_dns_instance_query`](#file_dns_instance_query): Query a specific DNS settings object of a NAS Server.
* [`file_dns_modify`](#file_dns_modify): Modify the DNS settings of a NAS Server.
* [`file_ftp_collection_query`](#file_ftp_collection_query): Query FTP/SFTP instances.
* [`file_ftp_create`](#file_ftp_create): Create an FTP/SFTP server.
* [`file_ftp_delete`](#file_ftp_delete): Delete an FTP/SFTP Server.
* [`file_ftp_instance_query`](#file_ftp_instance_query): Query a specific FTP/SFTP server for its settings.
* [`file_ftp_modify`](#file_ftp_modify): Modify an FTP/SFTP server settings.
* [`file_interface_collection_query`](#file_interface_collection_query): Query file interfaces.
* [`file_interface_create`](#file_interface_create): Create a file interface.
* [`file_interface_delete`](#file_interface_delete): Delete a file interface.
* [`file_interface_instance_query`](#file_interface_instance_query)
* [`file_interface_modify`](#file_interface_modify): Modify the settings of a file interface.
* [`file_interface_route_collection_query`](#file_interface_route_collection_query): Query file interface routes.
* [`file_interface_route_create`](#file_interface_route_create): Create and configure a new file interface route.There are 3 route types Subnet, Default, and Host.* The default route establishes a static ro
* [`file_interface_route_delete`](#file_interface_route_delete): Delete file interface route.
* [`file_interface_route_instance_query`](#file_interface_route_instance_query): Query a specific file interface route for details.
* [`file_interface_route_modify`](#file_interface_route_modify): Modify file interface route settings.
* [`file_kerberos_collection_query`](#file_kerberos_collection_query): Query of the Kerberos service settings of NAS Servers.
* [`file_kerberos_create`](#file_kerberos_create): Create a Kerberos configuration. The operation will fail if a Kerberos configuration already exists.
* [`file_kerberos_delete`](#file_kerberos_delete): Delete Kerberos configuration of a NAS Server.
* [`file_kerberos_download_keytab`](#file_kerberos_download_keytab): Download previously uploaded keytab file for secure NFS service.
* [`file_kerberos_instance_query`](#file_kerberos_instance_query): Query a specific Kerberos service settings of a NAS Server.
* [`file_kerberos_modify`](#file_kerberos_modify): Modify the Kerberos service settings of a NAS Server.
* [`file_kerberos_upload_keytab`](#file_kerberos_upload_keytab): A keytab file is required for secure NFS service with a Linux or Unix Kerberos Key Distribution Center (KDC). The keytab file can be generate
* [`file_ldap_collection_query`](#file_ldap_collection_query): List LDAP Service instances.
* [`file_ldap_create`](#file_ldap_create): Create an LDAP service on a NAS Server. Only one LDAP Service object can be created per NAS Server.
* [`file_ldap_delete`](#file_ldap_delete): Delete a NAS Server's LDAP settings.
* [`file_ldap_download_certificate`](#file_ldap_download_certificate)
* [`file_ldap_download_config`](#file_ldap_download_config)
* [`file_ldap_instance_query`](#file_ldap_instance_query): Query a specific NAS Server's LDAP settings object.
* [`file_ldap_modify`](#file_ldap_modify): Modify a NAS Server's LDAP settings object.
* [`file_ldap_upload_certificate`](#file_ldap_upload_certificate)
* [`file_ldap_upload_config`](#file_ldap_upload_config)
* [`file_ndmp_collection_query`](#file_ndmp_collection_query): List configured NDMP service instances.
* [`file_ndmp_create`](#file_ndmp_create): Add an NDMP service configuration to a NAS server. Only one NDMP service object can be configured per NAS server.
* [`file_ndmp_delete`](#file_ndmp_delete): Delete an NDMP service configuration instance of a NAS Server.
* [`file_ndmp_instance_query`](#file_ndmp_instance_query): Query an NDMP service configuration instance.
* [`file_ndmp_modify`](#file_ndmp_modify): Modify an NDMP service configuration instance.
* [`file_nis_collection_query`](#file_nis_collection_query): Query the NIS settings of NAS Servers.
* [`file_nis_create`](#file_nis_create): Create a new NIS Service on a NAS Server. Only one NIS Setting object can be created per NAS Server.
* [`file_nis_delete`](#file_nis_delete): Delete NIS settings of a NAS Server.
* [`file_nis_instance_query`](#file_nis_instance_query): Query a specific NIS settings object of a NAS Server.
* [`file_nis_modify`](#file_nis_modify): Modify the NIS settings of a NAS Server.
* [`file_system_clone`](#file_system_clone): Create a clone of a file system.
* [`file_system_collection_query`](#file_system_collection_query): List file systems.
* [`file_system_create`](#file_system_create): Create a file system.
* [`file_system_delete`](#file_system_delete): Delete a file system.
* [`file_system_instance_query`](#file_system_instance_query): Query a specific file system.
* [`file_system_modify`](#file_system_modify): Modify a file system.
* [`file_system_refresh`](#file_system_refresh): Refresh a snapshot of a file system. The content of the snapshot is replaced with the current content of the parent file system.
* [`file_system_refresh_quota`](#file_system_refresh_quota): Refresh the actual content of tree and user quotas objects.
* [`file_system_restore`](#file_system_restore): Restore from a snapshot of a file system.
* [`file_system_snapshot`](#file_system_snapshot): Create a snapshot of a file system.
* [`file_tree_quota_collection_query`](#file_tree_quota_collection_query): List tree quota instances.
* [`file_tree_quota_create`](#file_tree_quota_create): Create a tree quota instance.
* [`file_tree_quota_delete`](#file_tree_quota_delete): Delete a tree quota instance.
* [`file_tree_quota_instance_query`](#file_tree_quota_instance_query): Query a tree quota instance.
* [`file_tree_quota_modify`](#file_tree_quota_modify): Modify a tree quota instance.
* [`file_tree_quota_refresh`](#file_tree_quota_refresh): Refresh the cache with the actual value of the tree quota.
* [`file_user_quota_collection_query`](#file_user_quota_collection_query): List user quota instances.
* [`file_user_quota_create`](#file_user_quota_create): Create a user quota instance.
* [`file_user_quota_instance_query`](#file_user_quota_instance_query): Query a user quota instance.
* [`file_user_quota_modify`](#file_user_quota_modify): Modify a user quota instance.
* [`file_user_quota_refresh`](#file_user_quota_refresh): Refresh the cache with the actual value of the user quota.
* [`file_virus_checker_collection_query`](#file_virus_checker_collection_query): Query all virus checker settings of the NAS Servers.
* [`file_virus_checker_create`](#file_virus_checker_create): Add a new virus checker setting to a NAS Server. Only one instance can be created per NAS Server.Workflow to enable the virus checker setting
* [`file_virus_checker_delete`](#file_virus_checker_delete): Delete virus checker settings of a NAS Server.
* [`file_virus_checker_download_config`](#file_virus_checker_download_config): Download a virus checker configuration file containing the template or the actual (if already uploaded) virus checker configuration settings.
* [`file_virus_checker_instance_query`](#file_virus_checker_instance_query): Query a specific virus checker setting of a NAS Server.
* [`file_virus_checker_modify`](#file_virus_checker_modify): Modify the virus checker settings of a NAS Server.
* [`file_virus_checker_upload_config`](#file_virus_checker_upload_config): Upload a virus checker configuration file containing the virus checker configuration settings.
* [`hardware_collection_query`](#hardware_collection_query): List hardware components.
* [`hardware_drive_repurpose`](#hardware_drive_repurpose): A drive that has been used in a different appliance will be locked for use only in that appliance. This operation will allow a locked drive t
* [`hardware_instance_query`](#hardware_instance_query): Get a specific hardware component instance.
* [`hardware_modify`](#hardware_modify): Modify a hardware instance.
* [`host_attach`](#host_attach): Attach host to volume.
* [`host_collection_query`](#host_collection_query): List host information.
* [`host_create`](#host_create): Add a host.
* [`host_delete`](#host_delete): Delete a host. Delete fails if host is attached to a volume or consistency group.
* [`host_detach`](#host_detach): Detach host from volume.
* [`host_group_attach`](#host_group_attach): Attach host group to volume.
* [`host_group_collection_query`](#host_group_collection_query): List host groups.
* [`host_group_create`](#host_group_create): Create a host group.
* [`host_group_delete`](#host_group_delete): Delete a host group. Delete fails if host group is attached to a volume.
* [`host_group_detach`](#host_group_detach): Detach host group from volume.
* [`host_group_instance_query`](#host_group_instance_query): Get details about a specific host group.
* [`host_group_modify`](#host_group_modify): Operations that can be performed are modify name, remove host(s) from host group, add host(s) to host group. Modify request will only support
* [`host_instance_query`](#host_instance_query): Get details about a specific host by id.
* [`host_modify`](#host_modify): Operation that can be performed are modify name, modify description, remove initiator(s) from host, add initiator(s) to host, update existing
* [`host_virtual_volume_mapping_collection_query`](#host_virtual_volume_mapping_collection_query): Query associations between a virtual volume and the host(s) it is attached to.
* [`host_virtual_volume_mapping_instance_query`](#host_virtual_volume_mapping_instance_query): Query a specific virtual volume mapping.
* [`host_volume_mapping_collection_query`](#host_volume_mapping_collection_query): Query associations between a volume and the host or host group it is attached to.
* [`host_volume_mapping_instance_query`](#host_volume_mapping_instance_query): Query a specific host volume mapping.
* [`import_host_initiator_collection_query`](#import_host_initiator_collection_query): Query import host initiators.
* [`import_host_initiator_instance_query`](#import_host_initiator_instance_query): Query a specific import host initiator instance.
* [`import_host_system_collection_query`](#import_host_system_collection_query): Query import host systems that are attached to volumes.
* [`import_host_system_create`](#import_host_system_create): Add an import host system so that it can be mapped to a volume. Before mapping an import host system, ensure that a host agent is installed. 
* [`import_host_system_delete`](#import_host_system_delete): Delete an import host system. You cannot delete an import host system if there are import sessions active in the system referencing the impor
* [`import_host_system_instance_query`](#import_host_system_instance_query): Query a specific import host system instance.
* [`import_host_system_refresh`](#import_host_system_refresh): Refresh the details of a specific import host system. Use this operation when there is a change to the import host or import host volumes.
* [`import_host_volume_collection_query`](#import_host_volume_collection_query): Query import host volumes.
* [`import_host_volume_instance_query`](#import_host_volume_instance_query): Query a specific import host volume instance.
* [`import_psgroup_collection_query`](#import_psgroup_collection_query): Query PS Group storage arrays.
* [`import_psgroup_discover`](#import_psgroup_discover): Discover the importable volumes and snapshot schedules in the PS Group.
* [`import_psgroup_instance_query`](#import_psgroup_instance_query): Query a specific PS Group storage array.
* [`import_psgroup_volume_collection_query`](#import_psgroup_volume_collection_query): Query PS Group volumes.
* [`import_psgroup_volume_import_snapshot_schedules`](#import_psgroup_volume_import_snapshot_schedules): Return the snapshot schedules for a PS Group volume.
* [`import_psgroup_volume_instance_query`](#import_psgroup_volume_instance_query): Query a specific PS Group volume.
* [`import_session_cancel`](#import_session_cancel): Cancel an active import session. Cancel is allowed when the import is in a Scheduled, Queued, Copy_In_Progress, or Ready_For_Cutover state. A
* [`import_session_cleanup`](#import_session_cleanup): Clean up an import session that is in Cleanup_Required state and requires user intervention to revert the source volume to its pre-import sta
* [`import_session_collection_query`](#import_session_collection_query): Query import sessions.
* [`import_session_create`](#import_session_create): Create a new import session. The source storage system and hosts that access the volumes or consistency groups must be added prior to creatin
* [`import_session_cutover`](#import_session_cutover): Commit an import session that is in a Ready_For_Cutover state. When the import session is created with the automatic_cutover attribute set to
* [`import_session_delete`](#import_session_delete): Delete an import session that is in a Completed, Failed, or Cancelled state. Delete removes the historical record of the import. To stop acti
* [`import_session_instance_query`](#import_session_instance_query): Query a specific session.
* [`import_session_modify`](#import_session_modify): Modify the scheduled date and time of the specified import session.
* [`import_session_pause`](#import_session_pause): Pauses an ongoing import session. When this occurs, the background data copy stops, but IO to the source still occurs. Pause is only supporte
* [`import_session_resume`](#import_session_resume): Resumes the paused import session. The background data copy continues from where it was stopped. Resume is only applicable when the import in
* [`import_storage_center_collection_query`](#import_storage_center_collection_query): Query SC arrays.
* [`import_storage_center_consistency_group_collection_query`](#import_storage_center_consistency_group_collection_query): Query SC consistency groups.
* [`import_storage_center_consistency_group_import_snapshot_profiles`](#import_storage_center_consistency_group_import_snapshot_profiles): Return the snapshot profiles of an SC consistency group.
* [`import_storage_center_consistency_group_instance_query`](#import_storage_center_consistency_group_instance_query): Query a specific SC consistency group.
* [`import_storage_center_discover`](#import_storage_center_discover): Discover the importable volumes and snapshot profiles in the SC array.
* [`import_storage_center_instance_query`](#import_storage_center_instance_query): Query a specific SC array.
* [`import_storage_center_volume_collection_query`](#import_storage_center_volume_collection_query): Query SC volumes.
* [`import_storage_center_volume_import_snapshot_profiles`](#import_storage_center_volume_import_snapshot_profiles): Return the snapshot profiles of an SC volume.
* [`import_storage_center_volume_instance_query`](#import_storage_center_volume_instance_query): Query a specific SC volume.
* [`import_unity_collection_query`](#import_unity_collection_query): Query Unity storage systems.
* [`import_unity_consistency_group_collection_query`](#import_unity_consistency_group_collection_query): Query Unity consistency groups.
* [`import_unity_consistency_group_import_snapshot_schedules`](#import_unity_consistency_group_import_snapshot_schedules): Return the snapshot schedules associated with the specified Unity consistency group.
* [`import_unity_consistency_group_instance_query`](#import_unity_consistency_group_instance_query): Query a specific Unity consistency group.
* [`import_unity_discover`](#import_unity_discover): Discover the importable volumes and consistency groups in the Unity storage system.
* [`import_unity_instance_query`](#import_unity_instance_query): Query a specific Unity storage system.
* [`import_unity_volume_collection_query`](#import_unity_volume_collection_query): Query Unity volumes.
* [`import_unity_volume_import_snapshot_schedules`](#import_unity_volume_import_snapshot_schedules): Return the snapshot schedules associated with the specified Unity volume.
* [`import_unity_volume_instance_query`](#import_unity_volume_instance_query): Query a specific Unity volume.
* [`import_vnx_array_collection_query`](#import_vnx_array_collection_query): Query VNX storage systems.
* [`import_vnx_array_discover`](#import_vnx_array_discover): Discover the importable volumes and consistency groups in a VNX storage system.
* [`import_vnx_array_instance_query`](#import_vnx_array_instance_query): Query a specific VNX storage system.
* [`import_vnx_consistency_group_collection_query`](#import_vnx_consistency_group_collection_query): Query VNX consistency groups.
* [`import_vnx_consistency_group_instance_query`](#import_vnx_consistency_group_instance_query): Query a specific VNX consistency group.
* [`import_vnx_volume_collection_query`](#import_vnx_volume_collection_query): Query VNX volumes.
* [`import_vnx_volume_instance_query`](#import_vnx_volume_instance_query): Query a specific VNX volume.
* [`ip_pool_address_collection_query`](#ip_pool_address_collection_query): Query configured IP addresses.
* [`ip_pool_address_instance_query`](#ip_pool_address_instance_query): Query a specific IP address.
* [`ip_port_collection_query`](#ip_port_collection_query): Query IP port configurations.
* [`ip_port_instance_query`](#ip_port_instance_query): Query a specific IP port configuration.
* [`ip_port_modify`](#ip_port_modify): Modify IP port parameters.
* [`job_collectionquery`](#job_collectionquery): Query jobs.
* [`job_instancequery`](#job_instancequery): Query a specific job.
* [`keystore_archive_downloadakeystorebackuparchivefile`](#keystore_archive_downloadakeystorebackuparchivefile): Download a keystore backup archive file that was previously generated by a successful /api/rest/keystore_archive/regenerate POST command. Thi
* [`keystore_archive_regeneratearchivefile`](#keystore_archive_regeneratearchivefile): Creates a new encryption keystore archive file to replace the existing archive file, which includes the individual keystore backup files from
* [`license_collection_query`](#license_collection_query): Query license information for the cluster. There is always one license instance.
* [`license_instance_query`](#license_instance_query): Query the specific license information for the cluster.
* [`license_license_file_upload`](#license_license_file_upload): Upload a software license to install the license on the cluster.
* [`license_retrieve_license`](#license_retrieve_license): Retrieve the license directly from the DellEMC Software Licensing Central. This runs automatically when the cluster is configured, and if it 
* [`local_user_collection_query`](#local_user_collection_query): Query all local user account instances. This resource type collection query does not support filtering, sorting or pagination
* [`local_user_create`](#local_user_create): Create a new local user account. Any existing local user with either an administrator or a security administrator role can create a new local
* [`local_user_delete`](#local_user_delete): Delete a local user account instance using the unique identifier. You cannot delete the default 'admin' account or the account you are curren
* [`local_user_instance_query`](#local_user_instance_query): Query a specific local user account instance using an unique identifier.
* [`local_user_modify`](#local_user_modify): Modify a property of a local user account using the unique identifier. You cannot modify the default 'admin' user account.
* [`login_session_collection_query`](#login_session_collection_query): Obtain the login session for the current user. This resource type collection query does not support filtering, sorting or pagination
* [`logout_logout`](#logout_logout): Log out the current user.
* [`maintenance_window_collection_query`](#maintenance_window_collection_query): Query the maintenance window configurations.
* [`maintenance_window_instance_query`](#maintenance_window_instance_query): Query one appliance maintenance window configuration.
* [`maintenance_window_modify`](#maintenance_window_modify): Configure maintenance window.
* [`metrics_metrics`](#metrics_metrics): Retrieves metrics for specified type.
* [`migration_recommendation_collectionquery`](#migration_recommendation_collectionquery): Get migration recommendations.
* [`migration_recommendation_create`](#migration_recommendation_create): Generate a recommendation for redistributing storage utilization between appliances.
* [`migration_recommendation_create_migration_sessions`](#migration_recommendation_create_migration_sessions): Create the migration sessions to implement a migration recommendation. If the response contains a list of hosts to rescan, those hosts must b
* [`migration_recommendation_delete`](#migration_recommendation_delete): Delete a migration recommendation.
* [`migration_recommendation_instancequery`](#migration_recommendation_instancequery): Get a single migration recommendation.
* [`migration_recommendation_start_migration_sessions`](#migration_recommendation_start_migration_sessions): Start previously created migration sessions for recommendation. Ensure that any rescans specified in the create_migration_sessions response h
* [`migration_session_collection_query`](#migration_session_collection_query): Query migration sessions.
* [`migration_session_create`](#migration_session_create): Create a new migration session. For virtual volumes (vVols), the background copy is completed during this phase and the ownership of the vVol
* [`migration_session_cutover`](#migration_session_cutover): Final phase of the migration, when ownership of the volume, vVol, or volume group is transferred to the new appliance.
* [`migration_session_delete`](#migration_session_delete): Delete a migration session. With the force option, a migration session can be deleted regardless of its state. All background activity is can
* [`migration_session_instance_query`](#migration_session_instance_query): Query a specific migration session.
* [`migration_session_pause`](#migration_session_pause): Pause a migration session. Only migration sessions in the synchronizing state can be paused.
* [`migration_session_resume`](#migration_session_resume): Resume a paused migration session. You cannot resume a migration session in the failed state.
* [`migration_session_sync`](#migration_session_sync): Synchronize a migration session. During this phase, the majority of the background copy is completed and there are no interruptions to any se
* [`nas_server_collection_query`](#nas_server_collection_query): Query all NAS servers.
* [`nas_server_create`](#nas_server_create): Create a NAS server.
* [`nas_server_delete`](#nas_server_delete): Delete a NAS server.
* [`nas_server_download_group`](#nas_server_download_group): Download a NAS server group file containing the template or the actual (if already uploaded) group details.
* [`nas_server_download_homedir`](#nas_server_download_homedir): Download a NAS server homedir file containing the template or the actual (if already uploaded) homedir configuration settings.
* [`nas_server_download_hosts`](#nas_server_download_hosts): Download an NAS server host file containing template/actual(if already uploaded) host details.
* [`nas_server_download_netgroup`](#nas_server_download_netgroup): Download an NAS server netgroup file containing the template or the actual (if already uploaded) netgroup details.
* [`nas_server_download_nsswitch`](#nas_server_download_nsswitch): Download a NAS server nsswitch file containing the template or the actual (if already uploaded) nsswitch configuration settings.
* [`nas_server_download_ntxmap`](#nas_server_download_ntxmap): Download an NAS server ntxmap file containing the template or the actual (if already uploaded) ntxmap configuration settings.
* [`nas_server_download_passwd`](#nas_server_download_passwd): Download a NAS server passwd file containing template or the actual (if already uploaded) passwd details.
* [`nas_server_download_user_mapping_report`](#nas_server_download_user_mapping_report): Download the report generated by the update_user_mappings action.
* [`nas_server_instance_query`](#nas_server_instance_query): Query a specific NAS server.
* [`nas_server_modify`](#nas_server_modify): Modify the settings of a NAS server.
* [`nas_server_ping`](#nas_server_ping): Ping destination from NAS server.
* [`nas_server_update_user_mappings`](#nas_server_update_user_mappings): Fix the user mappings for all file systems associated with the NAS server. This process updates file ownership on the NAS server's file syste
* [`nas_server_upload_group`](#nas_server_upload_group): Upload NAS server group file.
* [`nas_server_upload_homedir`](#nas_server_upload_homedir): Upload the NAS server homedir file.
* [`nas_server_upload_hosts`](#nas_server_upload_hosts): Upload NAS server host file.
* [`nas_server_upload_netgroup`](#nas_server_upload_netgroup): Upload the NAS server netgroup file.
* [`nas_server_upload_nsswitch`](#nas_server_upload_nsswitch): Upload the NAS server nsswitch file.
* [`nas_server_upload_ntxmap`](#nas_server_upload_ntxmap)
* [`nas_server_upload_passwd`](#nas_server_upload_passwd): Upload NAS server passwd file.
* [`network_collection_query`](#network_collection_query): Query the IP network configurations of the cluster.
* [`network_instance_query`](#network_instance_query): Query a specific IP network configuration.
* [`network_modify`](#network_modify): Modify IP network parameters, such as gateways, netmasks, VLAN identifiers, and IP addresses.
* [`network_replace`](#network_replace): Reconfigure cluster management network settings from IPv4 to IPv6 or vice versa.
* [`network_scale`](#network_scale): Add IP ports for use by the storage network, or remove IP ports so they can no longer be used.At least one IP port must be configured for use
* [`nfs_export_collection_query`](#nfs_export_collection_query): List NFS Exports.
* [`nfs_export_create`](#nfs_export_create): Create an NFS Export for a Snapshot.
* [`nfs_export_delete`](#nfs_export_delete): Delete NFS Export.
* [`nfs_export_instance_query`](#nfs_export_instance_query): Get NFS Export properties.
* [`nfs_export_modify`](#nfs_export_modify): Modify NFS Export Properties.
* [`nfs_server_collection_query`](#nfs_server_collection_query): Query all NFS Servers.
* [`nfs_server_create`](#nfs_server_create): Create an NFS server.
* [`nfs_server_delete`](#nfs_server_delete): Delete an NFS server.
* [`nfs_server_instance_query`](#nfs_server_instance_query): Query settings of an NFS server.
* [`nfs_server_join`](#nfs_server_join): Join the secure NFS server to the NAS server's AD domain, which is necessary for Secure NFS.
* [`nfs_server_modify`](#nfs_server_modify): Modify NFS server settings.
* [`nfs_server_unjoin`](#nfs_server_unjoin): Unjoin the secure NFS server from the NAS server's Active Directory domain. If you unjoin with secure NFS exports active, exports will be una
* [`node_collection_query`](#node_collection_query): Query the nodes in a cluster.
* [`node_instance_query`](#node_instance_query): Query a specific node in a cluster.
* [`ntp_collection_query`](#ntp_collection_query): Query NTP settings for a cluster.
* [`ntp_instance_query`](#ntp_instance_query): Query a specific NTP setting.
* [`ntp_modify`](#ntp_modify): Modify NTP settings.
* [`performance_rule_collectionquery`](#performance_rule_collectionquery): Get performance rules.
* [`performance_rule_instancequery`](#performance_rule_instancequery): Get a performance rule by id.
* [`physical_switch_collection_query`](#physical_switch_collection_query): Query physical switches settings for a cluster.
* [`physical_switch_create`](#physical_switch_create): Create a physical switch settings.
* [`physical_switch_delete`](#physical_switch_delete): Delete the physical switch settings.
* [`physical_switch_instance_query`](#physical_switch_instance_query): Query a specific physical switch settings.
* [`physical_switch_modify`](#physical_switch_modify): Modify a physical switch settings.
* [`policy_collection_query`](#policy_collection_query): Query protection and performance policies.The following REST query is an example of how to retrieve protection policies along with their rule
* [`policy_create`](#policy_create): Create a new protection policy. Protection policies can be assigned to volumes or volume groups. When a protection policy is assigned to a vo
* [`policy_delete`](#policy_delete): Delete a protection policy.Protection policies that are used by any storage resources can not be deleted.
* [`policy_instance_query`](#policy_instance_query): Query a specific policy.
* [`policy_modify`](#policy_modify): Modify a protection policy.
* [`remote_system_collection_query`](#remote_system_collection_query): Query remote systems.
* [`remote_system_create`](#remote_system_create): Create a new remote system relationship. The type of remote system being connected requires different parameter sets. For PowerStore remote s
* [`remote_system_delete`](#remote_system_delete): Delete a remote system. Deleting the remote system deletes the management and data connections established with the remote system. You cannot
* [`remote_system_instance_query`](#remote_system_instance_query): Query a remote system instance.
* [`remote_system_modify`](#remote_system_modify): Modify a remote system instance. The list of valid parameters depends on the type of remote system.For PowerStore remote system relationships
* [`remote_system_verify`](#remote_system_verify): Verify and update the remote system instance. Detects changes in the local and remote systems and reestablishes data connections, also taking
* [`replication_rule_collection_query`](#replication_rule_collection_query): Query all replication rules.
* [`replication_rule_create`](#replication_rule_create): Create a new replication rule.
* [`replication_rule_delete`](#replication_rule_delete): Delete a replication rule.Deleting a rule is not permitted, if the rule is associated with a protection policy thatis currently applied to a 
* [`replication_rule_instance_query`](#replication_rule_instance_query): Query a specific replication rule.
* [`replication_rule_modify`](#replication_rule_modify): Modify a replication rule.If the rule is associated with a policy that is currently applied toa storage resource, the modified rule is immedi
* [`replication_session_collection_query`](#replication_session_collection_query): Query replication sessions.
* [`replication_session_failover`](#replication_session_failover): Fail over a replication session instance. Failing over the replication session changes the role of the destination system. After a failover, 
* [`replication_session_instance_query`](#replication_session_instance_query): Query a replication session instance.
* [`replication_session_pause`](#replication_session_pause): Pause a replication session instance. You can pause a replication session when you need to modify the source or destination system. For examp
* [`replication_session_reprotect`](#replication_session_reprotect): Reprotect a replication session instance. Activates the replication session and starts synchronization. This can only be used when the sessio
* [`replication_session_resume`](#replication_session_resume): Resume a replication session instance that is paused. Resuming the replication session schedules a synchronization cycle if the session was i
* [`replication_session_sync`](#replication_session_sync): Synchronize the destination resource with changes on source resource from the previous synchronization cycle. Synchronization happens either 
* [`role_collection_query`](#role_collection_query): Query roles. This resource type collection query does not support filtering, sorting or pagination
* [`role_instance_query`](#role_instance_query): Query a specific role.
* [`sas_port_collection_query`](#sas_port_collection_query): Query the SAS port configuration for all cluster nodes.
* [`sas_port_instancequery`](#sas_port_instancequery): Query a specific SAS port configuration.
* [`security_config_collection_query`](#security_config_collection_query): Query system security configurations. This resource type collection query does not support filtering, sorting or pagination
* [`security_config_instance_query`](#security_config_instance_query): Query a specific system security configuration.
* [`service_config_collection_query`](#service_config_collection_query): Query the service configuration instances for the cluster. This resource type collection query does not support filtering, sorting or paginat
* [`service_config_instance_query`](#service_config_instance_query): Query the service configuration instances for an appliance.
* [`service_config_modify`](#service_config_modify): Modify the service configuration for an appliance.
* [`service_user_collection_query`](#service_user_collection_query): Query the service user account instance. This resource type collection query does not support filtering, sorting or pagination
* [`service_user_instance_query`](#service_user_instance_query): Query the service user account using the unique identifier.
* [`service_user_modify`](#service_user_modify): Modify the properties of the service user account.
* [`smb_server_collection_query`](#smb_server_collection_query): Query all SMB servers.
* [`smb_server_create`](#smb_server_create): Create an SMB server.
* [`smb_server_delete`](#smb_server_delete): Delete a SMB server. The SMB server must not be joined to a domain to be deleted.
* [`smb_server_instance_query`](#smb_server_instance_query): Query settings of a specific SMB server.
* [`smb_server_join`](#smb_server_join): Join the SMB server to an Active Directory domain.
* [`smb_server_modify`](#smb_server_modify): Modify an SMB server's settings.
* [`smb_server_unjoin`](#smb_server_unjoin): Unjoin the SMB server from an Active Directory domain.
* [`smb_share_collection_query`](#smb_share_collection_query): List SMB shares.
* [`smb_share_create`](#smb_share_create): Create an SMB share.
* [`smb_share_delete`](#smb_share_delete): Delete an SMB Share.
* [`smb_share_instance_query`](#smb_share_instance_query): Get an SMB Share.
* [`smb_share_modify`](#smb_share_modify): Modify SMB share properties.
* [`smtp_config_collection_query`](#smtp_config_collection_query): Query the SMTP configuration. There is always exactly one smtp_config instance.
* [`smtp_config_instance_query`](#smtp_config_instance_query): Query the specific SMTP configuration.
* [`smtp_config_modify`](#smtp_config_modify): Configure the outgoing SMTP information.
* [`smtp_config_test`](#smtp_config_test): Test the SMTP configuration.
* [`snapshot_rule_collection_query`](#snapshot_rule_collection_query): Query all snapshot rules.
* [`snapshot_rule_create`](#snapshot_rule_create): Create a new snapshot rule.
* [`snapshot_rule_delete`](#snapshot_rule_delete): Delete a snapshot rule
* [`snapshot_rule_instance_query`](#snapshot_rule_instance_query): Query a specific snapshot rule.
* [`snapshot_rule_modify`](#snapshot_rule_modify): Modify a snapshot rule.If the rule is associated with a policy that is currently applied toa storage resource, the modified rule is immediate
* [`software_installed_collection_query`](#software_installed_collection_query): Query the software that is installed on each appliance. The output returns a list of JSON objects representing the software that is installed
* [`software_installed_instance_query`](#software_installed_instance_query): Query a specific item from the list of installed software.
* [`software_package_collection_query`](#software_package_collection_query): Query the software packages that are known by the cluster. The output returns a list of JSON objects representing the packages.
* [`software_package_delete`](#software_package_delete): Delete the specified software package from the cluster. This operation may take some time to complete.
* [`software_package_install`](#software_package_install): Start a software upgrade background job for the specified appliance within the cluster. If an  appliance is not specified, the upgrade is per
* [`software_package_instance_query`](#software_package_instance_query): Query a specific software package.
* [`software_package_puhc`](#software_package_puhc): Run the pre-upgrade health check for a software package. This operation may take some time to respond.
* [`software_package_upload`](#software_package_upload): Push a software package file from the client to the cluster. When successfully uploaded and verified, the result is a software_package in the
* [`storage_container_collection_query`](#storage_container_collection_query): List storage containers.
* [`storage_container_create`](#storage_container_create): Create a virtual volume (vVol) storage container.
* [`storage_container_delete`](#storage_container_delete): Delete a storage container.
* [`storage_container_instance_query`](#storage_container_instance_query): Query a specific instance of storage container.
* [`storage_container_modify`](#storage_container_modify): Modify a storage container.
* [`storage_container_mount`](#storage_container_mount): Mount a storage container as a vVol datastore in vCenter.
* [`storage_container_unmount`](#storage_container_unmount): Unmount a storage container, which removes the vVol datastore from vCenter.
* [`vcenter_collection_query`](#vcenter_collection_query): Query registered vCenters.
* [`vcenter_create`](#vcenter_create): Add a vCenter. Not allowed in Unified+ deployments.
* [`vcenter_delete`](#vcenter_delete): Delete a registered vCenter. Deletion of vCenter disables functionality that requires communication with vCenter. Not allowed in Unified+ dep
* [`vcenter_instance_query`](#vcenter_instance_query): Query a specific vCenter instance.
* [`vcenter_modify`](#vcenter_modify): Modify a vCenter settings.
* [`veth_port_collection_query`](#veth_port_collection_query): Query virtual Ethernet port configurations.
* [`veth_port_instance_query`](#veth_port_instance_query): Query a specific virtual Ethernet port configuration.
* [`virtual_machine_collection_query`](#virtual_machine_collection_query): Query virtual machines that use storage from the cluster.
* [`virtual_machine_delete`](#virtual_machine_delete): Delete a virtual machine snapshot. This operation cannot be used on a base virtual machine or virtual machine template.
* [`virtual_machine_instance_query`](#virtual_machine_instance_query): Query a specific virtual machine instance.
* [`virtual_machine_modify`](#virtual_machine_modify): Modify a virtual machine. This operation cannot be used on virtual machine snapshots or templates.
* [`virtual_machine_snapshot`](#virtual_machine_snapshot): Create a snapshot of a virtual machine. This operation cannot be used on a virtual machine snapshot or template.
* [`virtual_volume_collection_query`](#virtual_volume_collection_query): Get virtual volumes.
* [`virtual_volume_delete`](#virtual_volume_delete): Delete a virtual volume.
* [`virtual_volume_instance_query`](#virtual_volume_instance_query): Get a specific virtual volume.
* [`volume_attach`](#volume_attach): Attach a volume to a host or host group.
* [`volume_clone`](#volume_clone): Create a clone of a volume or snapshot.
* [`volume_collection_query`](#volume_collection_query): Query volumes that are provisioned on the appliance.
* [`volume_create`](#volume_create): Create a volume on the appliance.
* [`volume_delete`](#volume_delete): Delete a volume. * A volume which is attached to a host or host group or is a member of a volume group cannot be deleted.* A volume which has
* [`volume_detach`](#volume_detach): Detach a volume from a host or host group.
* [`volume_group_add_members`](#volume_group_add_members): Add member volumes to an existing primary or clone volume group.This cannot be used to add members to a snapshot set. Members cannot be added
* [`volume_group_clone`](#volume_group_clone): Clone a volume group. The clone volume group will be created on the same appliance as the source volume group.A clone of a volume group will 
* [`volume_group_collection_query`](#volume_group_collection_query): Query all volume groups, including snapshot sets and clones of volume groups.
* [`volume_group_create`](#volume_group_create): Create a new volume group. The resulting volume group will have a type of Primary.
* [`volume_group_delete`](#volume_group_delete): Delete a volume group, snapshot set, or clone.Before you try deleting a volume group, snapshot set, or clone, ensure that you first detach it
* [`volume_group_instance_query`](#volume_group_instance_query): Query a specific volume group, snapshot set, or clone.
* [`volume_group_modify`](#volume_group_modify): Modify a volume group, snapshot set, or clone.
* [`volume_group_refresh`](#volume_group_refresh): Refresh the contents of a volume group (the target volume group) from another volume group in the same family.A backup snapshot set of the ta
* [`volume_group_remove_members`](#volume_group_remove_members): Remove members from an existing primary or clone volume group.This cannot be used to remove members from a snapshot set. Members cannot be re
* [`volume_group_restore`](#volume_group_restore): Restore a volume group from a snapshot set. A primary or a clone volume group can only be restored from one of its immediate snapshot sets.A 
* [`volume_group_snapshot`](#volume_group_snapshot): Create a new snapshot set for a volume group.When a snapshot of a volume group is created, the resultant snapshot volume group is referred to
* [`volume_instance_query`](#volume_instance_query): Query a specific volume instance.
* [`volume_modify`](#volume_modify): Modify the parameters of a volume.
* [`volume_refresh`](#volume_refresh): Refresh the contents of the target volume from another volume in the same family. By default, a backup snapshot of the target volume is not c
* [`volume_restore`](#volume_restore): Restore a volume from a snapshot. A primary or clone volume can only be restored from one of its immediate snapshots.  By default, a backup s
* [`volume_snapshot`](#volume_snapshot): Create a snapshot of a volume or a clone. The source id of the snapshot is the id of source volume or clone. The source time is the time when
* [`x509_certificate_collection_query`](#x509_certificate_collection_query): Query to list X509 Certificates instances. This resource type collection query does not support filtering, sorting or pagination
* [`x509_certificate_decommission_certificates`](#x509_certificate_decommission_certificates): Decommission x509 certificates for one service type (currently only Replication_HTTP is supported) of one scope (for example remote system)
* [`x509_certificate_exchange_certificates`](#x509_certificate_exchange_certificates): Exchange certificates between two clusters. Add CA certificates to the trust store of each cluster and assign roles to the client certificate
* [`x509_certificate_instance_query`](#x509_certificate_instance_query): Query a specific X509 Certificate instance.

### Plans

* [`powerstore::capacity_volumes`](#powerstorecapacity_volumes): list volumes with more than given capacity
* [`powerstore::create_assign_protection_policy`](#powerstorecreate_assign_protection_policy): A Bolt Plan that creates a set of "organization default" snapshot rules,
uses them to create a protection policy, then assigns that new protection
policy to an existing volume
* [`powerstore::create_multiple_volumes`](#powerstorecreate_multiple_volumes): This plan creates multiple volumes
* [`powerstore::create_volume`](#powerstorecreate_volume): A Bolt Plan that creates or deletes a volume
* [`powerstore::create_volume_attach_host_with_fs`](#powerstorecreate_volume_attach_host_with_fs): A Bolt Plan that creates a volume, maps that new volume to an existing
host, scans that host's iSCSI bus to ensure device nodes have been created,
computes the device name as viewed by the host, partitions the new disk
device, puts new file system on partition, mounts fresh file system at
designated location
* [`powerstore::delete_multiple_volumes`](#powerstoredelete_multiple_volumes): This plan deletes multiple volumes after first removing them from a group if they are a group member.
* [`powerstore::find_empty_volume_groups`](#powerstorefind_empty_volume_groups): Find empty volume groups - Puppet language plan example
* [`powerstore::get_fs_used_size_greaterthan_threshold`](#powerstoreget_fs_used_size_greaterthan_threshold): List filesystems using more than $threshold percent of storage. Note: currently limited to one target.
* [`powerstore::multi_create_volume_attach_host_with_fs`](#powerstoremulti_create_volume_attach_host_with_fs): This Bolt Plan makes is possible to create volumes, map them to multiple
hosts, create XFS file systems upon them and mount them at a specific
location by wrapping another plan that is capable of doing this for a single
host

## Resource types

### `powerstore_email_notify_destination`

rubocop:disable Style/StringLiterals

#### Properties

The following properties are available in the `powerstore_email_notify_destination` type.

##### `email_address`

Data type: `Optional[String]`

Email address to receive notifications.

##### `ensure`

Data type: `Enum['present', 'absent']`

Whether this resource should be present or absent on the target system.

Default value: `present`

##### `notify_critical`

Data type: `Optional[Boolean]`

Whether to send notifications for critical alerts.

##### `notify_info`

Data type: `Optional[Boolean]`

Whether send notifications for informational alerts.

##### `notify_major`

Data type: `Optional[Boolean]`

Whether to send notifications for major alerts.

##### `notify_minor`

Data type: `Optional[Boolean]`

Whether to send notifications for minor alerts.

#### Parameters

The following parameters are available in the `powerstore_email_notify_destination` type.

##### `id`

namevar

Data type: `String`

Unique identifier of the email notification destination.

### `powerstore_file_dns`

rubocop:disable Style/StringLiterals

#### Properties

The following properties are available in the `powerstore_file_dns` type.

##### `add_ip_addresses`

Data type: `Optional[Array[String]]`

IP addresses to add to the current list. The addresses may be IPv4 or IPv6. Error occurs if an IP address already exists. Cannot be combined with ip_addresses.

##### `domain`

Data type: `Optional[String[1,255]]`

Name of the DNS domain, where the NAS Server does host names lookup when an FQDN is not specified in the request.

##### `ensure`

Data type: `Enum['present', 'absent']`

Whether this resource should be present or absent on the target system.

Default value: `present`

##### `ip_addresses`

Data type: `Optional[Array[String]]`

The list of DNS server IP addresses. The addresses may be IPv4 or IPv6.

##### `nas_server_id`

Data type: `Optional[String]`

Unique identifier of the associated NAS Server instance that uses this DNS object. Only one DNS object per NAS Server is supported.

##### `remove_ip_addresses`

Data type: `Optional[Array[String]]`

IP addresses to remove from the current list. The addresses may be IPv4 or IPv6. Error occurs if IP address is not present. Cannot be combined with ip_addresses.

##### `transport`

Data type: `Optional[Enum['UDP','TCP']]`

Transport used when connecting to the DNS Server:* UDP - DNS uses the UDP protocol (default)* TCP - DNS uses the TCP protocol

##### `transport_l10n`

Data type: `Optional[String]`

Localized message string corresponding to transport

#### Parameters

The following parameters are available in the `powerstore_file_dns` type.

##### `id`

namevar

Data type: `String`

Unique identifier of the DNS object.

### `powerstore_file_ftp`

rubocop:disable Style/StringLiterals

#### Properties

The following properties are available in the `powerstore_file_ftp` type.

##### `add_groups`

Data type: `Optional[Array[String]]`

Groups to add to the current groups. Error occurs if the group already exists. Cannot be combined with groups.

##### `add_hosts`

Data type: `Optional[Array[String]]`

Host IP addresses to add to the current hosts. The addresses may be IPv4 or IPv6. Error occurs if the IP address already exists. Cannot be combined with hosts.

##### `add_users`

Data type: `Optional[Array[String]]`

Users to add to the current users. Error occurs if the user already exist. Cannot be combined with users.

##### `audit_dir`

Data type: `Optional[String]`

(Applies when the value of is_audit_enabled is true.) Directory of FTP/SFTP audit files. Logs are saved in '/' directory (default) or in a mounted file system (Absolute path of the File system directory which should already exist).

##### `audit_max_size`

Data type: `Optional[Integer[40960,9223372036854775807]]`

(Applies when the value of is_audit_enabled is true.) Maximum size of all (current plus archived) FTP/SFTP audit files, in bytes.There is a maximum of 5 audit files, 1 current audit file (ftp.log) and 4 archived audit files.The maximum value for this setting is 5GB (each file of 1GB) if the audit directory belongs to a user file system of the NAS server.If the audit directory is '/', the maximum value is 5MB (each file of 1MB).The minimum value is 40kB (each file of 8KB) on any file system.

##### `default_homedir`

Data type: `Optional[String]`

(Applies when the value of is_homedir_limit_enabled is false.) Default directory of FTP and SFTP clients who have a home directory that is not defined or accessible.

##### `ensure`

Data type: `Enum['present', 'absent']`

Whether this resource should be present or absent on the target system.

Default value: `present`

##### `groups`

Data type: `Optional[Array[String]]`

Allowed or denied user groups, depending on the value of the is_allowed_groups attribute.- If allowed groups exist, only users who are members of these groups and no others can connect to the NAS server through FTP or SFTP.- If denied groups exist, all users who are members of those groups always have access denied to the NAS server through FTP or SFTP.- If the list is empty, there is no restriction to the NAS server access through FTP or SFTP based on the user group.

##### `hosts`

Data type: `Optional[Array[String]]`

Allowed or denied hosts, depending on the value of the is_allowed_hosts attribute. A host is defined using its IP address. Subnets using CIDR notation are also supported.- If allowed hosts exist, only those hosts and no others can connect to the NAS server through FTP or SFTP.- If denied hosts exist, they always have access denied to the NAS server through FTP or SFTP.- If the list is empty, there is no restriction to NAS server access through FTP or SFTP based on the host IP address.- The addresses may be IPv4 or IPv6.

##### `is_allowed_groups`

Data type: `Optional[Boolean]`

Indicates whether the groups attribute contains allowed or denied user groups. Values are:- true - groups contains allowed user groups.- false - groups contains denied user groups.

##### `is_allowed_hosts`

Data type: `Optional[Boolean]`

Indicates whether the hosts attribute contains allowed or denied hosts. Values are:true - hosts contains allowed hosts.false - hosts contains denied hosts.

##### `is_allowed_users`

Data type: `Optional[Boolean]`

Indicates whether the users attribute contains allowed or denied users. Values are:- true - users contains allowed users.- false - users contains denied users.

##### `is_anonymous_authentication_enabled`

Data type: `Optional[Boolean]`

Indicates whether FTP clients can be authenticated anonymously. Values are:- true - Anonymous user name is accepted.- false - Anonymous user name is not accepted.

##### `is_audit_enabled`

Data type: `Optional[Boolean]`

Indicates whether the activity of FTP and SFTP clients is tracked in audit files. Values are:- true - FTP/SFTP activity is tracked.- false - FTP/SFTP activity is not tracked.

##### `is_ftp_enabled`

Data type: `Optional[Boolean]`

Indicates whether the FTP server is enabled on the NAS server specified in the nasServer attribute. Values are:- true - FTP server is enabled on the specified NAS server.- false - FTP server is disabled on the specified NAS server.

##### `is_homedir_limit_enabled`

Data type: `Optional[Boolean]`

Indicates whether an FTP or SFTP user access is limited to the home directory of the user. Values are:- true - An FTP or SFTP user can access only the home directory of the user.- false - FTP and SFTP users can access any NAS server directory, according to NAS server permissions.

##### `is_sftp_enabled`

Data type: `Optional[Boolean]`

Indicates whether the SFTP server is enabled on the NAS server specified in the nasServer attribute. Values are:- true - SFTP server is enabled on the specified NAS server.- false - SFTP server is disabled on the specified NAS server.

##### `is_smb_authentication_enabled`

Data type: `Optional[Boolean]`

Indicates whether FTP and SFTP clients can be authenticated using an SMB user name. These user names are defined in a Windows domain controller, and their formats are user@domain or domain\\user. Values are:- true - SMB user names are accepted for authentication.- false - SMB user names are not accepted for authentication.

##### `is_unix_authentication_enabled`

Data type: `Optional[Boolean]`

Indicates whether FTP and SFTP clients can be authenticated using a Unix user name. Unix user names are defined in LDAP, NIS servers or in local passwd file. Values are:- true - Unix user names are accepted for authentication.- false - Unix user names are not accepted for authentication.

##### `message_of_the_day`

Data type: `Optional[String]`

Message of the day displayed on the console of FTP clients after their authentication. The length of this message is limited to 511 bytes of UTF-8 characters, and the length of each line is limited to 80 bytes.

##### `nas_server_id`

Data type: `Optional[String]`

Unique identifier of the NAS server that is configured with the FTP server.

##### `remove_groups`

Data type: `Optional[Array[String]]`

Groups to remove from the current groups. Error occurs if the group is not present. Cannot be combined with groups.

##### `remove_hosts`

Data type: `Optional[Array[String]]`

Host IP addresses to remove from the current hosts. The addresses may be IPv4 or IPv6. Error occurs if the IP address is not present. Cannot be combined with hosts.

##### `remove_users`

Data type: `Optional[Array[String]]`

Users to remove from the current users. Error occurs if the user is not present. Cannot be combined with users.

##### `users`

Data type: `Optional[Array[String]]`

Allowed or denied users, depending on the value of the is_allowed_user attribute.- If allowed users exist, only those users and no others can connect to the NAS server through FTP or SFTP.- If denied users exist, they have always access denied to the NAS server through FTP or SFTP.- If the list is empty, there is no restriction to the NAS server access through FTP or SFTP based on the user name.

##### `welcome_message`

Data type: `Optional[String]`

Welcome message displayed on the console of FTP and SFTP clients before their authentication. The length of this message is limited to 511 bytes of UTF-8 characters, and the length of each line is limited to 80 bytes.

#### Parameters

The following parameters are available in the `powerstore_file_ftp` type.

##### `id`

namevar

Data type: `String`

Unique identifier of the FTP/SFTP Server object.

### `powerstore_file_interface`

rubocop:disable Style/StringLiterals

#### Properties

The following properties are available in the `powerstore_file_interface` type.

##### `ensure`

Data type: `Enum['present', 'absent']`

Whether this resource should be present or absent on the target system.

Default value: `present`

##### `gateway`

Data type: `Optional[String[1,45]]`

Gateway address for the network interface. IPv4 and IPv6 are supported.

##### `ip_address`

Data type: `Optional[String[1,45]]`

IP address of the network interface. IPv4 and IPv6 are supported.

##### `is_disabled`

Data type: `Optional[Boolean]`

Indicates whether the network interface is disabled.

##### `name`

Data type: `Optional[String]`

Name of the network interface. This property supports case-insensitive filtering

##### `nas_server_id`

Data type: `Optional[String]`

Unique identifier of the NAS server to which the network interface belongs, as defined by the nas_server resource type.

##### `prefix_length`

Data type: `Optional[Integer[1,128]]`

Prefix length for the interface. IPv4 and IPv6 are supported.

##### `role`

Data type: `Optional[Enum['Production','Backup']]`

- Production - This type of network interface is used for all file protocols and services of a NAS server. This type of interface is inactive while a NAS server is in destination mode. - Backup  - This type of network interface is used only for NDMP/NFS backup or disaster recovery testing. This type of interface is always active in all NAS server modes.

##### `role_l10n`

Data type: `Optional[String]`

Localized message string corresponding to role

##### `vlan_id`

Data type: `Optional[Integer[0,4094]]`

Virtual Local Area Network (VLAN) identifier for the interface. The interface uses the identifier to accept packets that have matching VLAN tags.

#### Parameters

The following parameters are available in the `powerstore_file_interface` type.

##### `id`

namevar

Data type: `String`

Unique identifier of the file interface.

### `powerstore_file_interface_route`

rubocop:disable Style/StringLiterals

#### Properties

The following properties are available in the `powerstore_file_interface_route` type.

##### `destination`

Data type: `Optional[String]`

IPv4 or IPv6 address of the target network node based on the specific route type. Values are:* For a default route, there is no value because the system will use the specified gateway IP address.* For a host route, the value is the host IP address.* For a subnet route, the value is a subnet IP address.

##### `ensure`

Data type: `Enum['present', 'absent']`

Whether this resource should be present or absent on the target system.

Default value: `present`

##### `file_interface_id`

Data type: `Optional[String]`

Unique identifier of the associated file interface.

##### `gateway`

Data type: `Optional[String[1,45]]`

IP address of the gateway associated with the route.

##### `operational_status`

Data type: `Optional[Enum['Ok','Invalid_IP_Version','Invalid_Source_Interface','Invalid_Gateway','Not_Operational']]`

File interface route Operational Status:* Ok - the route is working fine.* Invalid_IP_Version - source interfaces have a different IP protocol version than the route.* Invalid_Source_Interface - no source interfaces set up on the system.* Invalid_Gateway - source interfaces in a different subnet than the gateway.* Not_Operational - the route is not operational.

##### `operational_status_l10n`

Data type: `Optional[String]`

Localized message string corresponding to operational_status

##### `prefix_length`

Data type: `Optional[Integer[1,128]]`

IPv4 or IPv6 prefix length for the route.

#### Parameters

The following parameters are available in the `powerstore_file_interface_route` type.

##### `id`

namevar

Data type: `String`

Unique identifier of the file interface route object.

### `powerstore_file_kerberos`

rubocop:disable Style/StringLiterals

#### Properties

The following properties are available in the `powerstore_file_kerberos` type.

##### `add_kdc_addresses`

Data type: `Optional[Array[String[1,255]]]`

Fully Qualified domain names of the Kerberos Key Distribution Center (KDC) servers to add to the current list. Error occurs if name already exists. Cannot be combined with kdc_addresses. IPv4 and IPv6 addresses are not supported.

##### `ensure`

Data type: `Enum['present', 'absent']`

Whether this resource should be present or absent on the target system.

Default value: `present`

##### `kdc_addresses`

Data type: `Optional[Array[String[1,255]]]`

Fully Qualified domain names of the Kerberos Key Distribution Center (KDC) servers. IPv4 and IPv6 addresses are not supported.

##### `nas_server_id`

Data type: `Optional[String]`

Unique identifier of the associated NAS Server instance that uses this Kerberos object. Only one Kerberos object per NAS Server is supported.

##### `port_number`

Data type: `Optional[Integer[0,65535]]`

KDC servers TCP port.

##### `realm`

Data type: `Optional[String[1,255]]`

Realm name of the Kerberos Service.

##### `remove_kdc_addresses`

Data type: `Optional[Array[String[1,255]]]`

Fully Qualified domain names of the Kerberos Key Distribution Center (KDC) servers to remove from the current list. Error occurs if name is not in the existing list. Cannot be combined with kdc_addresses. IPv4 and IPv6 addresses are not supported.

#### Parameters

The following parameters are available in the `powerstore_file_kerberos` type.

##### `id`

namevar

Data type: `String`

Unique identifier of the Kerberos service object.

### `powerstore_file_ldap`

rubocop:disable Style/StringLiterals

#### Properties

The following properties are available in the `powerstore_file_ldap` type.

##### `add_addresses`

Data type: `Optional[Array[String]]`

IP addresses to add to the current server IP addresses list. The addresses may be IPv4 or IPv6. Error occurs if an IP address already exists in the addresses list. Cannot be combined with addresses.

##### `addresses`

Data type: `Optional[Array[String]]`

The list of LDAP server IP addresses. The addresses may be IPv4 or IPv6.

##### `authentication_type`

Data type: `Optional[Enum['Anonymous','Simple','Kerberos']]`

Authentication type for the LDAP server.* Anonymous - Anonymous authentication means no authentication occurs and the NAS Server uses an anonymous login to access the LDAP-based directory server.* Simple - Simple authentication means the NAS Server must provide a bind distinguished name and password to access the LDAP-based directory server.* Kerberos - Kerberos authentication means the NAS Server uses a KDC to confirm the identity when accessing the Active Directory.

##### `authentication_type_l10n`

Data type: `Optional[String]`

Localized message string corresponding to authentication_type

##### `base_dn`

Data type: `Optional[String[3,255]]`

Name of the LDAP base DN. Base Distinguished Name (BDN) of the root of the LDAP directory tree. The appliance uses the DN to bind to the LDAP service and locate in the LDAP directory tree to begin a search for information.  The base DN can be expressed as a fully-qualified domain name or in X.509 format by using the attribute dc=. For example, if the fully-qualified domain name is mycompany.com, the base DN is expressed as dc=mycompany,dc=com.

##### `bind_dn`

Data type: `Optional[String[0,1023]]`

Bind Distinguished Name (DN) to be used when binding.

##### `bind_password`

Data type: `Optional[String[0,1023]]`

The associated password to be used when binding to the server.

##### `ensure`

Data type: `Enum['present', 'absent']`

Whether this resource should be present or absent on the target system.

Default value: `present`

##### `is_certificate_uploaded`

Data type: `Optional[Boolean]`

Indicates whether an LDAP certificate file has been uploaded.

##### `is_config_file_uploaded`

Data type: `Optional[Boolean]`

Indicates whether an LDAP configuration file has been uploaded.

##### `is_smb_account_used`

Data type: `Optional[Boolean]`

Indicates whether SMB authentication is used to authenticate to the LDAP server. Values are:     * true - Indicates that the SMB settings are used for Kerberos authentication.    * false - Indicates that Kerberos uses its own settings.

##### `is_verify_server_certificate`

Data type: `Optional[Boolean]`

Indicates whether Certification Authority certificate is used to verify the LDAP server certificate for secure SSL connections. Values are: * true - verifies LDAP server's certificate. * false - doesn't verify LDAP server's certificate.

##### `nas_server_id`

Data type: `Optional[String]`

Unique identifier of the associated NAS Server instance that will use this LDAP object. Only one LDAP object per NAS Server is supported.

##### `password`

Data type: `Optional[String[0,1023]]`

The associated password for Kerberos authentication.

##### `port_number`

Data type: `Optional[Integer[0,65536]]`

The TCP/IP port used by the NAS Server to connect to the LDAP servers. The default port number for LDAP is 389 and LDAPS is 636.

##### `principal`

Data type: `Optional[String[0,1023]]`

Specifies the principal name for Kerberos authentication.

##### `profile_dn`

Data type: `Optional[String[0,255]]`

For an iPlanet LDAP server, specifies the DN of the entry with the configuration profile.

##### `protocol`

Data type: `Optional[Enum['LDAP','LDAPS']]`

Indicates whether the LDAP protocol uses SSL for secure network communication. SSL encrypts data over the network and provides message and server authentication.* LDAP - LDAP protocol without SSL.* LDAPS - (Default) LDAP protocol with SSL. When you enable LDAPS, make sure to specify the appropriate LDAPS port (usually port 636) and to upload an LDAPS trust certificate to the LDAP server.

##### `protocol_l10n`

Data type: `Optional[String]`

Localized message string corresponding to protocol

##### `realm`

Data type: `Optional[String[0,255]]`

Specifies the realm name for Kerberos authentication.

##### `remove_addresses`

Data type: `Optional[Array[String]]`

IP addresses to remove from the current server IP addresses list. The addresses may be IPv4 or IPv6. Error occurs if an IP address does not exist in the addresses_list. Cannot be combined with addresses.

##### `schema_type`

Data type: `Optional[Enum['RFC2307','Microsoft','Unknown']]`

LDAP server schema type.* RFC2307 - OpenLDAP/iPlanet schema.* Microsoft - Microsoft Identity Management for UNIX (IDMU/SFU) schema.* Unknown - Unknown protocol.

##### `schema_type_l10n`

Data type: `Optional[String]`

Localized message string corresponding to schema_type

#### Parameters

The following parameters are available in the `powerstore_file_ldap` type.

##### `id`

namevar

Data type: `String`

LDAP settings object Id.

### `powerstore_file_ndmp`

rubocop:disable Style/StringLiterals

#### Properties

The following properties are available in the `powerstore_file_ndmp` type.

##### `ensure`

Data type: `Enum['present', 'absent']`

Whether this resource should be present or absent on the target system.

Default value: `present`

##### `nas_server_id`

Data type: `Optional[String]`

Unique identifier of the NAS server to be configured with these NDMP settings.

##### `password`

Data type: `Optional[String]`

Password for the NDMP service user.

##### `user_name`

Data type: `Optional[String]`

User name for accessing the NDMP service.

#### Parameters

The following parameters are available in the `powerstore_file_ndmp` type.

##### `id`

namevar

Data type: `String`

Unique identifier of the NDMP service object.

### `powerstore_file_nis`

rubocop:disable Style/StringLiterals

#### Properties

The following properties are available in the `powerstore_file_nis` type.

##### `add_ip_addresses`

Data type: `Optional[Array[String]]`

IP addresses to add to the current list. The addresses may be IPv4 or IPv6. Error occurs if the IP address already exists. Cannot be combined with ip_addresses.

##### `domain`

Data type: `Optional[String[1,255]]`

Name of the NIS domain.

##### `ensure`

Data type: `Enum['present', 'absent']`

Whether this resource should be present or absent on the target system.

Default value: `present`

##### `ip_addresses`

Data type: `Optional[Array[String]]`

The list of NIS server IP addresses.

##### `nas_server_id`

Data type: `Optional[String]`

Unique identifier of the associated NAS Server instance that uses this NIS Service object.  Only one NIS Service per NAS Server is supported.

##### `remove_ip_addresses`

Data type: `Optional[Array[String]]`

IP addresses to remove from the current list. The addresses may be IPv4 or IPv6. Error occurs if the IP address is not present. Cannot be combined with ip_addresses.

#### Parameters

The following parameters are available in the `powerstore_file_nis` type.

##### `id`

namevar

Data type: `String`

Unique identifier of the NIS object.

### `powerstore_file_system`

rubocop:disable Style/StringLiterals

#### Properties

The following properties are available in the `powerstore_file_system` type.

##### `access_policy`

Data type: `Optional[Enum['Native','UNIX','Windows']]`

File system security access policies. Each file system uses its access policy to determine how to reconcile the differences between NFS and SMB access control. Selecting an access policy determines which mechanism is used to enforce file security on the particular file system. * Native - Native Security. * UNIX - UNIX Security. * Windows - Windows Security.

##### `access_policy_l10n`

Data type: `Optional[String]`

Localized message string corresponding to access_policy

##### `access_type`

Data type: `Optional[Enum['Snapshot','Protocol']]`

Indicates whether the snapshot directory or protocol access is granted to the file system snapshot.* Snapshot- Snapshot access is via the .snapshot folder in the file system.* Protocol - Protocol access is via normal file shares. Protocol access is not provided by default - the NFS and/or SMB share must be created explicitly for the snapshot.

##### `access_type_l10n`

Data type: `Optional[String]`

Localized message string corresponding to access_type

##### `creation_timestamp`

Data type: `Optional[String]`

Time, in seconds, when the snapshot was created.

##### `creator_type`

Data type: `Optional[Enum['Scheduler','User']]`

Enumeration of possible snapshot creator types. * Scheduler - Created by a snapshot schedule.* User - Created by a user.* External_VSS - Created by Windows Volume Shadow Copy Service (VSS) to obtain an application consistent snapshot.* External_NDMP - Created by an NDMP backup operation.* External_Restore - Created as a backup snapshot before a snapshot restore.* External_Replication_Manager - Created by Replication Manager.* Snap_CLI - Created inband by SnapCLI.* AppSync - Created by AppSync.

##### `creator_type_l10n`

Data type: `Optional[String]`

Localized message string corresponding to creator_type

##### `default_hard_limit`

Data type: `Optional[Integer[0,9223372036854775807]]`

Default hard limit of user quotas and tree quotas (bytes). The hard limit value is always rounded up to match the file system's physical block size.(0 means 'No limitation'. This value can be used to compute the amount of space consumed without limiting the space).

##### `default_soft_limit`

Data type: `Optional[Integer[0,9223372036854775807]]`

Default soft limit of user quotas and tree quotas (bytes). Value is always rounded up to match the file system's physical block size.(0 means 'No limitation'.)

##### `description`

Data type: `Optional[String[0,255]]`

File system description. (255 UTF-8 characters).

##### `ensure`

Data type: `Enum['present', 'absent']`

Whether this resource should be present or absent on the target system.

Default value: `present`

##### `expiration_timestamp`

Data type: `Optional[String]`

Time when the snapshot will expire. Use 1970-01-01T00:00:00.000Z to set expiration timestamp to null.

##### `filesystem_type`

Data type: `Optional[Enum['Primary','Snapshot']]`

* Primary - Normal file system or clone.* Snapshot - Snapshot of a file system.

##### `filesystem_type_l10n`

Data type: `Optional[String]`

Localized message string corresponding to filesystem_type

##### `folder_rename_policy`

Data type: `Optional[Enum['All_Allowed','SMB_Forbidden','All_Forbidden']]`

File system folder rename policies for the file system with multiprotocol access enabled. These policies control whether the directory can be renamed from NFS or SMB clients when at least one file is opened in the directory, or in one of its child directories. * All_Allowed - All protocols are allowed to rename directories without any restrictions. * SMB_Forbidden - A directory rename from the SMB protocol will be denied if at least one file is opened in the directory or in one of its child directories. * All_Forbidden - Any directory rename request will be denied regardless of the protocol used, if at least one file is opened in the directory or in one of its child directories.

##### `folder_rename_policy_l10n`

Data type: `Optional[String]`

Localized message string corresponding to folder_rename_policy

##### `grace_period`

Data type: `Optional[Integer[-1,2147483647]]`

Grace period of soft limits (seconds): -1: default: Infinite grace (Windows policy).  0: Use system default of 1 week. positive: Grace period after which the soft limit is treated as a hard limit (seconds).

##### `id`

Data type: `Optional[String]`

File system id.

##### `is_async_m_time_enabled`

Data type: `Optional[Boolean]`

Indicates whether asynchronous MTIME is enabled on the file system or protocol snaps that are mounted writeable. Values are:* true - Asynchronous MTIME is enabled on the file system.* false - Asynchronous MTIME is disabled on the file system.

##### `is_modified`

Data type: `Optional[Boolean]`

Indicates whether the snapshot may have changed since it was created. Values are:true - Snapshot is or was shared with read/write access.false - Snapshot was never shared.        

##### `is_quota_enabled`

Data type: `Optional[Boolean]`

Indicates whether quota is enabled. Quotas are not supported for read-only file systems. Default value for the grace period is set to infinite=-1 to match Windows' quota policyValues are:* true - Start tracking usages for all users on a file system or a quota tree, and user quota limits will be enforced.* false - Stop tracking usages for all users on a file system or a quota tree, and user quota limits will not be enforced.

##### `is_smb_no_notify_enabled`

Data type: `Optional[Boolean]`

Indicates whether notifications of changes to directory file structure are enabled.* true - Change directory notifications are enabled.* false - Change directory notifications are disabled.                      

##### `is_smb_notify_on_access_enabled`

Data type: `Optional[Boolean]`

Indicates whether file access notifications are enabled on the file system. Values are:* true - File access notifications are enabled on the file system.* false - File access notifications are disabled on the file system.

##### `is_smb_notify_on_write_enabled`

Data type: `Optional[Boolean]`

Indicates whether file writes notifications are enabled on the file system. Values are:* true - File writes notifications are enabled on the file system.* false - File writes notifications are disabled on the file system.

##### `is_smb_op_locks_enabled`

Data type: `Optional[Boolean]`

Indicates whether opportunistic file locking is enabled on the file system. Values are:* true - Opportunistic file locking is enabled on the file system.* false - Opportunistic file locking is disabled on the file system.

##### `is_smb_sync_writes_enabled`

Data type: `Optional[Boolean]`

Indicates whether the synchronous writes option is enabled on the file system. Values are:* true - Synchronous writes option is enabled on the file system.* false - Synchronous writes option is disabled on the file system.

##### `last_refresh_timestamp`

Data type: `Optional[String]`

Time, in seconds, when the snapshot was last refreshed.

##### `last_writable_timestamp`

Data type: `Optional[String]`

If not mounted, and was previously mounted, the time (in seconds) of last mount. If never mounted, the value will be zero.

##### `locking_policy`

Data type: `Optional[Enum['Advisory','Mandatory']]`

File system locking policies. These policy choices control whether the NFSv4 range locks are honored. Because NFSv3 is advisory by design, this policy specifies that the NFSv4 locking feature behaves like NFSv3 (advisory mode), for backward compatiblity with applications expecting an advisory locking scheme.   * Advisory - No lock checking for NFS and honor SMB lock range only for SMB. * Mandatory - Honor SMB and NFS lock range.

##### `locking_policy_l10n`

Data type: `Optional[String]`

Localized message string corresponding to locking_policy

##### `nas_server_id`

Data type: `Optional[String]`

Id of the NAS Server on which the file system is mounted.

##### `parent_id`

Data type: `Optional[String]`

The object id of the parent of this file system (only applies to clones and snapshots). If the parent of a clone has been deleted the object_id will contain null.

##### `protection_policy_id`

Data type: `Optional[String]`

Id of the protection policy applied to the file system.

##### `size_total`

Data type: `Optional[Integer[3221225472,281474976710656]]`

Size that the file system presents to the host or end user. (Bytes)

##### `size_used`

Data type: `Optional[Integer[0,9223372036854775807]]`

Size used, in bytes, for the data and metadata of the file system.

##### `smb_notify_on_change_dir_depth`

Data type: `Optional[Integer[1,512]]`

Lowest directory level to which the enabled notifications apply, if any.

#### Parameters

The following parameters are available in the `powerstore_file_system` type.

##### `name`

namevar

Data type: `String[1,255]`

Name of the file system. (255 UTF-8 characters).

### `powerstore_file_tree_quota`

rubocop:disable Style/StringLiterals

#### Properties

The following properties are available in the `powerstore_file_tree_quota` type.

##### `description`

Data type: `Optional[String]`

Description of the tree quota.

##### `ensure`

Data type: `Enum['present', 'absent']`

Whether this resource should be present or absent on the target system.

Default value: `present`

##### `file_system_id`

Data type: `Optional[String]`

Unique identifier of the associated file system.

##### `hard_limit`

Data type: `Optional[Integer[0,9223372036854775807]]`

Hard limit of the tree quota, in bytes. No hard limit when set to 0. This value can be used to compute amount of space that is consumed without limiting the space. Value is always rounded up to match the physical block size of the filesystem.

##### `is_user_quotas_enforced`

Data type: `Optional[Boolean]`

Whether the quota must be enabled for all users, and whether user quota limits, if any, are enforced.Values are:- true - start tracking usage for all users on the quota tree, and enforce user quota limits.- false - stop tracking usage for all users on the quota tree, and do not enforce user quota limits.

##### `path`

Data type: `Optional[String]`

Path relative to the root of the associated filesystem.

##### `remaining_grace_period`

Data type: `Optional[Integer[0,9223372036854775807]]`

Remaining grace period, in seconds, after the soft limit is exceeded:- 0 - Grace period has already expired- -1 - No grace period in-progress, or infinite grace period setThe grace period of user quotas is set in the file system quota config.

##### `size_used`

Data type: `Optional[Integer[0,9223372036854775807]]`

Size already used on the tree quota, in bytes.

##### `soft_limit`

Data type: `Optional[Integer[0,9223372036854775807]]`

Soft limit of the tree quota, in bytes. No hard limit when set to 0. Value is always rounded up to match the physical block size of the filesystem.

##### `state`

Data type: `Optional[Enum['Ok','Soft_Exceeded','Soft_Exceeded_And_Expired','Hard_Reached']]`

State of the user quota or tree quota record period.* OK - No quota limits are exceeded.* Soft_Exceeded - Soft limit is exceeded, and grace period is not expired.* Soft_Exceeded_And_Expired - Soft limit is exceeded, and grace period is expired.* Hard_Reached - Hard limit is reached.

##### `state_l10n`

Data type: `Optional[String]`

Localized message string corresponding to state

#### Parameters

The following parameters are available in the `powerstore_file_tree_quota` type.

##### `id`

namevar

Data type: `String`

Unique identifier of the tree quota.

### `powerstore_file_virus_checker`

rubocop:disable Style/StringLiterals

#### Properties

The following properties are available in the `powerstore_file_virus_checker` type.

##### `ensure`

Data type: `Enum['present', 'absent']`

Whether this resource should be present or absent on the target system.

Default value: `present`

##### `is_config_file_uploaded`

Data type: `Optional[Boolean]`

Indicates whether a virus checker configuration file has been uploaded.

##### `is_enabled`

Data type: `Optional[Boolean]`

Indicates whether the anti-virus service is enabled on this NAS server. Value are:- true - Anti-virus service is enabled. Each file created or modified by an SMB client is scanned by the third-party anti-virus servers. If a virus is detected, the access to the file system is denied. If third-party anti-virus servers are not available, according the policy, the access to the file systems is denied to prevent potential viruses propagation.- false - Anti-virus service is disabled. File systems of the NAS servers are available for access without virus checking.

##### `nas_server_id`

Data type: `Optional[String]`

Unique identifier of an associated NAS Server instance that uses this virus checker configuration. Only one virus checker configuration per NAS Server is supported.

#### Parameters

The following parameters are available in the `powerstore_file_virus_checker` type.

##### `id`

namevar

Data type: `String`

Unique identifier of the virus checker instance.

### `powerstore_host`

rubocop:disable Style/StringLiterals

#### Properties

The following properties are available in the `powerstore_host` type.

##### `add_initiators`

Data type: `Optional[Array[Struct[{Optional[chap_mutual_password] => Optional[String[12,64]], Optional[chap_mutual_username] => Optional[String[1,64]], Optional[chap_single_password] => Optional[String[12,64]], Optional[chap_single_username] => Optional[String[1,64]], port_name => Optional[String], port_type => Optional[Enum['iSCSI','FC']], }]]]`

The list of initiators to be added. CHAP username and password are optional.

##### `description`

Data type: `Optional[String[0,256]]`

An optional description for the host. The description should not be more than 256 UTF-8 characters long and should not have any unprintable characters.

##### `ensure`

Data type: `Enum['present', 'absent']`

Whether this resource should be present or absent on the target system.

Default value: `present`

##### `host_group_id`

Data type: `Optional[String]`

Associated host group, if host is part of host group.

##### `host_initiators`

Data type: `Optional[Array[Struct[{Optional[active_sessions] => Optional[Array[Struct[{Optional[appliance_id] => Optional[String], Optional[bond_id] => Optional[String], Optional[eth_port_id] => Optional[String], Optional[fc_port_id] => Optional[String], Optional[node_id] => Optional[String], Optional[port_name] => Optional[String], Optional[veth_id] => Optional[String], }]]], Optional[chap_mutual_username] => Optional[String[1,64]], Optional[chap_single_username] => Optional[String[1,64]], Optional[port_name] => Optional[String], Optional[port_type] => Optional[Enum['iSCSI','FC']], Optional[port_type_l10n] => Optional[String], }]]]`

Filtering on the fields of this embedded resource is not supported.

##### `id`

Data type: `Optional[String]`

Unique id of the host.

##### `initiators`

Data type: `Optional[Array[Struct[{Optional[chap_mutual_password] => Optional[String[12,64]], Optional[chap_mutual_username] => Optional[String[1,64]], Optional[chap_single_password] => Optional[String[12,64]], Optional[chap_single_username] => Optional[String[1,64]], port_name => Optional[String], port_type => Optional[Enum['iSCSI','FC']], }]]]`

""

##### `modify_initiators`

Data type: `Optional[Array[Struct[{Optional[chap_mutual_password] => Optional[String[12,64]], Optional[chap_mutual_username] => Optional[String[1,64]], Optional[chap_single_password] => Optional[String[12,64]], Optional[chap_single_username] => Optional[String[1,64]], Optional[port_name] => Optional[String], }]]]`

Update list of existing initiators, identified by port_name, with new CHAP usernames and/or passwords.

##### `os_type`

Data type: `Optional[Enum['Windows','Linux','ESXi','AIX','HP-UX','Solaris']]`

Operating system of the host.

##### `os_type_l10n`

Data type: `Optional[String]`

Localized message string corresponding to os_type

##### `remove_initiators`

Data type: `Optional[Array[String]]`

The list of initiator port_names to be removed.

#### Parameters

The following parameters are available in the `powerstore_host` type.

##### `name`

namevar

Data type: `String[0,128]`

The host name. The name should not be more than 128 UTF-8 characters long and should not have any unprintable
characters.

### `powerstore_host_group`

rubocop:disable Style/StringLiterals

#### Properties

The following properties are available in the `powerstore_host_group` type.

##### `add_host_ids`

Data type: `Optional[Array[String]]`

List of hosts to be added to host group. The operation fails if the host(s) to be added are attached to volume.

##### `description`

Data type: `Optional[String[0,256]]`

An optional description for the host group. The description should not have any unprintable characters.

##### `ensure`

Data type: `Enum['present', 'absent']`

Whether this resource should be present or absent on the target system.

Default value: `present`

##### `host_ids`

Data type: `Optional[Array[String]]`

""

##### `id`

Data type: `Optional[String]`

Unique id of the host group.

##### `remove_host_ids`

Data type: `Optional[Array[String]]`

List of hosts to be removed from the host group. The operation fails if host group is attached to volume.

#### Parameters

The following parameters are available in the `powerstore_host_group` type.

##### `name`

namevar

Data type: `String[0,128]`

The host group name. The name should not be more than 128 UTF-8 characters long and should not have any unprintable
characters.

### `powerstore_import_host_system`

rubocop:disable Style/StringLiterals

#### Properties

The following properties are available in the `powerstore_import_host_system` type.

##### `agent_address`

Data type: `Optional[String]`

Hostname or IPv4 address of the import host system.

##### `agent_api_version`

Data type: `Optional[String]`

API version of the import host system.

##### `agent_port`

Data type: `Optional[Integer[0,65535]]`

TCP port of the import host system.

##### `agent_status`

Data type: `Optional[Enum['Unknown','Running','Conflict_Detected','Version_Unsupported']]`

Status of the import host system. Valid values are: * Unknown - Agent status is unknown. * Running - Agent is up and running. * Conflict_Detected - Agent detected that there are multiple MPIOs installed on the host and Destination Powerstore MPIO is not able to claim destination device as some other MPIO has already claimed it. * Version_Unsupported - Agent detected that the OS or any other dependent component does not satisfy the version as expected by the it.

##### `agent_status_l10n`

Data type: `Optional[String]`

Localized message string corresponding to agent_status

##### `agent_type`

Data type: `Optional[Enum['EQL','Native_MPIO','Power_Path','Unknown']]`

Type of import host system. Valid values are: * EQL - EQL MPIO.  * Native_MPIO - Native MPIO.  * Power_Path - POWER PATH MPIO.  * Unknown - Type of host agent is unknown to PowerStore.

##### `agent_type_l10n`

Data type: `Optional[String]`

Localized message string corresponding to agent_type

##### `agent_version`

Data type: `Optional[String]`

Version of the import host system.

##### `chap_mutual_password`

Data type: `Optional[String]`

Password for mutual CHAP authentication. This password is required when the cluster is using mutual authentication CHAP mode.

##### `chap_mutual_username`

Data type: `Optional[String]`

Username for mutual CHAP authentication. This username is required when the cluster is using mutual authentication CHAP mode.

##### `chap_single_password`

Data type: `Optional[String]`

Password for single CHAP authentication. This password is required when the cluster is using single authentication CHAP mode.

##### `chap_single_username`

Data type: `Optional[String]`

Username for single CHAP authentication. This username is required when the cluster is using single authentication CHAP mode.

##### `ensure`

Data type: `Enum['present', 'absent']`

Whether this resource should be present or absent on the target system.

Default value: `present`

##### `last_update_time`

Data type: `Optional[String]`

Time when the import host system was last updated.

##### `os_type`

Data type: `Optional[Enum['Windows','Linux','ESXi','Unknown']]`

Operating system of the import host system. Valid values are: * Windows - Windows.  * Linux - Linux.  * ESXi - ESXi.  * Unknown - Operating system of the host system is unknown to PowerStore.

##### `os_type_l10n`

Data type: `Optional[String]`

Localized message string corresponding to os_type

##### `os_version`

Data type: `Optional[String]`

Operating system version of the import host system.

##### `password`

Data type: `Optional[String]`

Password for the specified username.

##### `user_name`

Data type: `Optional[String]`

Username for the import host system.

#### Parameters

The following parameters are available in the `powerstore_import_host_system` type.

##### `id`

namevar

Data type: `String`

Unique identifier of the import host system

### `powerstore_import_session`

rubocop:disable Style/StringLiterals

#### Properties

The following properties are available in the `powerstore_import_session` type.

##### `automatic_cutover`

Data type: `Optional[Boolean]`

Indicates whether the import session cutover is manual (true) or automatic (false).

##### `average_transfer_rate`

Data type: `Optional[Integer[0,9223372036854775807]]`

Average transfer rate of a data import operation in bytes/sec over the whole copy period. Before and after the import is in the Copy_In_Progress state, this value is null.

##### `current_transfer_rate`

Data type: `Optional[Integer[0,9223372036854775807]]`

Current transfer rate of a data import operation in bytes/sec. Before and after the import is in the Copy_In_Progress state, this value is null.

##### `description`

Data type: `Optional[String[0,128]]`

Description of the import session. The name can contain a maximum of 128 unicode characters. It cannot contain unprintable characters.

##### `destination_resource_id`

Data type: `Optional[String]`

Unique identifier of the destination volume or volume group created as part of the import process.

##### `destination_resource_type`

Data type: `Optional[Enum['volume','volume_group']]`

Storage resource type of the import destination. Values are: * volume - The destination resource of the import session is a volume. * volume_group - The destination resource of the import session is a volume group.

##### `destination_resource_type_l10n`

Data type: `Optional[String]`

Localized message string corresponding to destination_resource_type

##### `ensure`

Data type: `Enum['present', 'absent']`

Whether this resource should be present or absent on the target system.

Default value: `present`

##### `error`

Data type: `Optional[Struct[{Optional[arguments] => Optional[Array[String]], Optional[code] => Optional[String], Optional[message_l10n] => Optional[String], }]]`

Filtering on the fields of this embedded resource is not supported.

##### `estimated_completion_timestamp`

Data type: `Optional[String]`

When the import is in the Copy_In_Progress state, this value indicates the estimated time at which the data copy will complete. Before the import is in the Copy_In_Progress state, the value is null.

##### `id`

Data type: `Optional[String]`

Unique identifier of the import session

##### `last_update_timestamp`

Data type: `Optional[String]`

Date and time when was the import was last updated. This value is updated each time the import job updates.

##### `parent_session_id`

Data type: `Optional[String]`

For a volume that is part of a consistency group import, this value is the session identifier of the import session. For an individual volume import, this value is null.

##### `progress_percentage`

Data type: `Optional[Integer[0,2147483647]]`

When the import is in the Copy_In_Progress state, this value indicates the completion percent for the import. Before the import is in the Copy_In_Progress state, this value is 0. After the cutover or if there is a failure, this value is null.

##### `protection_policy_id`

Data type: `Optional[String]`

Unique identifier of the protection policy that will be applied to an imported volume or consistency group after the import completes. Only snapshot policies are supported in an import. Once the import completes, you can add a replication policy. If you try to import a replication policy, the import job will fail.

##### `remote_system_id`

Data type: `Optional[String]`

Unique identifier of the storage system that contains the source volume or consistency group to be imported. You can query the source volume or consistency group object to get the identifier of the source system that the volume or consistency group are part of. Alternatively, you can use the remote_system object to get this information.

##### `scheduled_timestamp`

Data type: `Optional[String]`

Date and time at which the import session is scheduled to start. The date time is specified in ISO 8601 format with the time expressed in UTC format.

##### `source_resource_id`

Data type: `Optional[String]`

Unique identifier of the volume or consistency group to be imported. Refer to the following objects for more information: * Storage Center : import_storage_center_volume, import_storage_center_consistency_group * VNX : import_vnx_volume, import_vnx_consistency_group * PS Series : import_psgroup_volume * Unity : import_unity_volume, import_unity_consistency_group

##### `state`

Data type: `Optional[Enum['Scheduled','Paused','Queued','In_Progress','Mirror_Enabled','Ready_To_Start_Copy','Copy_In_Progress','Ready_For_Cutover','Cutover_In_Progress','Import_Completed','Cancelled','Failed','Cancel_Failed','Cancel_In_Progress','Cleanup_In_Progress','Cleanup_Failed','Invalid','Cleanup_Required','Import_Completed_With_Errors','Import_Cutover_Incomplete']]`

Import session states* Scheduled : Indicates that a user scheduled the import to run at a later time. The import remains in this state and waits until the schedule expires.* Paused : Indicates that the data copy between the source and destination volumes is paused.* Queued : Indicates that all imports are queued and run in a First In First Out (FIFO) order. This occurs when there are more active import sessions than supported.* In_Progress : Indicates that a queued import session is now in progress.* Mirror_Enabled : Indicates that an import session has completed setting up the entities required to import data from the source resource.* Ready_To_Start_Copy : Indicates that an import session is ready to start the data copy operation from the source resource.* Copy_In_Progress : Indicates that the data copy between the source and destination storage systems has started. The data copy runs as a background job and updates the import session percentage complete and estimated time left for the copy. Host IOs are pointed to PowerStore in this state. The import process keeps the source and destination volumes or consistency groups volume in sync by doing IO forwarding.* Ready_For_Cutover : Indicates that you can commit the import. The import process moves to this state after it successfully copies data from the source volume or consistency group.* Cutover_In_Progress : Indicates that the cutover of volumes that are part of a consistency group is in progress.* Import_Completed : Indicates that all operations completed successfully for a given import after a commit. In this state, the source volume is no longer mapped to the host and all stale paths are cleaned up.* Cancelled : Indicates that a user forcefully cancelled the import.* Failed : Indicates that there was an error during import. The appropriate error message  is returned in the error_response object.* Cancel_Failed : Indicates that an attempt to cancel the import of a volume failed in a consistency group import.* Cancel_In_Progress : Indicates that a cancel is in progress.* Cleanup_In_Progress : Indicates that the import of one or more volumes in a consistency group failed. When this occurs, you must roll back the import of the other volumes of the consistency group by executing a Cancel operation on each volume.* Cleanup_Failed : Indicates that there was an error while cleaning up the consistency group.* Invalid : Indicates that an import session is in an unexpected state.* Cleanup_Required : Indicates that there was an error while cleaning up the import or consistency group that requires user intervention to bring back host applications.* Import_Completed_With_Errors : Indicates that there was a mirror failure for one or more members while committing a consistency group due to which members were partially committed.The failed members were cancelled.* Import_Cutover_Incomplete : Indicates that one or more members  couldn't be committed successfully resulting in partial commit of the consistency group. Commit should be tried again on the consistency group.

##### `state_l10n`

Data type: `Optional[String]`

Localized message string corresponding to state

##### `volume_group_id`

Data type: `Optional[String]`

Unique identifier of the volume group to which the imported volume will belong, if any.

#### Parameters

The following parameters are available in the `powerstore_import_session` type.

##### `name`

namevar

Data type: `String[0,128]`

Name of the import session. The name must be unique in the PowerStore cluster and can contain a maximum of 128 unicode
characters. It cannot contain special HTTP characters, unprintable characters, or white space.

### `powerstore_local_user`

rubocop:disable Style/StringLiterals

#### Properties

The following properties are available in the `powerstore_local_user` type.

##### `current_password`

Data type: `Optional[String]`

Current password of the local user. Any local user can change his own password by providing current_password along with the new password.

##### `ensure`

Data type: `Enum['present', 'absent']`

Whether this resource should be present or absent on the target system.

Default value: `present`

##### `id`

Data type: `Optional[String]`

Unique identifier of the local user account to be deleted.

##### `is_built_in`

Data type: `Optional[Boolean]`

Whether the user account is built-in or not.

##### `is_default_password`

Data type: `Optional[Boolean]`

Whether the user account has a default password or not. Only applies to default user accounts.

##### `is_locked`

Data type: `Optional[Boolean]`

Lock or unlock the local user account. Local user with administration/security administration role can lock or unlock any other local user account. You cannot lock an account you are currently logged-in to.

##### `password`

Data type: `Optional[String]`

Password for the new local user account to be created. The password value can be 8 to 40 UTF-8 characters long, and include as a minimum one uppercase character, one lowercase character, one numeric character, and one special character from this list  [!,@

##### `role_id`

Data type: `Optional[String]`

The unique identifier of the role to which the new local user will be mapped. Where role_id '1' is for Administrator, '2' is for Storage Administrator, '3' is for Operator, '4' is for VM Administrator and '5' is for Security Administrator roles.

#### Parameters

The following parameters are available in the `powerstore_local_user` type.

##### `name`

namevar

Data type: `String`

Name of the new local user account to be created. The name value can be 1 to 64 UTF-8 characters long, and may only use
alphanumeric characters. Dot(.) is the only special character allowed.

### `powerstore_migration_session`

rubocop:disable Style/StringLiterals

#### Properties

The following properties are available in the `powerstore_migration_session` type.

##### `automatic_cutover`

Data type: `Optional[Boolean]`

Indicates whether the migration session cutover is manual or automatic. Default for virtual_volume resource type migrations is automatic, otherwise the default is manual.

##### `destination_appliance_id`

Data type: `Optional[String]`

Unique identifier of the destination appliance instance.

##### `ensure`

Data type: `Enum['present', 'absent']`

Whether this resource should be present or absent on the target system.

Default value: `present`

##### `family_id`

Data type: `Optional[String]`

Family identifier designating the storage resource or resources to migrate. For volume or virtual_volume migrations, the family is moved together because they share data among the primary object, snapshots, and clones. For volume_group migration, the family of each volume in the group is moved because it is a grouping of volumes.

##### `resource_type`

Data type: `Optional[Enum['volume','virtual_volume','volume_group']]`

Storage resource types eligible for migration.

#### Parameters

The following parameters are available in the `powerstore_migration_session` type.

##### `force`

Data type: `Optional[Boolean]`

Indicates whether all migration activities will be canceled before deleting the session.

##### `name`

namevar

Data type: `Optional[String]`

User-specified friendly name of the migration session instance. The name can contain a maximum of 32 Unicode characters.
It cannot contain unprintable characters, special HTTP characters, or whitespace.

### `powerstore_nas_server`

rubocop:disable Style/StringLiterals

#### Properties

The following properties are available in the `powerstore_nas_server` type.

##### `backup_i_pv4_interface_id`

Data type: `Optional[String]`

Unique identifier of the preferred IPv4 backup interface.

##### `backup_i_pv6_interface_id`

Data type: `Optional[String]`

Unique identifier of the preferred IPv6 backup interface.

##### `current_node_id`

Data type: `Optional[String]`

Unique identifier of the node on which the NAS server is running.

##### `current_preferred_i_pv4_interface_id`

Data type: `Optional[String]`

Unique identifier of the current active preferred IPv4 interface.

##### `current_preferred_i_pv6_interface_id`

Data type: `Optional[String]`

Unique identifier of the current active preferred IPv6 interface.

##### `current_unix_directory_service`

Data type: `Optional[Enum['None','NIS','LDAP','Local_Files','Local_Then_NIS','Local_Then_LDAP']]`

Define the Unix directory service used for looking up identity information for Unix such as UIDs, GIDs, net groups, and so on.

##### `current_unix_directory_service_l10n`

Data type: `Optional[String]`

Localized message string corresponding to current_unix_directory_service

##### `default_unix_user`

Data type: `Optional[String[0,63]]`

Default Unix user name used for granting access in case of Windows to Unix user mapping failure. When empty, access in such case is denied.

##### `default_windows_user`

Data type: `Optional[String[0,1023]]`

Default Windows user name used for granting access in case of Unix to Windows user mapping failure. When empty, access in such case is denied.

##### `description`

Data type: `Optional[String[0,255]]`

Description of the NAS server.

##### `ensure`

Data type: `Enum['present', 'absent']`

Whether this resource should be present or absent on the target system.

Default value: `present`

##### `id`

Data type: `Optional[String]`

Unique identifier of the NAS server.

##### `is_auto_user_mapping_enabled`

Data type: `Optional[Boolean]`

A Windows user must have a corresponding matching Unix user (uid) in order to connect.This attribute enables you to automatically generates this Unix user (uid), if that Windows user does not have any in the configured Unix directory service (UDS).In a pure SMB or non multi-protocol environment, this should be set to true.

##### `is_username_translation_enabled`

Data type: `Optional[Boolean]`

Enable the possibility to match a Windows account with an Unix account with different names.

##### `operational_status`

Data type: `Optional[Enum['Stopped','Starting','Started','Stopping','Failover','Degraded','Unknown']]`

NAS server operational status:* Stopped - NAS server is stopped.* Starting - NAS server is starting.* Started - NAS server is started.* Stopping - NAS server is stopping.* Failover - NAS server has failed over.* Degraded - NAS server is degraded (running without backup).* Unknown - NAS server state is unknown.

##### `operational_status_l10n`

Data type: `Optional[String]`

Localized message string corresponding to operational_status

##### `preferred_node_id`

Data type: `Optional[String]`

Unique identifier of the preferred node for the NAS server The initial value (on NAS server create) is taken from the current node.

##### `production_i_pv4_interface_id`

Data type: `Optional[String]`

Unique identifier of the preferred IPv4 production interface.

##### `production_i_pv6_interface_id`

Data type: `Optional[String]`

Unique identifier of the preferred IPv6 production interface.

#### Parameters

The following parameters are available in the `powerstore_nas_server` type.

##### `domain_password`

Data type: `Optional[String]`

Administrator password used to unjoin the associated SMB servers from the Active Directory (AD) domain before deleting
the NAS server. This parameter is required when the skipDomainUnjoin parameter is false or not set, and the NAS server
has SMB servers joined to an AD domain.

##### `domain_user_name`

Data type: `Optional[String]`

Administrator login used to unjoin the associated SMB servers from the Active Directory (AD) domain before deleting the
NAS server. This parameter is required when the skipDomainUnjoin parameter is false or not set, and the NAS server has
SMB servers joined to an AD domain.

##### `is_skip_domain_unjoin`

Data type: `Optional[Boolean]`

Indicates whether to keep the associated SMB servers joined to the Active Directory when the NAS server is deleted.
Values are:\n - true - Keep the associated SMB servers joined to the Active Directory when the NAS server is deleted. -
false - (Default) Try to unjoin the associated SMB servers from the Active Directory before deleting the NAS server.

##### `name`

namevar

Data type: `String[1,255]`

Name of the NAS server.

### `powerstore_nfs_export`

rubocop:disable Style/StringLiterals

#### Properties

The following properties are available in the `powerstore_nfs_export` type.

##### `add_no_access_hosts`

Data type: `Optional[Array[String]]`

Hosts to add to the no_access_host list. Hosts can be entered by Hostname, IP addresses (IPv4, IPv6, IPv4/PrefixLength, IPv6/PrefixLenght, or IPv4/subnetmask), or Netgroups prefixed with @. Error if the host already exists in the list. Cannot be combined with no_access_hosts.

##### `add_read_only_hosts`

Data type: `Optional[Array[String]]`

Hosts to add to the current read_only_hosts list. Hosts can be entered by Hostname, IP addresses (IPv4, IPv6, IPv4/PrefixLength, IPv6/PrefixLenght, or IPv4/subnetmask), or Netgroups prefixed with @. Error if the host already exists. Cannot combine with read_only_hosts.

##### `add_read_only_root_hosts`

Data type: `Optional[Array[String]]`

Hosts to add to the current read_only_root_hosts list. Hosts can be entered by Hostname, IP addresses (IPv4, IPv6, IPv4/PrefixLength, IPv6/PrefixLenght, or IPv4/subnetmask), or Netgroups prefixed with @. Error if the host already exists. Cannot combine with read_only_root_hosts.

##### `add_read_write_hosts`

Data type: `Optional[Array[String]]`

Hosts to add to the current read_write_hosts list. Hosts can be entered by Hostname, IP addresses (IPv4, IPv6, IPv4/PrefixLength, IPv6/PrefixLenght, or IPv4/subnetmask), or Netgroups prefixed with @. Error if Host is already exists. Cannot combine with read_write_hosts.

##### `add_read_write_root_hosts`

Data type: `Optional[Array[String]]`

Hosts to add to the current read_write_root_hosts list. Hosts can be entered by Hostname, IP addresses (IPv4, IPv6, IPv4/PrefixLength, IPv6/PrefixLenght, or IPv4/subnetmask), or Netgroups prefixed with @. Error if the host already exists. Cannot combine with read_write_root_hosts.

##### `anonymous_gid`

Data type: `Optional[Integer[-2147483648,2147483647]]`

Specifies the group ID of the anonymous account.

##### `anonymous_uid`

Data type: `Optional[Integer[-2147483648,2147483647]]`

Specifies the user ID of the anonymous account.

##### `default_access`

Data type: `Optional[Enum['No_Access','Read_Only','Read_Write','Root','Read_Only_Root']]`

Default access level for all hosts that can access the Export.* No_Access- Deny access to the Export for the hosts.* Read_Only- Allow read only access to the Export for the hosts.* Read_Write- Allow read write access to the Export for the hosts.* Root - Allow read write access to the Export for the hosts. Allow access to the Export for root user.* Read_Only_Root- Allow read only root access to the Export for the hosts.

##### `default_access_l10n`

Data type: `Optional[String]`

Localized message string corresponding to default_access

##### `description`

Data type: `Optional[String[0,511]]`

User defined NFS Export description.

##### `ensure`

Data type: `Enum['present', 'absent']`

Whether this resource should be present or absent on the target system.

Default value: `present`

##### `file_system_id`

Data type: `Optional[String]`

Unique identifier of the file system on which the NFS Export will be created.

##### `id`

Data type: `Optional[String]`

NFS Export object id.

##### `is_no_suid`

Data type: `Optional[Boolean]`

If set, do not allow access to set SUID. Otherwise, allow access.

##### `min_security`

Data type: `Optional[Enum['Sys','Kerberos','Kerberos_With_Integrity','Kerberos_With_Encryption']]`

NFS enforced security type for users accessing an NFS Export.* Sys - Allow the user to authenticate with any NFS security types: UNIX, Kerberos, Kerberos with integrity, or Kerberos with encryption.* Kerberos - Allow only Kerberos security for user authentication.* Kerberos_With_Integrity- Allow only Kerberos with integrity and Kerberos with encryption security for user authentication.* Kerberos_With_Encryption- Allow only Kerberos with encryption security for user authentication.

##### `min_security_l10n`

Data type: `Optional[String]`

Localized message string corresponding to min_security

##### `nfs_owner_username`

Data type: `Optional[String]`

(*Applies to NFS shares of VMware NFS storage resources.*) Default owner of the NFS Export associated with the datastore. Required if secure NFS enabled. For NFSv3 or NFSv4 without Kerberos, the default owner is root.

##### `no_access_hosts`

Data type: `Optional[Array[String]]`

Hosts with no access to the NFS export or its snapshots. Hosts can be entered by Hostname, IP addresses (IPv4, IPv6, IPv4/PrefixLength, IPv6/PrefixLenght, or IPv4/subnetmask), or Netgroups prefixed with @.

##### `path`

Data type: `Optional[String[1,1023]]`

Local path to export relative to the file system root directory. With NFS, each export of a file_system or file_snap must have a unique local path.Before you can create additional Exports within an NFS shared folder, you must create directories within it from a Linux/Unix host that is connected to the file system. After a directory has been created from a mounted host, you can create a corresponding Export and set access permissions accordingly.

##### `read_only_hosts`

Data type: `Optional[Array[String]]`

Hosts with read-only access to the NFS export and its snapshots. Hosts can be entered by Hostname, IP addresses (IPv4, IPv6, IPv4/PrefixLength, IPv6/PrefixLenght, or IPv4/subnetmask), or Netgroups prefixed with @.

##### `read_only_root_hosts`

Data type: `Optional[Array[String]]`

Hosts with read-only and ready-only for root user access to the NFS Export and its snapshots. Hosts can be entered by Hostname, IP addresses (IPv4, IPv6, IPv4/PrefixLength, IPv6/PrefixLenght, or IPv4/subnetmask), or Netgroups prefixed with @.

##### `read_write_hosts`

Data type: `Optional[Array[String]]`

Hosts with read and write access to the NFS export and its snapshots.Hosts can be entered by Hostname, IP addresses (IPv4, IPv6, IPv4/PrefixLength, IPv6/PrefixLenght, or IPv4/subnetmask), or Netgroups prefixed with @.

##### `read_write_root_hosts`

Data type: `Optional[Array[String]]`

Hosts with read and write and read and write for root user access to the NFS Export and its snapshots. Hosts can be entered by Hostname, IP addresses (IPv4, IPv6, IPv4/PrefixLength, IPv6/PrefixLenght, or IPv4/subnetmask), or Netgroups prefixed with @.

##### `remove_no_access_hosts`

Data type: `Optional[Array[String]]`

Hosts to remove from the current no_access_hosts list. Hosts can be entered by Hostname, IP addresses (IPv4, IPv6, IPv4/PrefixLength, IPv6/PrefixLenght, or IPv4/subnetmask), or Netgroups prefixed with @. Error if the host is not present. Cannot combine with no_access_hosts.

##### `remove_read_only_hosts`

Data type: `Optional[Array[String]]`

Hosts to remove from the current read_only_hosts list. Hosts can be entered by Hostname, IP addresses (IPv4, IPv6, IPv4/PrefixLength, IPv6/PrefixLenght, or IPv4/subnetmask), or Netgroups prefixed with @. Error if the host is not present. Cannot combine with read_only_hosts.

##### `remove_read_only_root_hosts`

Data type: `Optional[Array[String]]`

Hosts to remove from the current read_only_root_hosts list. Hosts can be entered by Hostname, IP addresses (IPv4, IPv6, IPv4/PrefixLength, IPv6/PrefixLenght, or IPv4/subnetmask), or Netgroups prefixed with @. Error if The host is not present. Cannot combine with read_only_root_hosts.

##### `remove_read_write_hosts`

Data type: `Optional[Array[String]]`

Hosts to remove from the current read_write_hosts list. Hosts can be entered by Hostname, IP addresses (IPv4, IPv6, IPv4/PrefixLength, IPv6/PrefixLenght, or IPv4/subnetmask), or Netgroups prefixed with @. Error if Host is not present. Cannot combine with read_write_hosts.

##### `remove_read_write_root_hosts`

Data type: `Optional[Array[String]]`

Hosts to remove from the current read_write_root_hosts list. Hosts can be entered by Hostname, IP addresses (IPv4, IPv6, IPv4/PrefixLength, IPv6/PrefixLenght, or IPv4/subnetmask), or Netgroups prefixed with @. Error if the host is not present. Cannot combine with read_write_root_hosts.

#### Parameters

The following parameters are available in the `powerstore_nfs_export` type.

##### `name`

namevar

Data type: `String[1,80]`

NFS Export name.

### `powerstore_physical_switch`

rubocop:disable Style/StringLiterals

#### Properties

The following properties are available in the `powerstore_physical_switch` type.

##### `connections`

Data type: `Optional[Array[Struct[{address => Optional[String[1,255]], connect_method => Optional[Enum['SSH','SNMPv2c']], Optional[port] => Optional[Integer[0,65535]], Optional[snmp_community_string] => Optional[String[0,128]], Optional[ssh_password] => Optional[String[0,128]], Optional[username] => Optional[String[0,128]], }]]]`

Supported connections for a physical switch.

##### `ensure`

Data type: `Enum['present', 'absent']`

Whether this resource should be present or absent on the target system.

Default value: `present`

##### `id`

Data type: `Optional[String]`

Unique identifier of the physical switch settings.

##### `purpose`

Data type: `Optional[Enum['Data_and_Management','Management_Only']]`

Physical switch purpose in network. Possible purposes are:  * Data_and_Management - Physical switch for all data and management networks.  * Management_Only - Physical switch for management network only.

##### `purpose_l10n`

Data type: `Optional[String]`

Localized message string corresponding to purpose

#### Parameters

The following parameters are available in the `powerstore_physical_switch` type.

##### `name`

namevar

Data type: `String[1,128]`

Name of a physical switch.

### `powerstore_policy`

rubocop:disable Style/StringLiterals

#### Properties

The following properties are available in the `powerstore_policy` type.

##### `add_replication_rule_ids`

Data type: `Optional[Array[String]]`

Replication rule identifiers to be added to this policy.

##### `add_snapshot_rule_ids`

Data type: `Optional[Array[String]]`

Snapshot rule identifiers to be added to this policy.

##### `description`

Data type: `Optional[String]`

Policy description.

##### `ensure`

Data type: `Enum['present', 'absent']`

Whether this resource should be present or absent on the target system.

Default value: `present`

##### `id`

Data type: `Optional[String]`

Unique identifier of the protection policy to be deleted.

##### `is_replica`

Data type: `Optional[Boolean]`

Indicates whether this is a replica policy, which is applied to replication destination storage resources. A policy of this type is restricted from many operations.

##### `remove_replication_rule_ids`

Data type: `Optional[Array[String]]`

Replication rule identifiers to be removed from this policy.

##### `remove_snapshot_rule_ids`

Data type: `Optional[Array[String]]`

Snapshot rule identifiers to be removed from this policy.

##### `replication_rule_ids`

Data type: `Optional[Array[String]]`

Replication rule identifiers included in this policy. At least one snapshot rule or one replication rule must be specified to create a protection policy.

##### `snapshot_rule_ids`

Data type: `Optional[Array[String]]`

Snapshot rule identifiers included in this policy. At least one snapshot rule or one replication rule must be specified to create a protection policy.

##### `type`

Data type: `Optional[Enum['Protection','Performance']]`

Supported policy types. * Protection - A protection policy, consisting of snapshot and replication rules. * Performance - A performance policy, consisting of performance rules.

##### `type_l10n`

Data type: `Optional[String]`

Localized message string corresponding to type

#### Parameters

The following parameters are available in the `powerstore_policy` type.

##### `name`

namevar

Data type: `String`

Policy name.

### `powerstore_remote_system`

rubocop:disable Style/StringLiterals

#### Properties

The following properties are available in the `powerstore_remote_system` type.

##### `data_connection_state`

Data type: `Optional[Enum['OK','Partial_Data_Connection_Loss','Complete_Data_Connection_Loss','Status_Not_Available','No_Targets_Discovered','Initializing']]`

Possible data connection states of a remote system:* OK                             - Normal conditions.* Partial_Data_Connection_Loss   - Partial data connection loss.* Complete_Data_Connection_Loss  - Complete data connection loss.* Status_Not_Available           - Status not available.* No_Targets_Discovered          - No targets discovered.* Initializing                   - Initializing

##### `data_connection_state_l10n`

Data type: `Optional[String]`

Localized message string corresponding to data_connection_state

##### `data_connections`

Data type: `Optional[Array[Struct[{Optional[initiator_address] => Optional[String], Optional[node_id] => Optional[String], Optional[status] => Optional[Enum['Login_Success','Authentication_Failure','Connection_Refused','Login_Timeout','Network_Error','General_Failure','Login_Success_No_Ports','Discovery_Success','Discovery_Authentication_Failure','Discovery_Connection_Refused','Discovery_Timeout']], Optional[status_l10n] => Optional[String], Optional[target_address] => Optional[String], }]]]`

List of data connections from each appliance in the local cluster to iSCSI target IP address. Filtering on the fields of this embedded resource is not supported.

##### `data_network_latency`

Data type: `Optional[Enum['Low','High']]`

Network latency choices for a remote system. Replication traffic can be tuned for higher efficiency depending on the expected network latency. This will only be used when the remote system type is PowerStore.* Low                      - Less than 5 milliseconds.* High                     - More than 5 milliseconds.

##### `data_network_latency_l10n`

Data type: `Optional[String]`

Localized message string corresponding to data_network_latency

##### `description`

Data type: `Optional[String[0,256]]`

User-specified description of the remote system.

##### `discovery_chap_mode`

Data type: `Optional[Enum['Disabled','Single','Mutual']]`

Challenge Handshake Authentication Protocol (CHAP) status:* Disabled     * Single       - Enabled for initiator authentication.* Mutual       - Enabled for initiator and target authentication.

##### `discovery_chap_mode_l10n`

Data type: `Optional[String]`

Localized message string corresponding to discovery_chap_mode

##### `ensure`

Data type: `Enum['present', 'absent']`

Whether this resource should be present or absent on the target system.

Default value: `present`

##### `id`

Data type: `Optional[String]`

Unique identifier of the remote system.


##### `import_chap_info`

Data type: `Optional[Struct[{Optional[initiator_discovery_password] => Optional[String], Optional[initiator_discovery_username] => Optional[String], Optional[initiator_session_password] => Optional[String], Optional[initiator_session_username] => Optional[String], Optional[target_discovery_password] => Optional[String], Optional[target_discovery_username] => Optional[String], Optional[target_session_password] => Optional[String], Optional[target_session_username] => Optional[String], }]]`

Information about the initiator, target session, or discovery CHAP secrets.

##### `iscsi_addresses`

Data type: `Optional[Array[String]]`

iSCSI target IP addresses for the data connection to the remote system. Must be specified when creating a non-PowerStore remote system.

##### `management_address`

Data type: `Optional[String]`

Management IP address of the remote system instance. Only IPv4 is supported for non-PowerStore remote systems.Both IPv4 and IPv6 are supported for PowerStore remote systems.

##### `remote_password`

Data type: `Optional[String]`

Password used to access the remote system. Used only for non-PowerStore systems.

##### `remote_username`

Data type: `Optional[String]`

Username used to access the remote system. Used only for non-PowerStore systems.

##### `serial_number`

Data type: `Optional[String]`

Serial number of the remote system instance.

##### `session_chap_mode`

Data type: `Optional[Enum['Disabled','Single','Mutual']]`

Challenge Handshake Authentication Protocol (CHAP) status:* Disabled     * Single       - Enabled for initiator authentication.* Mutual       - Enabled for initiator and target authentication.

##### `session_chap_mode_l10n`

Data type: `Optional[String]`

Localized message string corresponding to session_chap_mode

##### `state`

Data type: `Optional[Enum['OK','Update_Needed','Management_Connection_Lost']]`

Possible remote system states:    * OK                             - Normal conditions.* Update_Needed                  - Verify and update needed to handle network configuration changes on the systems.* Management_Connection_Lost     - Management connection to the remote peer is lost.

##### `state_l10n`

Data type: `Optional[String]`

Localized message string corresponding to state

##### `type`

Data type: `Optional[Enum['PowerStore','Unity','VNX','PS_Equallogic','Storage_Center','XtremIO']]`

Remote system connection type between the local system and the following remote systems:      * PowerStore               - PowerStore system* Unity                    - Unity import system* VNX                      - VNX import system* PS_Equallogic            - PS EqualLogic import system* Storage_Center           - Storage Center import system* XtremIO                  - XtremIO import system

##### `type_l10n`

Data type: `Optional[String]`

Localized message string corresponding to type

##### `user_name`

Data type: `Optional[String]`

Username used to access the non-PowerStore remote systems. 

#### Parameters

The following parameters are available in the `powerstore_remote_system` type.

##### `name`

namevar

Data type: `Optional[String[0,128]]`

User-specified name of the remote system. Used only for non-PowerStore systems. This value must contain 128 or fewer
printable Unicode characters.

### `powerstore_replication_rule`

rubocop:disable Style/StringLiterals

#### Properties

The following properties are available in the `powerstore_replication_rule` type.

##### `alert_threshold`

Data type: `Optional[Integer[0,1440]]`

Acceptable delay in minutes between the expected and actual replication sync intervals. The system generates an alert if the delay between the expected and actual sync exceeds this threshold. Alert threshold has the default value of one RPO in minutes.

##### `ensure`

Data type: `Enum['present', 'absent']`

Whether this resource should be present or absent on the target system.

Default value: `present`

##### `id`

Data type: `Optional[String]`

Unique identifier of the replication rule.

##### `is_replica`

Data type: `Optional[Boolean]`

Indicates if this is a replica of a rule or policy on a remote system that is the source of a replication session replicating a resource to the local system.

##### `remote_system_id`

Data type: `Optional[String]`

Unique identifier of the remote system to which this rule will replicate the associated resources.

##### `rpo`

Data type: `Optional[Enum['Five_Minutes','Fifteen_Minutes','Thirty_Minutes','One_Hour','Six_Hours','Twelve_Hours','One_Day']]`

Recovery point objective (RPO), which is the acceptable amount of data, measured in units of time, that may be lost in case of a failure.

##### `rpo_l10n`

Data type: `Optional[String]`

Localized message string corresponding to rpo

#### Parameters

The following parameters are available in the `powerstore_replication_rule` type.

##### `name`

namevar

Data type: `String`

Name of the replication rule.

### `powerstore_smb_share`

rubocop:disable Style/StringLiterals

#### Properties

The following properties are available in the `powerstore_smb_share` type.

##### `description`

Data type: `Optional[String[0,511]]`

SMB share description.

##### `ensure`

Data type: `Enum['present', 'absent']`

Whether this resource should be present or absent on the target system.

Default value: `present`

##### `file_system_id`

Data type: `Optional[String]`

Unique identifier of the file system on which the SMB Share will be created.

##### `id`

Data type: `Optional[String]`

SMB Share object id.

##### `is_abe_enabled`

Data type: `Optional[Boolean]`

Indicates whether Access-based Enumeration (ABE) is enabled. ABE filters the list of available files and folders on a server to include only those to which the requesting user has access. Values are:- true - ABE is enabled.- false - ABE is disabled.

##### `is_branch_cache_enabled`

Data type: `Optional[Boolean]`

Indicates whether BranchCace optimization is enabled. BranchCache optimization technology copies content from your main office or hosted cloud content servers and caches the content at branch office locations, allowing client computers at branch offices to access the content locally rather than over the WAN. Values are:- true - BranchCache is enabled.- false - BranchCache is disabled.

##### `is_continuous_availability_enabled`

Data type: `Optional[Boolean]`

Indicates whether continuous availability for Server Message Block (SMB) 3.0 is enabled for the SMB Share. Values are:- true - Continuous availability for SMB 3.0 is enabled for the SMB Share.- false - Continuous availability for SMB 3.0 is disabled for the SMB Share.

##### `is_encryption_enabled`

Data type: `Optional[Boolean]`

Indicates whether encryption for Server Message Block (SMB) 3.0 is enabled at the shared folder level. Values are:- true - encryption for SMB 3.0 is enabled.- false - encryption for SMB 3.0 is disabled.

##### `offline_availability`

Data type: `Optional[Enum['Manual','Documents','Programs','None']]`

Defines valid states of Offline Availability,   * Manual - Only specified files will be available offline.   * Documents - All files that users open will be available offline.   * Programs - Program will preferably run from the offline cache even when connected to the network. All files that users open will be available offline.   * None - Prevents clients from storing documents and programs in offline cache (default).

##### `offline_availability_l10n`

Data type: `Optional[String]`

Localized message string corresponding to offline_availability

##### `path`

Data type: `Optional[String]`

Local path to the file system or any existing sub-folder of the file system that is shared over the network.This path is relative to the NAS Server and must start with the filesystem's mountpoint path, which is the filesystem name.For example to share the top-level of a filesystem named svr1fs1, which is on the /svr1fs1 mountpoint of the NAS Server, use /svr1fs1 in the path parameter.SMB shares allow you to create multiple network shares for the same local path.

##### `umask`

Data type: `Optional[String]`

The default UNIX umask for new files created on the Share. If not specified the umask defaults to 022.

#### Parameters

The following parameters are available in the `powerstore_smb_share` type.

##### `name`

namevar

Data type: `String[1,80]`

SMB share name.

### `powerstore_snapshot_rule`

rubocop:disable Style/StringLiterals

#### Properties

The following properties are available in the `powerstore_snapshot_rule` type.

##### `days_of_week`

Data type: `Optional[Array[Enum['Monday','Tuesday','Wednesday','Thursday','Friday','Saturday','Sunday']]]`

Days of the week when the rule should be applied. Applies only for rules where the time_of_day parameter is set.

##### `days_of_week_l10n`

Data type: `Optional[Array[String]]`

Localized message array corresponding to days_of_week

##### `desired_retention`

Data type: `Optional[Integer[1,8760]]`

Desired snapshot retention period in hours. The system will retain snapshots for this time period, if space is available.

##### `ensure`

Data type: `Enum['present', 'absent']`

Whether this resource should be present or absent on the target system.

Default value: `present`

##### `id`

Data type: `Optional[String]`

Unique identifier of the snapshot rule.

##### `interval`

Data type: `Optional[Enum['Five_Minutes','Fifteen_Minutes','Thirty_Minutes','One_Hour','Two_Hours','Three_Hours','Four_Hours','Six_Hours','Eight_Hours','Twelve_Hours','One_Day']]`

Interval between snapshots. Either the interval parameter or the time_of_day parameter may be set. Setting one clears the other parameter.

##### `interval_l10n`

Data type: `Optional[String]`

Localized message string corresponding to interval

##### `is_replica`

Data type: `Optional[Boolean]`

Indicates if this is a replica of a rule or policy on a remote system that is the source of a replication session replicating a resource to the local system.

##### `time_of_day`

Data type: `Optional[String]`

Time of the day to take a daily snapshot, with format 'hh:mm' in 24 hour time format. Either the interval parameter or the time_of_day parameter may be set, but not both.

#### Parameters

The following parameters are available in the `powerstore_snapshot_rule` type.

##### `delete_snaps`

Data type: `Optional[Boolean]`

Specify whether all snapshots previously created by this rule should also be deleted when this rule is removed.

##### `name`

namevar

Data type: `String`

Snapshot rule name.

### `powerstore_storage_container`

rubocop:disable Style/StringLiterals

#### Properties

The following properties are available in the `powerstore_storage_container` type.

##### `ensure`

Data type: `Enum['present', 'absent']`

Whether this resource should be present or absent on the target system.

Default value: `present`

##### `id`

Data type: `Optional[String]`

The unique id of the storage container.

##### `quota`

Data type: `Optional[Integer[0,4611686018427387904]]`

The number of bytes that can be provisioned against this storage container. This must be a value greater than 10Gb and the default is 0 which means no limit.

#### Parameters

The following parameters are available in the `powerstore_storage_container` type.

##### `force`

Data type: `Optional[Boolean]`

Normally, deletion of a storage container that is mounted or still contains virtual volumes will be rejected. This
option overrides that error and allows the delete to continue. Use with great caution.

##### `name`

namevar

Data type: `String[1,64]`

Name for the storage container that is unique across all storage containers in the cluster. The name must be between 1
and 64 UTF-8 characters (inclusive), and not more than 127 bytes.

### `powerstore_vcenter`

rubocop:disable Style/StringLiterals

#### Properties

The following properties are available in the `powerstore_vcenter` type.

##### `address`

Data type: `Optional[String]`

IP address of vCenter host, in IPv4, IPv6, or hostname format.

##### `ensure`

Data type: `Enum['present', 'absent']`

Whether this resource should be present or absent on the target system.

Default value: `present`

##### `instance_uuid`

Data type: `Optional[String]`

UUID instance of the vCenter.

##### `password`

Data type: `Optional[String]`

Password to login to vCenter.

##### `username`

Data type: `Optional[String]`

User name to login to vCenter.

#### Parameters

The following parameters are available in the `powerstore_vcenter` type.

##### `id`

namevar

Data type: `String`

Unique identifier of the vCenter to delete.

### `powerstore_volume`

rubocop:disable Style/StringLiterals

#### Properties

The following properties are available in the `powerstore_volume` type.

##### `appliance_id`

Data type: `Optional[String]`

Identifier of the appliance on which the volume is provisioned.

##### `creation_timestamp`

Data type: `Optional[String]`

Time when the volume was created.

##### `description`

Data type: `Optional[String[0,128]]`

Description of the volume. This value must contain 128 or fewer printable Unicode characters.

##### `ensure`

Data type: `Enum['present', 'absent']`

Whether this resource should be present or absent on the target system.

Default value: `present`

##### `expiration_timestamp`

Data type: `Optional[String]`

New expiration time of the snapshot. Expired snapshots are deleted by the snapshot aging service that runs periodically in the background. If not specified, the snapshot never expires.Use a maximum timestamp value to set an expiration to never expire.

##### `force`

Data type: `Optional[Boolean]`

Normally a replication destination volume cannot be modified since it is controlled by replication. However, there can be cases where replication has failed or is no longer active and the replication destination volume needs to be cleaned up.With the force option, the user will be allowed to remove the protection policy from the replication destination volume provided that the replication session has never been synchronized and the last_sync_timestamp property is empty.This parameter defaults to false, if not specified.

##### `host_group_id`

Data type: `Optional[String]`

Unique identifier of the host group to be attached to the volume. If not specified, an unmapped volume is created. Only one of host_id or host_group_id can be supplied.

##### `host_id`

Data type: `Optional[String]`

Unique identifier of the host to be attached to the volume. If not specified, an unmapped volume is created. Only one of host_id or host_group_id can be supplied.

##### `id`

Data type: `Optional[String]`

Unique identifier of the volume to delete.

##### `is_replication_destination`

Data type: `Optional[Boolean]`

New value for is_replication_destination property. The modification is only supported for primary and clone volume, only when the current value is true and there is no longer a replication session using this volume as a destination, and only to false.

##### `location_history`

Data type: `Optional[Array[Struct[{Optional[from_appliance_id] => Optional[String], Optional[migrated_on] => Optional[String], Optional[reason] => Optional[Enum['Initial','Manual','Recommended']], Optional[reason_l10n] => Optional[String], Optional[to_appliance_id] => Optional[String], }]]]`

Filtering on the fields of this embedded resource is not supported.

##### `logical_unit_number`

Data type: `Optional[Integer[0,16383]]`

Optional logical unit number when creating a  attached volume.  If no host_id or host_group_id is specified, this property is ignored.

##### `migration_session_id`

Data type: `Optional[String]`

Unique identifier of the migration session assigned to the volume if it is part of a migration activity.

##### `min_size`

Data type: `Optional[Integer[0,9223372036854775807]]`

Optional minimum size for the volume, in bytes.

##### `node_affinity`

Data type: `Optional[Enum['System_Select_At_Attach','System_Selected_Node_A','System_Selected_Node_B','Preferred_Node_A','Preferred_Node_B']]`

This attribute shows which node will be advertised as the optimized IO path to the volume. It is initially set to System_Select_At_Attach and can be modified to other values. When a volume is first attached to a host, if node_affinity is System_Select_At_Attach then the system will make the assignment to either System_Selected_Node_A or System_Selected_Node_B. The node_affinity may be modified to one of System_Select_At_Attach or Preferred_Node_A or Preferred_Node_B. Both System_Selected_Node_A and System_Selected_Node_B are reserved for system use only and cannot be set as the volume's node_affinity.Possible affinity for a volume. * System_Select_At_Attach - Volume currently has no node affinity, affinity will be assigned when the volume is first attached. * System_Selected_Node_A - System selected Node A as the optimized IO path to volume. * System_Selected_Node_B - System selected Node B as the optimized IO path to volume. * Preferred_Node_A - Node A will always advertise as the optimized IO path to volume. * Preferred_Node_B - Node B will always advertise as the optimized IO path to volume.

##### `node_affinity_l10n`

Data type: `Optional[String]`

Localized message string corresponding to node_affinity

##### `performance_policy_id`

Data type: `Optional[String]`

Unique identifier of the performance policy assigned to the volume.

##### `protection_data`

Data type: `Optional[Struct[{Optional[copy_signature] => Optional[String], Optional[created_by_rule_id] => Optional[String], Optional[created_by_rule_name] => Optional[String], Optional[creator_type] => Optional[Enum['User','System','Scheduler']], Optional[creator_type_l10n] => Optional[String], Optional[expiration_timestamp] => Optional[String], Optional[family_id] => Optional[String], Optional[is_app_consistent] => Optional[Boolean], Optional[parent_id] => Optional[String], Optional[source_id] => Optional[String], Optional[source_timestamp] => Optional[String], }]]`

Protection data associated with a resource. Filtering on the fields of this embedded resource is not supported.

##### `protection_policy_id`

Data type: `Optional[String]`

Unique identifier of the protection policy assigned to the volume.

##### `sector_size`

Data type: `Optional[Integer[512,4096]]`

Optional sector size, in bytes. Only 512-byte and 4096-byte sectors are supported.

##### `size`

Data type: `Optional[Integer[1048576,281474976710656]]`

Size of the volume to be created, in bytes. Minimum volume size is 1MB. Maximum volume size is 256TB. Size must be a multiple of 8192.

##### `state`

Data type: `Optional[Enum['Ready','Initializing','Offline','Destroying']]`

Volume life cycle states. * Ready - Volume is operating normally. * Initializing - Volume is starting but not yet ready for use. * Offline - Volume is not available. * Destroying - Volume is being deleted. No new operations are allowed.

##### `state_l10n`

Data type: `Optional[String]`

Localized message string corresponding to state

##### `type`

Data type: `Optional[Enum['Primary','Clone','Snapshot']]`

Type of volume. * Primary - A base object. * Clone - A read-write object that shares storage with the object from which it is sourced. * Snapshot - A read-only object created from a volume or clone.

##### `type_l10n`

Data type: `Optional[String]`

Localized message string corresponding to type

##### `volume_group_id`

Data type: `Optional[String]`

Volume group to add the volume to.  If not specified, the volume is not added to a volume group.

##### `wwn`

Data type: `Optional[String]`

World wide name of the volume.

#### Parameters

The following parameters are available in the `powerstore_volume` type.

##### `name`

namevar

Data type: `String[0,128]`

Unique name for the volume to be created. This value must contain 128 or fewer printable Unicode characters.

### `powerstore_volume_group`

rubocop:disable Style/StringLiterals

#### Properties

The following properties are available in the `powerstore_volume_group` type.

##### `creation_timestamp`

Data type: `Optional[String]`

The time at which the volume group was created.

##### `description`

Data type: `Optional[String[0,256]]`

Description for the volume group. The description should not be more than 256characters long and should not have any unprintable characters.If description is not specified, the description for the volume group will not be set.

##### `ensure`

Data type: `Enum['present', 'absent']`

Whether this resource should be present or absent on the target system.

Default value: `present`

##### `force`

Data type: `Optional[Boolean]`

Normally a replication destination volume group cannot be modified since it is controlled by replication. However, there can be cases where replication has failed or is no longer active and the replication destination volume group needs to be cleaned up.With the force option, the user will be allowed to remove the protection policy from the replication destination volume group provided that the replication session has never been synchronized.This parameter defaults to false, if not specified.

##### `id`

Data type: `Optional[String]`

Unique identifier of the volume group.

##### `is_importing`

Data type: `Optional[Boolean]`

Indicates whether the volume group is being imported.

##### `is_protectable`

Data type: `Optional[Boolean]`

This is a derived field that is set internally. It enables/disables the following functionality:* Whether a protection_policy can be applied to the group.* Whether manual snapshots can be taken.* Whether clones of the group can be created.

##### `is_replication_destination`

Data type: `Optional[Boolean]`

New value for is_replication_destination property. is_replication_destination property of all the volumes in the volume group will be modified to the specified value. Modification of is_replication will not be transactional in nature. If the command only succeeds in modifying the is_replication_destination property of a subset of volumes, is_replication_destination property for the volume group will be set to true.Modification of this property is idempotent.This parameter is only valid when modifying a primary or a clone volume group, only when the volume group is no longer the destination of a replication session, and may only be set to false.

##### `is_write_order_consistent`

Data type: `Optional[Boolean]`

A boolean flag to indicate whether snapshot sets of the volume group will be write-order consistent.This parameter defaults to true, if not specified.

##### `location_history`

Data type: `Optional[Array[Struct[{Optional[from_appliance_id] => Optional[String], Optional[migrated_on] => Optional[String], Optional[reason] => Optional[Enum['Initial','Manual','Recommended']], Optional[reason_l10n] => Optional[String], Optional[to_appliance_id] => Optional[String], }]]]`

A list of locations. The list of locations includes the move to the current appliance. Filtering on the fields of this embedded resource is not supported.

##### `migration_session_id`

Data type: `Optional[String]`

Unique identifier of the migration session assigned to the volume group when it is part of a migration activity.

##### `placement_rule`

Data type: `Optional[Enum['Same_Appliance','No_Preference']]`

This is set during creation, and determines resource balancer recommendations.* Same_Appliance - All the members of the group should be on the same appliance in the cluster.* No_Preference - The volumes can be placed on any of the appliances in the cluster. Filtering on the fields of this embedded resource is not supported.

##### `protection_data`

Data type: `Optional[Struct[{Optional[copy_signature] => Optional[String], Optional[created_by_rule_id] => Optional[String], Optional[created_by_rule_name] => Optional[String], Optional[creator_type] => Optional[Enum['User','System','Scheduler']], Optional[creator_type_l10n] => Optional[String], Optional[expiration_timestamp] => Optional[String], Optional[family_id] => Optional[String], Optional[is_app_consistent] => Optional[Boolean], Optional[parent_id] => Optional[String], Optional[source_id] => Optional[String], Optional[source_timestamp] => Optional[String], }]]`

Protection data associated with a resource. Filtering on the fields of this embedded resource is not supported.

##### `protection_policy_id`

Data type: `Optional[String]`

Unique identifier of an optional protection policy to assign to the volume group.

##### `type`

Data type: `Optional[Enum['Primary','Clone','Snapshot']]`

Type of volume. * Primary - A base object. * Clone - A read-write object that shares storage with the object from which it is sourced. * Snapshot - A read-only object created from a volume or clone.

##### `type_l10n`

Data type: `Optional[String]`

Localized message string corresponding to type

##### `volume_ids`

Data type: `Optional[Array[String]]`

A list of identifiers of existing volumes that should be added to the volume group. All the volumes must be on the same Cyclone appliance and should not be part of another volume group.If a list of volumes is not specified or if the specified list is empty, anempty volume group of type Volume will be created.

#### Parameters

The following parameters are available in the `powerstore_volume_group` type.

##### `delete_members`

Data type: `Optional[Boolean]`

By default, the members of a volume group being deleted are only removed. Set this optional parameter to true to
override this behavior and also delete the members after they are removed from the volume group.This parameter defaults
to false, if not specified.

##### `name`

namevar

Data type: `String[0,128]`

Unique name for the volume group. The name should contain no special HTTP characters and no unprintable characters.
Although the case of the name provided is reserved, uniqueness check is case-insensitive, so the same name in two
different cases is not considered unique.

## Functions

### `format_bytes`

Type: Ruby 4.x API

format_bytes.rb

#### `format_bytes(Integer $bytes)`

format_bytes.rb

Returns: `Any` A string containing a human-readable representation of bytes using the most appropriate unit

##### `bytes`

Data type: `Integer`

The size in bytes

### `to_bytes`

Type: Ruby 4.x API

to_bytes.rb

#### `to_bytes(Variant[Numeric,String] $arg)`

to_bytes.rb

Returns: `Any` Value converted into bytes

##### `arg`

Data type: `Variant[Numeric,String]`

The string containing a byte size

## Tasks

### `alert_collection_query`

Query all alerts.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `alert_instance_query`

Query a specific alert.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the alert.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `alert_modify`

Modify an alert. acknowledged_severity parameter, if included, will cause the request to fail when the alert's severity is higher than the acknowledged_severity parameter value. acknowledged_severity  is ignored when is_acknowledged is set to false.

**Supports noop?** false

#### Parameters

##### `acknowledged_severity`

Data type: `Optional[Enum['None','Info','Minor','Major','Critical']]`

Possible severities.

##### `id`

Data type: `String`

Unique identifier of the specific alert.

##### `is_acknowledged`

Data type: `Boolean`

Indicates whether the alert has been acknowledged.

### `appliance_collection_query`

Query the appliances in a cluster.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `appliance_forecast`

Forecast capacity usage for an appliance.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique id of the appliance.

##### `metric_type`

Data type: `Enum['Physical_Space_Used_One_Day']`

Metric type to be forecast.

### `appliance_instance_query`

Query a specific appliance in a cluster.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the appliance.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `appliance_modify`

Modify an appliance's name.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the appliance.

##### `name`

Data type: `String`

New name of the appliance.

### `appliance_time_to_full`

Returns information about when an appliance is forecast to reach 100% capacity usage.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique id of the appliance.

##### `metric_type`

Data type: `Enum['Physical_Space_Used_One_Day']`

Metric type to be forecast.

### `audit_event_collection_query`

Query audit log entries.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `bond_collection_query`

Query bond configurations.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `bond_instance_query`

Query a specific bond configuration.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the bond configuration.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `chap_config_collection_query`

Query the list of (one) CHAP configuration settings objects. This resource type collection query does not support filtering, sorting or pagination

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `chap_config_instance_query`

Query the CHAP configuration settings object.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

The id of the CHAP configuration object (always '0').

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `chap_config_modify`

Modify the CHAP configuration settings object. To enable either Single or Mutual CHAP modes, the username and password must already be set, or included in the same request as the new mode.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

The id of the CHAP configuration object (always '0').

##### `mode`

Data type: `Enum['Disabled','Single','Mutual']`

Available CHAP modes that describe or set the iSCSI CHAP mode for the entire cluster. * Disabled - CHAP is not used in the cluster * Single - CHAP is being used to authenticate the initiator  * Mutual - CHAP is used to authenticate both the initiator and target 

### `cluster_collection_query`

Get details about the cluster. This resource type collection query does not support filtering, sorting or pagination

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `cluster_forecast`

Forecast capacity usage for the cluster.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique id of the cluster.

##### `metric_type`

Data type: `Enum['Physical_Space_Used_One_Day']`

Metric type to be forecast.

### `cluster_instance_query`

Get details about the cluster. This does not support the following standard query functionality: property selection, and nested query embedding.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the Cluster.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `cluster_modifyclusterproperties`

Modify cluster properties, such as physical MTU.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the Cluster.

##### `name`

Data type: `Optional[String[1,64]]`

The name of the cluster. The name can be up to 64 UTF-8 characters and cannot be an empty string.

##### `physical_mtu`

Data type: `Optional[Integer[1500,9000]]`

The physical ethernet port (eth_port resource) MTU setting, global for all ports in the cluster. This is the default MTU setting for IP traffic, and the upper limit on network-specific MTU settings (network resource), where this can be overridden for some specific kinds of traffic (management, data, and vmotion). This value must be in the range 1500-9000.

### `cluster_time_to_full`

Returns information about when the cluster is forecast to reach 100% capacity usage.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique id of the cluster

##### `metric_type`

Data type: `Enum['Physical_Space_Used_One_Day']`

Metric type to be forecast.

### `discovered_initiator_collection_query`

Returns connected initiators that are not associated with a host. This resource type collection query does not support filtering, sorting or pagination

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `dns_collection_query`

Query DNS settings for a cluster.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `dns_instance_query`

Query a specific DNS setting.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the DNS setting.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `dns_modify`

Modify a DNS setting.

**Supports noop?** false

#### Parameters

##### `addresses`

Data type: `Array[String]`

DNS server addresses in IPv4 or IPv6 format.

##### `id`

Data type: `String`

Unique identifier of the DNS setting.

### `email_notify_destination_collection_query`

Query all email notification destinations.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `email_notify_destination_create`

Add an email address to receive notifications.

**Supports noop?** false

#### Parameters

##### `email_address`

Data type: `String`

Email address to receive notifications.

##### `notify_critical`

Data type: `Optional[Boolean]`

Whether to send notifications for critical alerts.

##### `notify_info`

Data type: `Optional[Boolean]`

Whether send notifications for informational alerts.

##### `notify_major`

Data type: `Optional[Boolean]`

Whether to send notifications for major alerts.

##### `notify_minor`

Data type: `Optional[Boolean]`

Whether to send notifications for minor alerts.

### `email_notify_destination_delete`

Delete an email notification destination.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the email notification destination.

### `email_notify_destination_instance_query`

Query a specific email notification destination.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the email notification destination.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `email_notify_destination_modify`

Modify an email notification destination.

**Supports noop?** false

#### Parameters

##### `email_address`

Data type: `Optional[String]`

Email address to receive notifications.

##### `id`

Data type: `String`

Unique identifier of the email notification destination.

##### `notify_critical`

Data type: `Optional[Boolean]`

Whether to send notifications for critical alerts.

##### `notify_info`

Data type: `Optional[Boolean]`

Whether to send notifications for informational alerts.

##### `notify_major`

Data type: `Optional[Boolean]`

Whether to send notifications for major alerts.

##### `notify_minor`

Data type: `Optional[Boolean]`

Whether to send notifications for minor alerts.

### `email_notify_destination_test`

Send a test email to an email address.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the email notification destination.

### `eth_port_collection_query`

Get Ethernet front-end port configuration for all cluster nodes.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `eth_port_instance_query`

Get Ethernet front-end port configuration by instance identifier.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Ethernet front-end port instance identifier.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `eth_port_modify`

Change the properties of the front-end port. Note that setting the port's requested speed may not cause the port speed to change immediately. In cases where the SFP is not inserted or the port is down the requested speed will be set but the current_speed will still show the old value until the SFP is able to change speed. By default, the partner port speed on the other node in the appliance is set to the same requested speed. If the requested speed is not supported by the partner port it is left unchanged.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the port.

##### `requested_speed`

Data type: `Enum['Auto','10_Mbps','100_Mbps','1_Gbps','10_Gbps','25_Gbps','40_Gbps']`

Supported Ethernet front-end port transmission speeds.For the current_speed attribute, these values show the current transmission speed on the port.For the requested_speed attribute, these values show the transmission speed set by the user. A requested speed of Auto means that the current speed value will be automatically detected.If this file is updated, also update FrontEndPortSpeedEnum.yaml* Auto - the speed value is automatically detected* 10_Mbps - 10 Megabits per second* 100_Mbps - 100 Megabits per second* 1_Gbps - 1 Gigabits per second* 10_Gbps - 10 Gigabits per second* 25_Gbps - 25 Gigabits per second* 40_Gbps - 40 Gigabits per second

### `event_eventsummary`

Get event by Event Id.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Event Id

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `event_getevents`

Returns all events in the database.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `fc_port_collection_query`

Query the FC front-end port configurations for all cluster nodes.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `fc_port_instance_query`

Query a specific FC front-end port configuration.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the FC front-end port.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `fc_port_modify`

Modify an FC front-end port's speed. Setting the port's requested speed might not cause the port speed to change immediately. In cases where the Small Form-Factor Pluggable (SFP) is not inserted or the port is down, the requested speed is set, but the current_speed attribute shows the old value until the SFP is able to change speed. By default, the partner port speed on the other node in the appliance is set to the same requested speed. If the requested speed is not supported by the partner port, it is left unchanged.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the FC front-end port.

##### `requested_speed`

Data type: `Enum['Auto','4_Gbps','8_Gbps','16_Gbps','32_Gbps']`

Possible Fibre Channel port speeds. For the current_speed attribute, these values show the current transmission speed on the port. For the requested_speed attribute, these values show the transmission speed set by the user. A requested speed of Auto means that the current speed value will be automatically detected.If this file is updated, also update FrontEndPortSpeedEnum.yaml* Auto - the speed value is automatically detected* 4_Gbps - 4 Gigabits per second* 8_Gbps - 8 Gigabits per second* 16_Gbps - 16 Gigabits per second* 32_Gbps - 32 Gigabits per second

### `file_dns_collection_query`

Query of the DNS settings of NAS Servers.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `file_dns_create`

Create a new DNS Server configuration for a NAS Server. Only one object can be created per NAS Server.

**Supports noop?** false

#### Parameters

##### `domain`

Data type: `String[1,255]`

Name of the DNS domain, where the NAS Server does host names lookup when an FQDN is not specified in the request.

##### `ip_addresses`

Data type: `Array[String]`

The list of DNS server IP addresses. The addresses may be IPv4 or IPv6.

##### `nas_server_id`

Data type: `String`

Unique identifier of the associated NAS Server instance that uses this DNS object. Only one DNS object per NAS Server is supported.

##### `transport`

Data type: `Optional[Enum['UDP','TCP']]`

Transport used when connecting to the DNS Server:* UDP - DNS uses the UDP protocol (default)* TCP - DNS uses the TCP protocol

### `file_dns_delete`

Delete DNS settings of a NAS Server.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the DNS object.

### `file_dns_instance_query`

Query a specific DNS settings object of a NAS Server.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the DNS object.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `file_dns_modify`

Modify the DNS settings of a NAS Server.

**Supports noop?** false

#### Parameters

##### `add_ip_addresses`

Data type: `Optional[Array[String]]`

IP addresses to add to the current list. The addresses may be IPv4 or IPv6. Error occurs if an IP address already exists. Cannot be combined with ip_addresses.

##### `domain`

Data type: `Optional[String[1,255]]`

Name of the DNS domain, where the NAS Server does host names lookup when an FQDN is not specified in the request.

##### `id`

Data type: `String`

Unique identifier of the DNS object.

##### `ip_addresses`

Data type: `Optional[Array[String]]`

A new list of DNS server IP addresses to replace the existing list. The addresses may be IPv4 or IPv6.

##### `remove_ip_addresses`

Data type: `Optional[Array[String]]`

IP addresses to remove from the current list. The addresses may be IPv4 or IPv6. Error occurs if IP address is not present. Cannot be combined with ip_addresses.

##### `transport`

Data type: `Optional[Enum['UDP','TCP']]`

Transport used when connecting to the DNS Server:* UDP - DNS uses the UDP protocol (default)* TCP - DNS uses the TCP protocol

### `file_ftp_collection_query`

Query FTP/SFTP instances.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `file_ftp_create`

Create an FTP/SFTP server.

**Supports noop?** false

#### Parameters

##### `audit_dir`

Data type: `Optional[String]`

(Applies when the value of is_audit_enabled is true.) Directory of FTP/SFTP audit files. Logs are saved in '/' directory (default) or in a mounted file system (Absolute path of the File system directory which should already exist).

##### `audit_max_size`

Data type: `Optional[Integer[40960,9223372036854775807]]`

(Applies when the value of is_audit_enabled is true.) Maximum size of all (current plus archived) FTP/SFTP audit files, in bytes.There is a maximum of 5 audit files, 1 current audit file (ftp.log) and 4 archived audit files.The maximum value for this setting is 5GB (each file of 1GB) if the audit directory belongs to a user file system of the NAS server.If the audit directory is '/', the maximum value is 5MB (each file of 1MB).The minimum value is 40kB (each file of 8KB) on any file system.

##### `default_homedir`

Data type: `Optional[String]`

(Applies when the value of is_homedir_limit_enabled is false.) Default directory of FTP and SFTP clients who have a home directory that is not defined or accessible.

##### `groups`

Data type: `Optional[Array[String]]`

Allowed or denied user groups, depending on the value of the is_allowed_groups attribute.- If allowed groups exist, only users who are members of these groups and no others can connect to the NAS server through FTP or SFTP.- If denied groups exist, all users who are members of those groups always have access denied to the NAS server through FTP or SFTP.- If the list is empty, there is no restriction to the NAS server access through FTP or SFTP based on the user group.

##### `hosts`

Data type: `Optional[Array[String]]`

Allowed or denied hosts, depending on the value of the is_allowed_hosts attribute. A host is defined using its IP address. Subnets using CIDR notation are also supported.- If allowed hosts exist, only those hosts and no others can connect to the NAS server through FTP or SFTP.- If denied hosts exist, they always have access denied to the NAS server through FTP or SFTP.- If the list is empty, there is no restriction to NAS server access through FTP or SFTP based on the host IP address.- The addresses may be IPv4 or IPv6.

##### `is_allowed_groups`

Data type: `Optional[Boolean]`

Indicates whether the groups attribute contains allowed or denied user groups. Values are:- true - groups contains allowed user groups.- false - groups contains denied user groups.

##### `is_allowed_hosts`

Data type: `Optional[Boolean]`

Indicates whether the hosts attribute contains allowed or denied hosts. Values are:true - hosts contains allowed hosts.false - hosts contains denied hosts.

##### `is_allowed_users`

Data type: `Optional[Boolean]`

Indicates whether the users attribute contains allowed or denied users. Values are:- true - users contains allowed users.- false - users contains denied users.

##### `is_anonymous_authentication_enabled`

Data type: `Optional[Boolean]`

Indicates whether FTP clients can be authenticated anonymously. Values are:- true - Anonymous user name is accepted.- false - Anonymous user name is not accepted.

##### `is_audit_enabled`

Data type: `Optional[Boolean]`

Indicates whether the activity of FTP and SFTP clients is tracked in audit files. Values are:- true - FTP/SFTP activity is tracked.- false - FTP/SFTP activity is not tracked.

##### `is_ftp_enabled`

Data type: `Optional[Boolean]`

Indicates whether the FTP server is enabled on the NAS server specified in the nasServer attribute. Values are:- true - FTP server is enabled on the specified NAS server.- false - FTP server is disabled on the specified NAS server.

##### `is_homedir_limit_enabled`

Data type: `Optional[Boolean]`

Indicates whether an FTP or SFTP user access is limited to the home directory of the user. Values are:- true - An FTP or SFTP user can access only the home directory of the user.- false - FTP and SFTP users can access any NAS server directory, according to NAS server permissions.

##### `is_sftp_enabled`

Data type: `Optional[Boolean]`

Indicates whether the SFTP server is enabled on the NAS server specified in the nasServer attribute. Values are:- true - SFTP server is enabled on the specified NAS server.- false - SFTP server is disabled on the specified NAS server.

##### `is_smb_authentication_enabled`

Data type: `Optional[Boolean]`

Indicates whether FTP and SFTP clients can be authenticated using an SMB user name. These user names are defined in a Windows domain controller, and their formats are user@domain or domain\\user. Values are:- true - SMB user names are accepted for authentication.- false - SMB user names are not accepted for authentication.

##### `is_unix_authentication_enabled`

Data type: `Optional[Boolean]`

Indicates whether FTP and SFTP clients can be authenticated using a Unix user name. Unix user names are defined in LDAP, NIS servers or in local passwd file. Values are:- true - Unix user names are accepted for authentication.- false - Unix user names are not accepted for authentication.

##### `message_of_the_day`

Data type: `Optional[String]`

Message of the day displayed on the console of FTP clients after their authentication. The length of this message is limited to 511 bytes of UTF-8 characters, and the length of each line is limited to 80 bytes.

##### `nas_server_id`

Data type: `String`

Unique identifier of the NAS server that is configured with the FTP server.

##### `users`

Data type: `Optional[Array[String]]`

Allowed or denied users, depending on the value of the is_allowed_user attribute.- If allowed users exist, only those users and no others can connect to the NAS server through FTP or SFTP.- If denied users exist, they have always access denied to the NAS server through FTP or SFTP.- If the list is empty, there is no restriction to the NAS server access through FTP or SFTP based on the user name.

##### `welcome_message`

Data type: `Optional[String]`

Welcome message displayed on the console of FTP and SFTP clients before their authentication. The length of this message is limited to 511 bytes of UTF-8 characters, and the length of each line is limited to 80 bytes.

### `file_ftp_delete`

Delete an FTP/SFTP Server.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the FTP/SFTP Server object.

### `file_ftp_instance_query`

Query a specific FTP/SFTP server for its settings.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the FTP/SFTP Server object.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `file_ftp_modify`

Modify an FTP/SFTP server settings.

**Supports noop?** false

#### Parameters

##### `add_groups`

Data type: `Optional[Array[String]]`

Groups to add to the current groups. Error occurs if the group already exists. Cannot be combined with groups.

##### `add_hosts`

Data type: `Optional[Array[String]]`

Host IP addresses to add to the current hosts. The addresses may be IPv4 or IPv6. Error occurs if the IP address already exists. Cannot be combined with hosts.

##### `add_users`

Data type: `Optional[Array[String]]`

Users to add to the current users. Error occurs if the user already exist. Cannot be combined with users.

##### `audit_dir`

Data type: `Optional[String]`

(Applies when the value of is_audit_enabled is true.) Directory of FTP/SFTP audit files. Logs are saved in '/' directory (default) or in a mounted file system (Absolute path of the File system directory which should already exist).

##### `audit_max_size`

Data type: `Optional[Integer[40960,9223372036854775807]]`

(Applies when the value of is_audit_enabled is true.) Maximum size of all (current plus archived) FTP/SFTP audit files, in bytes.There is a maximum of 5 audit files, 1 current audit file (ftp.log) and 4 archived audit files.The maximum value for this setting is 5GB (each file of 1GB) if the audit directory belongs to a user file system of the NAS server.If the audit directory is '/', the maximum value is 5MB (each file of 1MB).The minimum value is 40kB (each file of 8KB) on any file system.

##### `default_homedir`

Data type: `Optional[String]`

(Applies when the value of is_homedir_limit_enabled is false.) Default directory of FTP and SFTP clients that have a home directory which is not defined or accessible.

##### `groups`

Data type: `Optional[Array[String]]`

Allowed or denied user groups, depending on the value of the is_allowed_groups attribute.- If allowed groups exist, only users who are members of these groups and no others can connect to the NAS server through FTP or SFTP.- If denied groups exist, all users who are members of those groups always have access denied to the NAS server through FTP or SFTP.- If the list is empty, there is no restriction to the NAS server access through FTP or SFTP based on the user group.

##### `hosts`

Data type: `Optional[Array[String]]`

Allowed or denied hosts, depending on the value of the is_allowed_hosts attribute. A host is defined using its IP address. Subnets using CIDR notation are also supported.- If allowed hosts exist, only those hosts and no others can connect to the NAS server through FTP or SFTP.- If denied hosts exist, they always have access denied to the NAS server through FTP or SFTP.- If the list is empty, there is no restriction to NAS server access through FTP or SFTP based on the host IP address.- The addresses may be IPv4 or IPv6.

##### `id`

Data type: `String`

Unique identifier of the FTP/SFTP Server object.

##### `is_allowed_groups`

Data type: `Optional[Boolean]`

Indicates whether the groups attribute contains allowed or denied user groups. Values are:- true - groups contains allowed user groups.- false - groups contains denied user groups.

##### `is_allowed_hosts`

Data type: `Optional[Boolean]`

Indicates whether the hosts attribute contains allowed or denied hosts. Values are:true - hosts contains allowed hosts.false - hosts contains denied hosts.

##### `is_allowed_users`

Data type: `Optional[Boolean]`

Indicates whether the users attribute contains allowed or denied users. Values are:- true - users contains allowed users.- false - users contains denied users.

##### `is_anonymous_authentication_enabled`

Data type: `Optional[Boolean]`

Indicates whether FTP clients can be authenticated anonymously. Values are:- true - Anonymous user name is accepted.- false - Anonymous user name is not accepted.

##### `is_audit_enabled`

Data type: `Optional[Boolean]`

Indicates whether the activity of FTP and SFTP clients is tracked in audit files. Values are:- true - FTP/SFTP activity is tracked.- false - FTP/SFTP activity is not tracked.

##### `is_ftp_enabled`

Data type: `Optional[Boolean]`

Indicates whether the FTP server is enabled on the NAS server specified in the nasServer attribute. Values are:- true - FTP server is enabled on the specified NAS server.- false - FTP server is disabled on the specified NAS server.

##### `is_homedir_limit_enabled`

Data type: `Optional[Boolean]`

Indicates whether an FTP or SFTP user access is limited to the home directory of the user. Values are:- true - An FTP or SFTP user can access only the home directory of the user.- false - FTP and SFTP users can access any NAS server directory, according to NAS server permissions.

##### `is_sftp_enabled`

Data type: `Optional[Boolean]`

Indicates whether the SFTP server is enabled on the NAS server specified in the nasServer attribute. Values are:- true - SFTP server is enabled on the specified NAS server.- false - SFTP server is disabled on the specified NAS server.

##### `is_smb_authentication_enabled`

Data type: `Optional[Boolean]`

Indicates whether FTP and SFTP clients can be authenticated using an SMB user name. These user names are defined in a Windows domain controller, and their formats are user@domain or domain\\user. Values are:- true - SMB user names are accepted for authentication.- false - SMB user names are not accepted for authentication.

##### `is_unix_authentication_enabled`

Data type: `Optional[Boolean]`

Indicates whether FTP and SFTP clients can be authenticated using a Unix user name. Unix user names are defined in LDAP, NIS servers or in local passwd file. Values are:- true - Unix user names are accepted for authentication.- false - Unix user names are not accepted for authentication.

##### `message_of_the_day`

Data type: `Optional[String]`

Message of the day displayed on the console of FTP clients after their authentication. The length of this message is limited to 511 bytes of UTF-8 characters, and the length of each line is limited to 80 bytes.

##### `remove_groups`

Data type: `Optional[Array[String]]`

Groups to remove from the current groups. Error occurs if the group is not present. Cannot be combined with groups.

##### `remove_hosts`

Data type: `Optional[Array[String]]`

Host IP addresses to remove from the current hosts. The addresses may be IPv4 or IPv6. Error occurs if the IP address is not present. Cannot be combined with hosts.

##### `remove_users`

Data type: `Optional[Array[String]]`

Users to remove from the current users. Error occurs if the user is not present. Cannot be combined with users.

##### `users`

Data type: `Optional[Array[String]]`

Allowed or denied users, depending on the value of the is_allowed_users attribute.- If allowed users exist, only those users and no others can connect to the NAS server through FTP or SFTP.- If denied users exist, they always have access denied to the NAS server through FTP or SFTP.- If the list is empty, there is no restriction to the NAS server access through FTP or SFTP based on the user name.

##### `welcome_message`

Data type: `Optional[String]`

Welcome message displayed on the console of FTP and SFTP clients before their authentication. The length of this message is limited to 511 bytes of UTF-8 characters, and the length of each line is limited to 80 bytes.

### `file_interface_collection_query`

Query file interfaces.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `file_interface_create`

Create a file interface.

**Supports noop?** false

#### Parameters

##### `gateway`

Data type: `Optional[String[1,45]]`

Gateway address for the network interface. IPv4 and IPv6 are supported.

##### `ip_address`

Data type: `String[1,45]`

IP address of the network interface. IPv4 and IPv6 are supported.

##### `is_disabled`

Data type: `Optional[Boolean]`

Indicates whether the network interface is disabled.

##### `nas_server_id`

Data type: `String`

Unique identifier of the NAS server to which the network interface belongs, as defined by the nas_server resource type.

##### `prefix_length`

Data type: `Integer[1,128]`

Prefix length for the interface. IPv4 and IPv6 are supported.

##### `role`

Data type: `Optional[Enum['Production','Backup']]`

- Production - This type of network interface is used for all file protocols and services of a NAS server. This type of interface is inactive while a NAS server is in destination mode. - Backup  - This type of network interface is used only for NDMP/NFS backup or disaster recovery testing. This type of interface is always active in all NAS server modes.

##### `vlan_id`

Data type: `Optional[Integer[0,4094]]`

Virtual Local Area Network (VLAN) identifier for the interface. The interface uses the identifier to accept packets that have matching VLAN tags.

### `file_interface_delete`

Delete a file interface.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the file interface.

### `file_interface_instance_query`

The file_interface_instance_query task.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the file interface.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `file_interface_modify`

Modify the settings of a file interface.

**Supports noop?** false

#### Parameters

##### `gateway`

Data type: `Optional[String[0,45]]`

Gateway address for the network interface. IPv4 and IPv6 are supported.

##### `id`

Data type: `String`

Unique identifier of the file interface.

##### `ip_address`

Data type: `Optional[String[1,45]]`

IP address of the network interface. IPv4 and IPv6 are supported.

##### `is_disabled`

Data type: `Optional[Boolean]`

Indicates whether the network interface is disabled.

##### `prefix_length`

Data type: `Optional[Integer[1,128]]`

Prefix length for the interface. IPv4 and IPv6 are supported.

##### `vlan_id`

Data type: `Optional[Integer[0,4094]]`

Virtual Local Area Network (VLAN) identifier for the interface. The interface uses the identifier to accept packets that have matching VLAN tags.

### `file_interface_route_collection_query`

Query file interface routes.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `file_interface_route_create`

Create and configure a new file interface route.There are 3 route types Subnet, Default, and Host.* The default route establishes a static route to a default gateway. To create a default route, provide only the default gateway IP address.* The host route establishes a static route to a specific host. To create a host route, provide the IP address of the specific host in the destination field, and the gateway.* The subnet route establishes a static route to a particular subnet. To create a subnet route, provide the IP address of the target subnet in the destination, the prefix length for that subnet, and the gateway.

**Supports noop?** false

#### Parameters

##### `destination`

Data type: `Optional[String]`

IPv4 or IPv6 address of the target network node based on the specific route type. Values are:* For a default route, there is no value because the system will use the specified gateway IP address.* For a host route, the value is the host IP address.* For a subnet route, the value is a subnet IP address.

##### `file_interface_id`

Data type: `String`

Unique identifier of the associated file interface.

##### `gateway`

Data type: `Optional[String[1,45]]`

IP address of the gateway associated with the route.

##### `prefix_length`

Data type: `Optional[Integer[1,128]]`

IPv4 or IPv6 prefix length for the route.

### `file_interface_route_delete`

Delete file interface route.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the file interface route object.

### `file_interface_route_instance_query`

Query a specific file interface route for details.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the file interface route object.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `file_interface_route_modify`

Modify file interface route settings.

**Supports noop?** false

#### Parameters

##### `destination`

Data type: `Optional[String]`

IPv4 or IPv6 address of the target network node based on the specific route type. Values are:* For a default route, there is no value because the system will use the specified gateway IP address.* For a host route, the value is the host IP address.* For a subnet route, the value is a subnet IP address.

##### `gateway`

Data type: `Optional[String[0,45]]`

IP address of the gateway associated with the route.

##### `id`

Data type: `String`

Unique identifier of the file interface route object.

##### `prefix_length`

Data type: `Optional[Integer[1,128]]`

IPv4 or IPv6 prefix length for the route.

### `file_kerberos_collection_query`

Query of the Kerberos service settings of NAS Servers.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `file_kerberos_create`

Create a Kerberos configuration. The operation will fail if a Kerberos configuration already exists.

**Supports noop?** false

#### Parameters

##### `kdc_addresses`

Data type: `Array[String[1,255]]`

Fully Qualified domain names of the Kerberos Key Distribution Center (KDC) servers. IPv4 and IPv6 addresses are not supported.

##### `nas_server_id`

Data type: `String`

Unique identifier of the associated NAS Server instance that uses this Kerberos object. Only one Kerberos object per NAS Server is supported.

##### `port_number`

Data type: `Optional[Integer[0,65535]]`

KDC servers TCP port.

##### `realm`

Data type: `String[1,255]`

Realm name of the Kerberos Service.

### `file_kerberos_delete`

Delete Kerberos configuration of a NAS Server.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the Kerberos service object.

### `file_kerberos_download_keytab`

Download previously uploaded keytab file for secure NFS service.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the Kerberos service object.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `file_kerberos_instance_query`

Query a specific Kerberos service settings of a NAS Server.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Kerberos service object.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `file_kerberos_modify`

Modify the Kerberos service settings of a NAS Server.

**Supports noop?** false

#### Parameters

##### `add_kdc_addresses`

Data type: `Optional[Array[String[1,255]]]`

Fully Qualified domain names of the Kerberos Key Distribution Center (KDC) servers to add to the current list. Error occurs if name already exists. Cannot be combined with kdc_addresses. IPv4 and IPv6 addresses are not supported.

##### `id`

Data type: `String`

Unique identifier of the Kerberos service object.

##### `kdc_addresses`

Data type: `Optional[Array[String[1,255]]]`

Fully Qualified domain names of the Kerberos Key Distribution Center (KDC) servers. IPv4 and IPv6 addresses are not supported.

##### `port_number`

Data type: `Optional[Integer[0,65535]]`

KDC servers TCP port.

##### `realm`

Data type: `Optional[String[1,255]]`

Realm name of the Kerberos Service.

##### `remove_kdc_addresses`

Data type: `Optional[Array[String[1,255]]]`

Fully Qualified domain names of the Kerberos Key Distribution Center (KDC) servers to remove from the current list. Error occurs if name is not in the existing list. Cannot be combined with kdc_addresses. IPv4 and IPv6 addresses are not supported.

### `file_kerberos_upload_keytab`

A keytab file is required for secure NFS service with a Linux or Unix Kerberos Key Distribution Center (KDC). The keytab file can be generated using the KDC server.

**Supports noop?** false

#### Parameters

##### `body`

Data type: `Optional[String]`



##### `id`

Data type: `String`

Unique identifier of the Kerberos service object.

### `file_ldap_collection_query`

List LDAP Service instances.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `file_ldap_create`

Create an LDAP service on a NAS Server. Only one LDAP Service object can be created per NAS Server.

**Supports noop?** false

#### Parameters

##### `addresses`

Data type: `Optional[Array[String]]`

The list of LDAP server IP addresses. The addresses may be IPv4 or IPv6.

##### `authentication_type`

Data type: `Enum['Anonymous','Simple','Kerberos']`

Authentication type for the LDAP server.* Anonymous - Anonymous authentication means no authentication occurs and the NAS Server uses an anonymous login to access the LDAP-based directory server.* Simple - Simple authentication means the NAS Server must provide a bind distinguished name and password to access the LDAP-based directory server.* Kerberos - Kerberos authentication means the NAS Server uses a KDC to confirm the identity when accessing the Active Directory.

##### `base_dn`

Data type: `String[3,255]`

Name of the LDAP base DN. Base Distinguished Name (BDN) of the root of the LDAP directory tree. The appliance uses the DN to bind to the LDAP service and locate in the LDAP directory tree to begin a search for information.  The base DN can be expressed as a fully-qualified domain name or in X.509 format by using the attribute dc=. For example, if the fully-qualified domain name is mycompany.com, the base DN is expressed as dc=mycompany,dc=com.

##### `bind_dn`

Data type: `Optional[String[0,1023]]`

Bind Distinguished Name (DN) to be used when binding.

##### `bind_password`

Data type: `Optional[String[0,1023]]`

The associated password to be used when binding to the server.

##### `is_smb_account_used`

Data type: `Optional[Boolean]`

Indicates whether SMB authentication is used to authenticate to the LDAP server. Values are:     * true - Indicates that the SMB settings are used for Kerberos authentication.    * false - Indicates that Kerberos uses its own settings.

##### `is_verify_server_certificate`

Data type: `Optional[Boolean]`

Indicates whether Certification Authority certificate is used to verify the LDAP server certificate for secure SSL connections. Values are: * true - verifies LDAP server's certificate. * false - doesn't verify LDAP server's certificate.

##### `nas_server_id`

Data type: `String`

Unique identifier of the associated NAS Server instance that will use this LDAP object. Only one LDAP object per NAS Server is supported.

##### `password`

Data type: `Optional[String[0,1023]]`

The associated password for Kerberos authentication.

##### `port_number`

Data type: `Optional[Integer[0,65536]]`

The TCP/IP port used by the NAS Server to connect to the LDAP servers. The default port number for LDAP is 389 and LDAPS is 636.

##### `principal`

Data type: `Optional[String[0,1023]]`

Specifies the principal name for Kerberos authentication.

##### `profile_dn`

Data type: `Optional[String[0,255]]`

For an iPlanet LDAP server, specifies the DN of the entry with the configuration profile.

##### `protocol`

Data type: `Optional[Enum['LDAP','LDAPS']]`

Indicates whether the LDAP protocol uses SSL for secure network communication. SSL encrypts data over the network and provides message and server authentication.* LDAP - LDAP protocol without SSL.* LDAPS - (Default) LDAP protocol with SSL. When you enable LDAPS, make sure to specify the appropriate LDAPS port (usually port 636) and to upload an LDAPS trust certificate to the LDAP server.

##### `realm`

Data type: `Optional[String[0,255]]`

Specifies the realm name for Kerberos authentication.

### `file_ldap_delete`

Delete a NAS Server's LDAP settings.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

LDAP settings object Id.

### `file_ldap_download_certificate`

The file_ldap_download_certificate task.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the LDAP settings object.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `file_ldap_download_config`

The file_ldap_download_config task.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the LDAP settings object.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `file_ldap_instance_query`

Query a specific NAS Server's LDAP settings object.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the LDAP settings object.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `file_ldap_modify`

Modify a NAS Server's LDAP settings object.

**Supports noop?** false

#### Parameters

##### `add_addresses`

Data type: `Optional[Array[String]]`

IP addresses to add to the current server IP addresses list. The addresses may be IPv4 or IPv6. Error occurs if an IP address already exists in the addresses list. Cannot be combined with addresses.

##### `addresses`

Data type: `Optional[Array[String]]`

The list of LDAP server IP addresses. The addresses may be IPv4 or IPv6.

##### `authentication_type`

Data type: `Optional[Enum['Anonymous','Simple','Kerberos']]`

Authentication type for the LDAP server.* Anonymous - Anonymous authentication means no authentication occurs and the NAS Server uses an anonymous login to access the LDAP-based directory server.* Simple - Simple authentication means the NAS Server must provide a bind distinguished name and password to access the LDAP-based directory server.* Kerberos - Kerberos authentication means the NAS Server uses a KDC to confirm the identity when accessing the Active Directory.

##### `base_dn`

Data type: `Optional[String[3,255]]`

Name of the LDAP base DN. Base Distinguished Name (BDN) of the root of the LDAP directory tree. The appliance uses the DN to bind to the LDAP service and locate in the LDAP directory tree to begin a search for information.  The base DN can be expressed as a fully-qualified domain name or in X.509 format by using the attribute dc=. For example, if the fully-qualified domain name is mycompany.com, the base DN is expressed as dc=mycompany,dc=com.

##### `bind_dn`

Data type: `Optional[String[0,1023]]`

Bind Distinguished Name (DN) to be used when binding.

##### `bind_password`

Data type: `Optional[String[0,1023]]`

The associated password to be used when binding to the server.

##### `id`

Data type: `String`

Unique identifier of the LDAP settings object id.

##### `is_smb_account_used`

Data type: `Optional[Boolean]`

Indicates whether SMB authentication is used to authenticate to the LDAP server. Values are:     * true - Indicates that the SMB settings are used for Kerberos authentication.    * false - Indicates that Kerberos uses its own settings.

##### `is_verify_server_certificate`

Data type: `Optional[Boolean]`

Indicates whether Certification Authority certificate is used to verify the LDAP server certificate for secure SSL connections. Values are: * true - verifies LDAP server's certificate. * false - doesn't verify LDAP server's certificate.

##### `password`

Data type: `Optional[String[0,1023]]`

The associated password for Kerberos authentication.

##### `port_number`

Data type: `Optional[Integer[0,65536]]`

The TCP/IP port used by the NAS Server to connect to the LDAP servers.

##### `principal`

Data type: `Optional[String[0,1023]]`

Specifies the principal name for Kerberos authentication.

##### `profile_dn`

Data type: `Optional[String[0,255]]`

For an iPlanet LDAP server, specifies the DN of the entry with the configuration profile.

##### `protocol`

Data type: `Optional[Enum['LDAP','LDAPS']]`

Indicates whether the LDAP protocol uses SSL for secure network communication. SSL encrypts data over the network and provides message and server authentication.* LDAP - LDAP protocol without SSL.* LDAPS - (Default) LDAP protocol with SSL. When you enable LDAPS, make sure to specify the appropriate LDAPS port (usually port 636) and to upload an LDAPS trust certificate to the LDAP server.

##### `realm`

Data type: `Optional[String[0,255]]`

Specifies the realm name for Kerberos authentication.

##### `remove_addresses`

Data type: `Optional[Array[String]]`

IP addresses to remove from the current server IP addresses list. The addresses may be IPv4 or IPv6. Error occurs if an IP address does not exist in the addresses_list. Cannot be combined with addresses.

### `file_ldap_upload_certificate`

The file_ldap_upload_certificate task.

**Supports noop?** false

#### Parameters

##### `body`

Data type: `String`



##### `id`

Data type: `String`

Unique identifier of the LDAP settings object.

### `file_ldap_upload_config`

The file_ldap_upload_config task.

**Supports noop?** false

#### Parameters

##### `body`

Data type: `String`



##### `id`

Data type: `String`

Unique identifier of the LDAP settings object.

### `file_ndmp_collection_query`

List configured NDMP service instances.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `file_ndmp_create`

Add an NDMP service configuration to a NAS server. Only one NDMP service object can be configured per NAS server.

**Supports noop?** false

#### Parameters

##### `nas_server_id`

Data type: `String`

Unique identifier of the NAS server to be configured with these NDMP settings.

##### `password`

Data type: `String`

Password for the NDMP service user.

##### `user_name`

Data type: `String`

User name for accessing the NDMP service.

### `file_ndmp_delete`

Delete an NDMP service configuration instance of a NAS Server.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the NDMP service object.

### `file_ndmp_instance_query`

Query an NDMP service configuration instance.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the NDMP service object.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `file_ndmp_modify`

Modify an NDMP service configuration instance.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the NDMP service object.

##### `password`

Data type: `Optional[String]`

Password for the NDMP service user.

##### `user_name`

Data type: `Optional[String]`

User name for accessing the NDMP service.

### `file_nis_collection_query`

Query the NIS settings of NAS Servers.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `file_nis_create`

Create a new NIS Service on a NAS Server. Only one NIS Setting object can be created per NAS Server.

**Supports noop?** false

#### Parameters

##### `domain`

Data type: `String[1,255]`

Name of the NIS domain.

##### `ip_addresses`

Data type: `Array[String]`

The list of NIS server IP addresses.

##### `nas_server_id`

Data type: `String`

Unique identifier of the associated NAS Server instance that uses this NIS Service object.  Only one NIS Service per NAS Server is supported.

### `file_nis_delete`

Delete NIS settings of a NAS Server.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the NIS object.

### `file_nis_instance_query`

Query a specific NIS settings object of a NAS Server.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the NIS object.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `file_nis_modify`

Modify the NIS settings of a NAS Server.

**Supports noop?** false

#### Parameters

##### `add_ip_addresses`

Data type: `Optional[Array[String]]`

IP addresses to add to the current list. The addresses may be IPv4 or IPv6. Error occurs if the IP address already exists. Cannot be combined with ip_addresses.

##### `domain`

Data type: `Optional[String[1,255]]`

Name of the NIS domain.

##### `id`

Data type: `String`

Unique identifier of the NIS object.

##### `ip_addresses`

Data type: `Optional[Array[String]]`

A new list of NIS server IP addresses to replace the existing list. The addresses may be IPv4 or IPv6.

##### `remove_ip_addresses`

Data type: `Optional[Array[String]]`

IP addresses to remove from the current list. The addresses may be IPv4 or IPv6. Error occurs if the IP address is not present. Cannot be combined with ip_addresses.

### `file_system_clone`

Create a clone of a file system.

**Supports noop?** false

#### Parameters

##### `access_policy`

Data type: `Optional[Enum['Native','UNIX','Windows']]`

File system security access policies. Each file system uses its access policy to determine how to reconcile the differences between NFS and SMB access control. Selecting an access policy determines which mechanism is used to enforce file security on the particular file system. * Native - Native Security. * UNIX - UNIX Security. * Windows - Windows Security.

##### `description`

Data type: `Optional[String[0,255]]`

Description of the clone.

##### `folder_rename_policy`

Data type: `Optional[Enum['All_Allowed','SMB_Forbidden','All_Forbidden']]`

File system folder rename policies for the file system with multiprotocol access enabled. These policies control whether the directory can be renamed from NFS or SMB clients when at least one file is opened in the directory, or in one of its child directories. * All_Allowed - All protocols are allowed to rename directories without any restrictions. * SMB_Forbidden - A directory rename from the SMB protocol will be denied if at least one file is opened in the directory or in one of its child directories. * All_Forbidden - Any directory rename request will be denied regardless of the protocol used, if at least one file is opened in the directory or in one of its child directories.

##### `id`

Data type: `String`

File system id.

##### `is_async_m_time_enabled`

Data type: `Optional[Boolean]`

Indicates whether asynchronous MTIME is enabled on the file system. Values are:* true - Asynchronous MTIME is enabled on the file system.* false - Asynchronous MTIME is disabled on the file system.

##### `is_smb_no_notify_enabled`

Data type: `Optional[Boolean]`

Indicates whether notifications of changes to directory file structure are enabled.* true - Change directory notifications are enabled.* false - Change directory notifications are disabled.                      

##### `is_smb_notify_on_access_enabled`

Data type: `Optional[Boolean]`

Indicates whether file access notifications are enabled on the file system. Values are:* true - File system notifications are enabled on the file system.* false - File system notifications are disabled on the file system.

##### `is_smb_notify_on_write_enabled`

Data type: `Optional[Boolean]`

Indicates whether file writes notifications are enabled on the file system. Values are:* true - File writes notifications are enabled on the file system.* false - File writes notifications are disabled on the file system.

##### `is_smb_op_locks_enabled`

Data type: `Optional[Boolean]`

Indicates if opportunistic file locking is enabled on the file system. Values are:* true - Opportunistic file locking is enabled on the file system.* false - Opportunistic file locking is disabled on the file system.

##### `is_smb_sync_writes_enabled`

Data type: `Optional[Boolean]`

Indicates whether the synchronous writes option is enabled on the file system. Values are:* true - Synchronous writes option is enabled on the file system.* false - Synchronous writes option is disabled on the file system.

##### `locking_policy`

Data type: `Optional[Enum['Advisory','Mandatory']]`

File system locking policies. These policy choices control whether the NFSv4 range locks are honored. Because NFSv3 is advisory by design, this policy specifies that the NFSv4 locking feature behaves like NFSv3 (advisory mode), for backward compatiblity with applications expecting an advisory locking scheme.   * Advisory - No lock checking for NFS and honor SMB lock range only for SMB. * Mandatory - Honor SMB and NFS lock range.

##### `name`

Data type: `String[1,255]`

Name of the clone.

##### `smb_notify_on_change_dir_depth`

Data type: `Optional[Integer[1,512]]`

Lowest directory level to which the enabled notifications apply, if any.

### `file_system_collection_query`

List file systems.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `file_system_create`

Create a file system.

**Supports noop?** false

#### Parameters

##### `access_policy`

Data type: `Optional[Enum['Native','UNIX','Windows']]`

File system security access policies. Each file system uses its access policy to determine how to reconcile the differences between NFS and SMB access control. Selecting an access policy determines which mechanism is used to enforce file security on the particular file system. * Native - Native Security. * UNIX - UNIX Security. * Windows - Windows Security.

##### `description`

Data type: `Optional[String[0,255]]`

File system description. (255 UTF-8 characters).

##### `folder_rename_policy`

Data type: `Optional[Enum['All_Allowed','SMB_Forbidden','All_Forbidden']]`

File system folder rename policies for the file system with multiprotocol access enabled. These policies control whether the directory can be renamed from NFS or SMB clients when at least one file is opened in the directory, or in one of its child directories. * All_Allowed - All protocols are allowed to rename directories without any restrictions. * SMB_Forbidden - A directory rename from the SMB protocol will be denied if at least one file is opened in the directory or in one of its child directories. * All_Forbidden - Any directory rename request will be denied regardless of the protocol used, if at least one file is opened in the directory or in one of its child directories.

##### `is_async_m_time_enabled`

Data type: `Optional[Boolean]`

Indicates whether asynchronous MTIME is enabled on the file system or protocol snaps that are mounted writeable. Values are:* true - Asynchronous MTIME is enabled on the file system.* false - Asynchronous MTIME is disabled on the file system.

##### `is_smb_no_notify_enabled`

Data type: `Optional[Boolean]`

Indicates whether notifications of changes to directory file structure are enabled.* true - Change directory notifications are enabled.* false - Change directory notifications are disabled.                      

##### `is_smb_notify_on_access_enabled`

Data type: `Optional[Boolean]`

Indicates whether file access notifications are enabled on the file system. Values are:* true - File access notifications are enabled on the file system.* false - File access notifications are disabled on the file system.

##### `is_smb_notify_on_write_enabled`

Data type: `Optional[Boolean]`

Indicates whether file writes notifications are enabled on the file system. Values are:* true - File writes notifications are enabled on the file system.* false - File writes notifications are disabled on the file system.

##### `is_smb_op_locks_enabled`

Data type: `Optional[Boolean]`

Indicates whether opportunistic file locking is enabled on the file system. Values are:* true - Opportunistic file locking is enabled on the file system.* false - Opportunistic file locking is disabled on the file system.

##### `is_smb_sync_writes_enabled`

Data type: `Optional[Boolean]`

Indicates whether the synchronous writes option is enabled on the file system. Values are:* true - Synchronous writes option is enabled on the file system.* false - Synchronous writes option is disabled on the file system.

##### `locking_policy`

Data type: `Optional[Enum['Advisory','Mandatory']]`

File system locking policies. These policy choices control whether the NFSv4 range locks are honored. Because NFSv3 is advisory by design, this policy specifies that the NFSv4 locking feature behaves like NFSv3 (advisory mode), for backward compatiblity with applications expecting an advisory locking scheme.   * Advisory - No lock checking for NFS and honor SMB lock range only for SMB. * Mandatory - Honor SMB and NFS lock range.

##### `name`

Data type: `String[1,255]`

Name of the file system. (255 UTF-8 characters).

##### `nas_server_id`

Data type: `String`

Id of the NAS Server on which the file system is mounted.

##### `protection_policy_id`

Data type: `Optional[String]`

Id of the protection policy applied to the file system.

##### `size_total`

Data type: `Integer[3221225472,281474976710656]`

Size that the file system presents to the host or end user. (Bytes)

##### `smb_notify_on_change_dir_depth`

Data type: `Optional[Integer[1,512]]`

Lowest directory level to which the enabled notifications apply, if any.

### `file_system_delete`

Delete a file system.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

File system id.

### `file_system_instance_query`

Query a specific file system.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

File system id.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `file_system_modify`

Modify a file system.

**Supports noop?** false

#### Parameters

##### `access_policy`

Data type: `Optional[Enum['Native','UNIX','Windows']]`

File system security access policies. Each file system uses its access policy to determine how to reconcile the differences between NFS and SMB access control. Selecting an access policy determines which mechanism is used to enforce file security on the particular file system. * Native - Native Security. * UNIX - UNIX Security. * Windows - Windows Security.

##### `default_hard_limit`

Data type: `Optional[Integer[0,9223372036854775807]]`

Default hard limit of user quotas and tree quotas (bytes). The hard limit value is always rounded up to match the file system's physical block size.(0 means 'No limitation'. This value can be used to compute the amount of space consumed without limiting the space).

##### `default_soft_limit`

Data type: `Optional[Integer[0,9223372036854775807]]`

Default soft limit of user quotas and tree quotas (bytes). Value is always rounded up to match the file system's physical block size.(0 means 'No limitation'.)

##### `description`

Data type: `Optional[String[0,255]]`

File system description. (255 UTF-8 characters).

##### `expiration_timestamp`

Data type: `Optional[String]`

Time when the snapshot will expire. Use 1970-01-01T00:00:00.000Z to set expiration timestamp to null.

##### `folder_rename_policy`

Data type: `Optional[Enum['All_Allowed','SMB_Forbidden','All_Forbidden']]`

File system folder rename policies for the file system with multiprotocol access enabled. These policies control whether the directory can be renamed from NFS or SMB clients when at least one file is opened in the directory, or in one of its child directories. * All_Allowed - All protocols are allowed to rename directories without any restrictions. * SMB_Forbidden - A directory rename from the SMB protocol will be denied if at least one file is opened in the directory or in one of its child directories. * All_Forbidden - Any directory rename request will be denied regardless of the protocol used, if at least one file is opened in the directory or in one of its child directories.

##### `grace_period`

Data type: `Optional[Integer[-1,2147483647]]`

Grace period of soft limits (seconds): -1: default: Infinite grace (Windows policy).  0: Use system default of 1 week. positive: Grace period after which the soft limit is treated as a hard limit (seconds).

##### `id`

Data type: `String`

File system id.

##### `is_async_m_time_enabled`

Data type: `Optional[Boolean]`

Indicates whether asynchronous MTIME is enabled on the file system or protocol snaps that are mounted writeable. Values are:* true - Asynchronous MTIME is enabled on the file system.* false - Asynchronous MTIME is disabled on the file system.

##### `is_quota_enabled`

Data type: `Optional[Boolean]`

Indicates whether quota is enabled. Quotas are not supported for read-only file systems. Default value for the grace period is set to infinite=-1 to match Windows' quota policyValues are:* true - Start tracking usages for all users on a file system or a quota tree, and user quota limits will be enforced.* false - Stop tracking usages for all users on a file system or a quota tree, and user quota limits will not be enforced.

##### `is_smb_no_notify_enabled`

Data type: `Optional[Boolean]`

Indicates whether notifications of changes to a directory file structure are enabled. Values are:* true - Change directory notifications are enabled.* false - Change directory notifications are disabled.

##### `is_smb_notify_on_access_enabled`

Data type: `Optional[Boolean]`

Indicates whether file access notifications are enabled on the file system. Values are:* true - File access notifications are enabled on the file system.* false - File access notifications on file access are disabled on the file system.

##### `is_smb_notify_on_write_enabled`

Data type: `Optional[Boolean]`

Indicates whether notifications on file writes are enabled on the file system. Values are:* true - File writes notifications are enabled on the file system.* false - File writes notifications are disabled on the file system.

##### `is_smb_op_locks_enabled`

Data type: `Optional[Boolean]`

Indicates whether opportunistic file locking is enabled on the file system. Values are:* true - Opportunistic file locking is enabled on the file system.* false - Opportunistic file locking is disabled on the file system.

##### `is_smb_sync_writes_enabled`

Data type: `Optional[Boolean]`

Indicates whether the synchronous writes option is enabled on the file system. Values are:* true - Synchronous writes option is enabled on the file system.* false - Synchronous writes option is disabled on the file system.

##### `locking_policy`

Data type: `Optional[Enum['Advisory','Mandatory']]`

File system locking policies. These policy choices control whether the NFSv4 range locks are honored. Because NFSv3 is advisory by design, this policy specifies that the NFSv4 locking feature behaves like NFSv3 (advisory mode), for backward compatiblity with applications expecting an advisory locking scheme.   * Advisory - No lock checking for NFS and honor SMB lock range only for SMB. * Mandatory - Honor SMB and NFS lock range.

##### `protection_policy_id`

Data type: `Optional[String]`

Id of the protection policy applied to the file system.

##### `size_total`

Data type: `Optional[Integer[3221225472,281474976710656]]`

Size, in bytes, presented to the host or end user. This can be used for both expand and shrink on a file system.

##### `smb_notify_on_change_dir_depth`

Data type: `Optional[Integer[1,512]]`

Lowest directory level to which the enabled notifications apply, if any.

### `file_system_refresh`

Refresh a snapshot of a file system. The content of the snapshot is replaced with the current content of the parent file system.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

File system snapshot id.

### `file_system_refresh_quota`

Refresh the actual content of tree and user quotas objects.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

File system id.

### `file_system_restore`

Restore from a snapshot of a file system.

**Supports noop?** false

#### Parameters

##### `copy_name`

Data type: `Optional[String[1,255]]`

Name of the backup snap to be created before the Restore operation occurs.  If no name is specified no backup copy will be made.

##### `id`

Data type: `String`

File system snapshot id.

### `file_system_snapshot`

Create a snapshot of a file system.

**Supports noop?** false

#### Parameters

##### `access_policy`

Data type: `Optional[Enum['Native','UNIX','Windows']]`

File system security access policies. Each file system uses its access policy to determine how to reconcile the differences between NFS and SMB access control. Selecting an access policy determines which mechanism is used to enforce file security on the particular file system. * Native - Native Security. * UNIX - UNIX Security. * Windows - Windows Security.

##### `access_type`

Data type: `Optional[Enum['Snapshot','Protocol']]`

Indicates whether the snapshot directory or protocol access is granted to the file system snapshot.* Snapshot- Snapshot access is via the .snapshot folder in the file system.* Protocol - Protocol access is via normal file shares. Protocol access is not provided by default - the NFS and/or SMB share must be created explicitly for the snapshot.

##### `description`

Data type: `Optional[String[0,255]]`

Snapshot description

##### `expiration_timestamp`

Data type: `Optional[String]`

Time, when the snapshot will expire.

##### `folder_rename_policy`

Data type: `Optional[Enum['All_Allowed','SMB_Forbidden','All_Forbidden']]`

File system folder rename policies for the file system with multiprotocol access enabled. These policies control whether the directory can be renamed from NFS or SMB clients when at least one file is opened in the directory, or in one of its child directories. * All_Allowed - All protocols are allowed to rename directories without any restrictions. * SMB_Forbidden - A directory rename from the SMB protocol will be denied if at least one file is opened in the directory or in one of its child directories. * All_Forbidden - Any directory rename request will be denied regardless of the protocol used, if at least one file is opened in the directory or in one of its child directories.

##### `id`

Data type: `String`

File system id.

##### `is_async_m_time_enabled`

Data type: `Optional[Boolean]`

Indicates whether asynchronous MTIME is enabled on the protocol snaps that are mounted writeable. Values are:* true - Asynchronous MTIME is enabled on the file system.* false - Asynchronous MTIME is disabled on the file system.        

##### `is_auto_delete_enabled`

Data type: `Optional[Boolean]`

Indicates whether the snapshot can be automatically deleted per threshold settings. Values are:* true - Snapshot can be automatically deleted per threshold settings.* false - Snapshot cannot be automatically deleted.

##### `is_smb_no_notify_enabled`

Data type: `Optional[Boolean]`

Indicates whether notifications of changes to a directory file structure are enabled.* true - Change directory notifications are enabled.* false - Change directory notifications are disabled.                      

##### `is_smb_notify_on_access_enabled`

Data type: `Optional[Boolean]`

Indicates whether file access notifications are enabled on the file system. Values are:* true - File access notifications are enabled on the file system.* false - File access notifications are disabled on the file system.

##### `is_smb_notify_on_write_enabled`

Data type: `Optional[Boolean]`

Indicates whether file writes notifications are enabled on the file system. Values are:* true - File writes notifications are enabled on the file system.* false - File writes notifications are disabled on the file system.

##### `is_smb_op_locks_enabled`

Data type: `Optional[Boolean]`

Indicates whether opportunistic file locking is enabled on the file system. Values are:* true - Opportunistic file locking is enabled on the file system.* false - Opportunistic file locking is disabled on the file system.

##### `is_smb_sync_writes_enabled`

Data type: `Optional[Boolean]`

Indicates whether the synchronous writes option is enabled on the file system. Values are:* true - Synchronous writes option is enabled on the file system.* false - Synchronous writes option is disabled on the file system.

##### `locking_policy`

Data type: `Optional[Enum['Advisory','Mandatory']]`

File system locking policies. These policy choices control whether the NFSv4 range locks are honored. Because NFSv3 is advisory by design, this policy specifies that the NFSv4 locking feature behaves like NFSv3 (advisory mode), for backward compatiblity with applications expecting an advisory locking scheme.   * Advisory - No lock checking for NFS and honor SMB lock range only for SMB. * Mandatory - Honor SMB and NFS lock range.

##### `name`

Data type: `Optional[String[1,255]]`

Name of the snapshot. The default name of the snapshot is the date and time when the snapshot is taken.

##### `smb_notify_on_change_dir_depth`

Data type: `Optional[Integer[1,512]]`

Lowest directory level to which the enabled notifications apply, if any.

### `file_tree_quota_collection_query`

List tree quota instances.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `file_tree_quota_create`

Create a tree quota instance.

**Supports noop?** false

#### Parameters

##### `description`

Data type: `Optional[String]`

Description of the tree quota.

##### `file_system_id`

Data type: `String`

Unique identifier of the associated file system.

##### `hard_limit`

Data type: `Optional[Integer[0,9223372036854775807]]`

Hard limit of the tree quota, in bytes. No hard limit when set to 0. This value can be used to compute amount of space that is consumed without limiting the space. Value is always rounded up to match the physical block size of the filesystem.

##### `is_user_quotas_enforced`

Data type: `Optional[Boolean]`

Whether the quota must be enabled for all users, and whether user quota limits, if any, are enforced.Values are:- true - start tracking usage for all users on the quota tree, and enforce user quota limits.- false - stop tracking usage for all users on the quota tree, and do not enforce user quota limits.

##### `path`

Data type: `String`

Path relative to the root of the associated filesystem.

##### `soft_limit`

Data type: `Optional[Integer[0,9223372036854775807]]`

Soft limit of the tree quota, in bytes. No hard limit when set to 0. Value is always rounded up to match the physical block size of the filesystem.

### `file_tree_quota_delete`

Delete a tree quota instance.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the tree quota.

### `file_tree_quota_instance_query`

Query a tree quota instance.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the tree quota.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `file_tree_quota_modify`

Modify a tree quota instance.

**Supports noop?** false

#### Parameters

##### `description`

Data type: `Optional[String]`

Description of the tree quota.

##### `hard_limit`

Data type: `Optional[Integer[0,9223372036854775807]]`

Hard limit of the tree quota, in bytes. No hard limit when set to 0. This value can be used to compute amount of space that is consumed without limiting the space. Value is always rounded up to match the physical block size of the filesystem.

##### `id`

Data type: `String`

Unique identifier of the tree quota.

##### `is_user_quotas_enforced`

Data type: `Optional[Boolean]`

Whether the quota must be enabled for all users, and whether user quota limits, if any, are enforced.Values are:- true - start tracking usage for all users on the quota tree, and enforce user quota limits.- false - stop tracking usage for all users on the quota tree, and do not enforce user quota limits.

##### `soft_limit`

Data type: `Optional[Integer[0,9223372036854775807]]`

Soft limit of the tree quota, in bytes. No hard limit when set to 0. Value is always rounded up to match the physical block size of the filesystem.

### `file_tree_quota_refresh`

Refresh the cache with the actual value of the tree quota.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the tree quota.

### `file_user_quota_collection_query`

List user quota instances.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `file_user_quota_create`

Create a user quota instance.

**Supports noop?** false

#### Parameters

##### `file_system_id`

Data type: `String`

Unique identifier of the filesystem in which the new user quota will be created.

##### `hard_limit`

Data type: `Optional[Integer[0,9223372036854775807]]`

Hard limit of the user quota, in bytes. No hard limit when set to 0. This value can be used to compute amount of space that is consumed without limiting the space. Value is rounded up to match the physical block size of the filesystem.

##### `soft_limit`

Data type: `Optional[Integer[0,9223372036854775807]]`

Soft limit of the user quota, in bytes. No hard limit when set to 0. Value is rounded up to match the physical block size of the filesystem.

##### `tree_quota_id`

Data type: `Optional[String]`

Unique identifier of the tree quota in which the new user quota will be created.

##### `uid`

Data type: `Optional[Integer[1,4294967294]]`

Unix user identifier (UID) of the user. Preferred identifier.

##### `unix_name`

Data type: `Optional[String]`

Unix username. Identifers are exclusive. Only one of the four identifiers among 'user uid' / 'unix username' / 'windows username' / 'windows SID' can be used at a time.

##### `windows_name`

Data type: `Optional[String]`

Windows username. The format is domain\\user for the domain user. Identifers are exclusive. Only one of the four identifiers among 'user uid' / 'unix username' / 'windows username' / 'windows SID' can be used at a time.

##### `windows_sid`

Data type: `Optional[String]`

Windows Security Identifier of the user. Identifers are exclusive. Only one of the four identifiers among 'user uid' / 'unix username' / 'windows username' / 'windows SID' can be used at a time.

### `file_user_quota_instance_query`

Query a user quota instance.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the file user quota.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `file_user_quota_modify`

Modify a user quota instance.

**Supports noop?** false

#### Parameters

##### `hard_limit`

Data type: `Optional[Integer[0,9223372036854775807]]`

Hard limit of the user quota, in bytes. No hard limit when set to 0. This value can be used to compute amount of space that is consumed without limiting the space. Value is rounded up to match the physical block size of the filesystem.

##### `id`

Data type: `String`

Unique identifier of the file user quota.

##### `soft_limit`

Data type: `Optional[Integer[0,9223372036854775807]]`

Soft limit of the user quota, in bytes. No hard limit when set to 0. Value is rounded up to match the physical block size of the filesystem.

### `file_user_quota_refresh`

Refresh the cache with the actual value of the user quota.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the file user quota.

### `file_virus_checker_collection_query`

Query all virus checker settings of the NAS Servers.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `file_virus_checker_create`

Add a new virus checker setting to a NAS Server. Only one instance can be created per NAS Server.Workflow to enable the virus checker settings on the NAS Server is as follows: \n1. Create a virus checker instance on NAS Server.2. Download template virus checker configuration file.3. Edit the configuration file with virus checker configuration details.4. Upload the configuration file.5. Enable the virus checker on the NAS Server.

**Supports noop?** false

#### Parameters

##### `nas_server_id`

Data type: `String`

Unique identifier of an associated NAS Server instance that uses this virus checker configuration. Only one virus checker configuration per NAS Server is supported.

### `file_virus_checker_delete`

Delete virus checker settings of a NAS Server.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the virus checker instance.

### `file_virus_checker_download_config`

Download a virus checker configuration file containing the template or the actual (if already uploaded) virus checker configuration settings.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the virus checker instance.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `file_virus_checker_instance_query`

Query a specific virus checker setting of a NAS Server.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the virus checker instance.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `file_virus_checker_modify`

Modify the virus checker settings of a NAS Server.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the virus checker instance.

##### `is_enabled`

Data type: `Boolean`

Indicates whether the anti-virus service is enabled on this NAS server. Value are:- true - Anti-virus service is enabled. Each file created or modified by an SMB client is scanned by the third-party anti-virus servers. If a virus is detected, the access to the file system is denied. If third-party anti-virus servers are not available, according the policy, the access to the file systems is denied to prevent potential viruses propagation.- false - Anti-virus service is disabled. File systems of the NAS servers are available for access without virus checking.

### `file_virus_checker_upload_config`

Upload a virus checker configuration file containing the virus checker configuration settings.

**Supports noop?** false

#### Parameters

##### `body`

Data type: `Optional[String]`

Upload virus checker configuration file.

##### `id`

Data type: `String`

Unique identifier of the virus checker instance.

### `hardware_collection_query`

List hardware components.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `hardware_drive_repurpose`

A drive that has been used in a different appliance will be locked for use only in that appliance. This operation will allow a locked drive to be used in the current appliance. All data on the drive will become unrecoverable. It will fail if the drive is not locked to a different appliance.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Identifier of the drive to repurpose.

##### `psid`

Data type: `String`

An alpha-numeric string that can be found on the physical label of the drive to repurpose. This is needed to validate that the user has physical control of the drive before performing the operation.

### `hardware_instance_query`

Get a specific hardware component instance.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique id of hardware component to get.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `hardware_modify`

Modify a hardware instance.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

The hardware component to modify.

##### `is_marked`

Data type: `Boolean`

New state for the hardware component location marker LED. Setting it to true will put the LED in a blinking state until set to false. Note that the state returned in the hardware component may not actually change for up to 60 seconds. This operation is currently supported for Base_Enclosure, Expansion_Enclosure, Node and Drive. Note that operations at the Base_Enclosure and Expansion_Enclosure apply to their children (Nodes and Drives for Base_Enclosure and Drives for Expansion_Enclosure). For components with a single physical LED (Base_Enclosure and Node), setting is_marked=true overrides the status_led_state property from on (or off) to Null, and setting is_marked=false reverts status_led_state to showing the state of the physical LED.

### `host_attach`

Attach host to volume.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique id of the host.

##### `logical_unit_number`

Data type: `Optional[Integer[0,16383]]`

Logical unit number for the volume, if desired.

##### `volume_id`

Data type: `String`

Volume to attach.

### `host_collection_query`

List host information.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `host_create`

Add a host.

**Supports noop?** false

#### Parameters

##### `description`

Data type: `Optional[String[0,256]]`

An optional description for the host. The description should not be more than 256 UTF-8 characters long and should not have any unprintable characters.

##### `initiators`

Data type: `Array[Struct[{Optional[chap_mutual_password] => Optional[String[12,64]], Optional[chap_mutual_username] => Optional[String[1,64]], Optional[chap_single_password] => Optional[String[12,64]], Optional[chap_single_username] => Optional[String[1,64]], port_name => Optional[String], port_type => Optional[Enum['iSCSI','FC']], }]]`



##### `name`

Data type: `String[0,128]`

The host name. The name should not be more than 128 UTF-8 characters long and should not have any unprintable characters.

##### `os_type`

Data type: `Enum['Windows','Linux','ESXi','AIX','HP-UX','Solaris']`

Operating system of the host.

### `host_delete`

Delete a host. Delete fails if host is attached to a volume or consistency group.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique id of the host.

### `host_detach`

Detach host from volume.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique id of the host.

##### `volume_id`

Data type: `String`

Volume to detach.

### `host_group_attach`

Attach host group to volume.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique id of the host group.

##### `logical_unit_number`

Data type: `Optional[Integer[0,16383]]`

Logical unit number for the volume, if desired.

##### `volume_id`

Data type: `String`

Volume to attach.

### `host_group_collection_query`

List host groups.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `host_group_create`

Create a host group.

**Supports noop?** false

#### Parameters

##### `description`

Data type: `Optional[String[0,256]]`

An optional description for the host group. The description should not have any unprintable characters.

##### `host_ids`

Data type: `Array[String]`



##### `name`

Data type: `String[0,128]`

The host group name. The name should not be more than 128 UTF-8 characters long and should not have any unprintable characters.

### `host_group_delete`

Delete a host group. Delete fails if host group is attached to a volume.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique id of the host group.

### `host_group_detach`

Detach host group from volume.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique id of the host group.

##### `volume_id`

Data type: `String`

Volume to detach.

### `host_group_instance_query`

Get details about a specific host group.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique id of the host group.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `host_group_modify`

Operations that can be performed are modify name, remove host(s) from host group, add host(s) to host group. Modify request will only support either a add_host(s) or remove_host(s) at a time along with modifying host name

**Supports noop?** false

#### Parameters

##### `add_host_ids`

Data type: `Optional[Array[String]]`

List of hosts to be added to host group. The operation fails if the host(s) to be added are attached to volume.

##### `description`

Data type: `Optional[String[0,256]]`

An optional description for the host group. The description should not be more than 256 UTF-8  characters long and should not have any unprintable characters.

##### `id`

Data type: `String`

Unique id of the host group.

##### `name`

Data type: `Optional[String[0,128]]`

A new host group name. The name should not be more than 128 UTF-8 characters long and should not have any unprintable characters.

##### `remove_host_ids`

Data type: `Optional[Array[String]]`

List of hosts to be removed from the host group. The operation fails if host group is attached to volume.

### `host_instance_query`

Get details about a specific host by id.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique id of the host.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `host_modify`

Operation that can be performed are modify name, modify description, remove initiator(s) from host, add initiator(s) to host, update existing initiator(s) with chap username/password. This will only support one of add, remove and update initiator operations in a single request.

**Supports noop?** false

#### Parameters

##### `add_initiators`

Data type: `Optional[Array[Struct[{Optional[chap_mutual_password] => Optional[String[12,64]], Optional[chap_mutual_username] => Optional[String[1,64]], Optional[chap_single_password] => Optional[String[12,64]], Optional[chap_single_username] => Optional[String[1,64]], port_name => Optional[String], port_type => Optional[Enum['iSCSI','FC']], }]]]`

The list of initiators to be added. CHAP username and password are optional.

##### `description`

Data type: `Optional[String[0,256]]`

An optional description for the host. The description should not be more than 256 UTF-8 characters long and should not have any unprintable characters.

##### `id`

Data type: `String`

Unique id of the host.

##### `modify_initiators`

Data type: `Optional[Array[Struct[{Optional[chap_mutual_password] => Optional[String[12,64]], Optional[chap_mutual_username] => Optional[String[1,64]], Optional[chap_single_password] => Optional[String[12,64]], Optional[chap_single_username] => Optional[String[1,64]], Optional[port_name] => Optional[String], }]]]`

Update list of existing initiators, identified by port_name, with new CHAP usernames and/or passwords.

##### `name`

Data type: `Optional[String[0,128]]`

The host name. The name should not be more than 128 UTF-8 characters long and should not have any unprintable characters.

##### `remove_initiators`

Data type: `Optional[Array[String]]`

The list of initiator port_names to be removed.

### `host_virtual_volume_mapping_collection_query`

Query associations between a virtual volume and the host(s) it is attached to.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `host_virtual_volume_mapping_instance_query`

Query a specific virtual volume mapping.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the virtual volume mapping.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `host_volume_mapping_collection_query`

Query associations between a volume and the host or host group it is attached to.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `host_volume_mapping_instance_query`

Query a specific host volume mapping.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the host volume mapping.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `import_host_initiator_collection_query`

Query import host initiators.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `import_host_initiator_instance_query`

Query a specific import host initiator instance.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the import host initiator to query.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `import_host_system_collection_query`

Query import host systems that are attached to volumes.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `import_host_system_create`

Add an import host system so that it can be mapped to a volume. Before mapping an import host system, ensure that a host agent is installed. Host agents can be installed on Linux, Windows, and ESXi host systems only.  While adding import_host_system if Host is not present a new Host shall be created. If Host is already present, the same Host will be updated with the import_host_system details.

**Supports noop?** false

#### Parameters

##### `agent_address`

Data type: `String`

Hostname or IPv4 address of the import host system.

##### `agent_port`

Data type: `Integer[0,65535]`

TCP port of the import host system.

##### `chap_mutual_password`

Data type: `Optional[String]`

Password for mutual CHAP authentication. This password is required when the cluster is using mutual authentication CHAP mode.

##### `chap_mutual_username`

Data type: `Optional[String]`

Username for mutual CHAP authentication. This username is required when the cluster is using mutual authentication CHAP mode.

##### `chap_single_password`

Data type: `Optional[String]`

Password for single CHAP authentication. This password is required when the cluster is using single authentication CHAP mode.

##### `chap_single_username`

Data type: `Optional[String]`

Username for single CHAP authentication. This username is required when the cluster is using single authentication CHAP mode.

##### `os_type`

Data type: `Enum['Windows','Linux','ESXi','Unknown']`

Operating system of the import host system. Valid values are: * Windows - Windows.  * Linux - Linux.  * ESXi - ESXi.  * Unknown - Operating system of the host system is unknown to PowerStore.

##### `password`

Data type: `String`

Password for the specified username.

##### `user_name`

Data type: `String`

Username for the import host system.

### `import_host_system_delete`

Delete an import host system. You cannot delete an import host system if there are import sessions active in the system referencing the import host system instance.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the import host system

### `import_host_system_instance_query`

Query a specific import host system instance.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the import host system to query.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `import_host_system_refresh`

Refresh the details of a specific import host system. Use this operation when there is a change to the import host or import host volumes.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the import host system for which to refresh details.

### `import_host_volume_collection_query`

Query import host volumes.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `import_host_volume_instance_query`

Query a specific import host volume instance.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the import host volume to query.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `import_psgroup_collection_query`

Query PS Group storage arrays.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `import_psgroup_discover`

Discover the importable volumes and snapshot schedules in the PS Group.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the PS Group.

### `import_psgroup_instance_query`

Query a specific PS Group storage array.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the PS Group.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `import_psgroup_volume_collection_query`

Query PS Group volumes.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `import_psgroup_volume_import_snapshot_schedules`

Return the snapshot schedules for a PS Group volume.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the PS Group volume.

### `import_psgroup_volume_instance_query`

Query a specific PS Group volume.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the PS Group volume.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `import_session_cancel`

Cancel an active import session. Cancel is allowed when the import is in a Scheduled, Queued, Copy_In_Progress, or Ready_For_Cutover state. After a successful cancellation, the host is mapped to original source volume, all paths are cleaned up, and the import state is Cancelled. The import can be attempted again in the future. In most cases, the Cancel operation gracefully rolls back the import based on the source and host error responses. Use the force option to stop the import job irrespective of whether the storage system or hosts have issues. When the force option is true, the import process tries to reach out to the source and host to gracefully terminate the import. If either are not reachable or if the request fails, the import is terminated without rolling back.

**Supports noop?** false

#### Parameters

##### `force`

Data type: `Optional[Boolean]`

Indicates whether the cancel import session operation is a normal cancel (true) or a forced stop (false). For a forced stop, the import job terminates without rolling back in source or host down failover scenarios.

##### `id`

Data type: `String`

Unique identifier of the import session

### `import_session_cleanup`

Clean up an import session that is in Cleanup_Required state and requires user intervention to revert the source volume to its pre-import state as part of the recovery procedure to restore host IO operations.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the import session.

### `import_session_collection_query`

Query import sessions.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `import_session_create`

Create a new import session. The source storage system and hosts that access the volumes or consistency groups must be added prior to creating an import session. The volumes or consistency groups must be in a migration-ready state.

**Supports noop?** false

#### Parameters

##### `automatic_cutover`

Data type: `Optional[Boolean]`

Indicates whether the import session cutover is manual (true) or automatic (false).

##### `description`

Data type: `Optional[String[0,128]]`

Description of the import session. The name can contain a maximum of 128 unicode characters. It cannot contain unprintable characters.

##### `name`

Data type: `String[0,128]`

Name of the import session. The name must be unique in the PowerStore cluster and can contain a maximum of 128 unicode characters. It cannot contain special HTTP characters, unprintable characters, or white space.

##### `protection_policy_id`

Data type: `Optional[String]`

Unique identifier of the protection policy that will be applied to an imported volume or consistency group after the import completes. Only snapshot policies are supported in an import. Once the import completes, you can add a replication policy. If you try to import a replication policy, the import job will fail.

##### `remote_system_id`

Data type: `String`

Unique identifier of the storage system that contains the source volume or consistency group to be imported. You can query the source volume or consistency group object to get the identifier of the source system that the volume or consistency group are part of. Alternatively, you can use the remote_system object to get this information.

##### `scheduled_timestamp`

Data type: `Optional[String]`

Date and time at which the import session is scheduled to start. The date time is specified in ISO 8601 format with the time expressed in UTC format.

##### `source_resource_id`

Data type: `String`

Unique identifier of the volume or consistency group to be imported. Refer to the following objects for more information: * Storage Center : import_storage_center_volume, import_storage_center_consistency_group * VNX : import_vnx_volume, import_vnx_consistency_group * PS Series : import_psgroup_volume * Unity : import_unity_volume, import_unity_consistency_group

##### `volume_group_id`

Data type: `Optional[String]`

Unique identifier of the volume group to which the imported volume will belong, if any.

### `import_session_cutover`

Commit an import session that is in a Ready_For_Cutover state. When the import session is created with the automatic_cutover attribute set to false, you must use the Cutover operation to complete the import. Until the cutover is complete, PowerStore forwards IO to the source volume to keep it in sync with all host IOs. You can cancel the import during this state if you want to continue using the source volume.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of an import session

### `import_session_delete`

Delete an import session that is in a Completed, Failed, or Cancelled state. Delete removes the historical record of the import. To stop active import sessions, use the Cancel operation. You can delete the import session after cancelling it.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the import session

### `import_session_instance_query`

Query a specific session.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the import session

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `import_session_modify`

Modify the scheduled date and time of the specified import session.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the import session.

##### `scheduled_timestamp`

Data type: `Optional[String]`

Indicates the new date and time at which the import session is scheduled to run. The date is specified in ISO 8601 format with time expressed in UTC format.

### `import_session_pause`

Pauses an ongoing import session. When this occurs, the background data copy stops, but IO to the source still occurs. Pause is only supported when the import job is in a in Copy_In_Progress state. You can resume or cancel the paused import.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the import session

### `import_session_resume`

Resumes the paused import session. The background data copy continues from where it was stopped. Resume is only applicable when the import in a Paused state.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the import session

### `import_storage_center_collection_query`

Query SC arrays.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `import_storage_center_consistency_group_collection_query`

Query SC consistency groups.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `import_storage_center_consistency_group_import_snapshot_profiles`

Return the snapshot profiles of an SC consistency group.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the SC consistency group.

### `import_storage_center_consistency_group_instance_query`

Query a specific SC consistency group.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the SC consistency group.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `import_storage_center_discover`

Discover the importable volumes and snapshot profiles in the SC array.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the SC array.

### `import_storage_center_instance_query`

Query a specific SC array.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the SC array.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `import_storage_center_volume_collection_query`

Query SC volumes.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `import_storage_center_volume_import_snapshot_profiles`

Return the snapshot profiles of an SC volume.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the SC volume.

### `import_storage_center_volume_instance_query`

Query a specific SC volume.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the SC volume.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `import_unity_collection_query`

Query Unity storage systems.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `import_unity_consistency_group_collection_query`

Query Unity consistency groups.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `import_unity_consistency_group_import_snapshot_schedules`

Return the snapshot schedules associated with the specified Unity consistency group.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the Unity consistency group.

### `import_unity_consistency_group_instance_query`

Query a specific Unity consistency group.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the Unity consistency group.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `import_unity_discover`

Discover the importable volumes and consistency groups in the Unity storage system.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the Unity storage system.

### `import_unity_instance_query`

Query a specific Unity storage system.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the Unity storage system.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `import_unity_volume_collection_query`

Query Unity volumes.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `import_unity_volume_import_snapshot_schedules`

Return the snapshot schedules associated with the specified Unity volume.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the Unity volume.

### `import_unity_volume_instance_query`

Query a specific Unity volume.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the Unity volume.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `import_vnx_array_collection_query`

Query VNX storage systems.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `import_vnx_array_discover`

Discover the importable volumes and consistency groups in a VNX storage system.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the VNX storage system.

### `import_vnx_array_instance_query`

Query a specific VNX storage system.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of a VNX storage system.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `import_vnx_consistency_group_collection_query`

Query VNX consistency groups.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `import_vnx_consistency_group_instance_query`

Query a specific VNX consistency group.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of a VNX consistency group.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `import_vnx_volume_collection_query`

Query VNX volumes.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `import_vnx_volume_instance_query`

Query a specific VNX volume.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the VNX volume.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `ip_pool_address_collection_query`

Query configured IP addresses.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `ip_pool_address_instance_query`

Query a specific IP address.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of a configured IP address.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `ip_port_collection_query`

Query IP port configurations.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `ip_port_instance_query`

Query a specific IP port configuration.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the IP port.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `ip_port_modify`

Modify IP port parameters.

**Supports noop?** false

#### Parameters

##### `add_current_usages`

Data type: `Optional[Array[Enum['Management','ISCSI','ISCSI_Default','External_Replication']]]`

Usages to add to the current usages of an IP port. The current usages of an IP port can be extended with external replication if this usage is in the port's list of available usages. The same settings will be applied to the partner IP port.WARNING: Only one IP port on each node can be assigned to the External_Replication usage. Assigning another IP port to this usage will automatically unassign the currently used IP port on the same node.To unassign an IP port from being used for external replication, choose another IP port and add External_Replication to its list of current usages.

##### `id`

Data type: `String`

Unique identifier of the IP port.

### `job_collectionquery`

Query jobs.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `job_instancequery`

Query a specific job.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique id of the job.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `keystore_archive_downloadakeystorebackuparchivefile`

Download a keystore backup archive file that was previously generated by a successful /api/rest/keystore_archive/regenerate POST command. This resource type collection query does not support filtering, sorting or pagination

**Supports noop?** false

#### Parameters

##### `filename`

Data type: `String`

Filename is the last component in the URI path and becomes the filename of the downloaded file.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `keystore_archive_regeneratearchivefile`

Creates a new encryption keystore archive file to replace the existing archive file, which includes the individual keystore backup files from each appliance in the cluster. Once complete, the command response includes a Uniform Resource Identifier, which can be used in a subsequent GET request to download the keystore backup archive file. This request is valid only on systems where Data at Rest Encryption is enabled and is applicable only on systems that support Data at Rest Encryption.

**Supports noop?** false

### `license_collection_query`

Query license information for the cluster. There is always one license instance.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `license_instance_query`

Query the specific license information for the cluster.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the license information instance.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `license_license_file_upload`

Upload a software license to install the license on the cluster.

**Supports noop?** false

#### Parameters

##### `license_file`

Data type: `Optional[String]`

The file to upload containing the software license to install the license on the cluster.

### `license_retrieve_license`

Retrieve the license directly from the DellEMC Software Licensing Central. This runs automatically when the cluster is configured, and if it fails, once per day during the trial period. This allows a manual attempt, normally after attempting to correct the network connectivity issue preventing the automatic retrieval.

**Supports noop?** false

### `local_user_collection_query`

Query all local user account instances. This resource type collection query does not support filtering, sorting or pagination

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `local_user_create`

Create a new local user account. Any existing local user with either an administrator or a security administrator role can create a new local user account. By default, a new local_user account is NOT locked.

**Supports noop?** false

#### Parameters

##### `name`

Data type: `String`

Name of the new local user account to be created. The name value can be 1 to 64 UTF-8 characters long, and may only use alphanumeric characters. Dot(.) is the only special character allowed.

##### `password`

Data type: `String`

Password for the new local user account to be created. The password value can be 8 to 40 UTF-8 characters long, and include as a minimum one uppercase character, one lowercase character, one numeric character, and one special character from this list  [!,@#$%^*>_~].

##### `role_id`

Data type: `String`

The unique identifier of the role to which the new local user will be mapped. Where role_id '1' is for Administrator, '2' is for Storage Administrator, '3' is for Operator, '4' is for VM Administrator and '5' is for Security Administrator roles.

### `local_user_delete`

Delete a local user account instance using the unique identifier. You cannot delete the default 'admin' account or the account you are currently logged into. Any local user account with Administrator or Security Administrator role can delete any other local user account except the default 'admin' account.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the local user account to be deleted.

### `local_user_instance_query`

Query a specific local user account instance using an unique identifier.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the local user account.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `local_user_modify`

Modify a property of a local user account using the unique identifier. You cannot modify the default 'admin' user account.

**Supports noop?** false

#### Parameters

##### `current_password`

Data type: `Optional[String]`

Current password of the local user. Any local user can change his own password by providing current_password along with the new password.

##### `id`

Data type: `String`

Unique identifier of the local user account to be modified.

##### `is_locked`

Data type: `Optional[Boolean]`

Lock or unlock the local user account. Local user with administration/security administration role can lock or unlock any other local user account. You cannot lock an account you are currently logged-in to.

##### `password`

Data type: `Optional[String]`

New password of the local user. Local user with administrator or security administrator role can reset the password of other local user accounts without providing the current password. You cannot reset the password of the account you are currently logged-in to.

##### `role_id`

Data type: `Optional[String]`

The unique identifier of the new role to which the local user has to be mapped. Where role_id '1' is for Administrator, '2' is for Storage Administrator, '3' is for Operator, '4' is for VM Administrator and '5' is for Security Administrator. A local user with either an administration or a security administration role can change the role of any other local user. You cannot change the role of the account you are currently logged-in to.

### `login_session_collection_query`

Obtain the login session for the current user. This resource type collection query does not support filtering, sorting or pagination

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `logout_logout`

Log out the current user.

**Supports noop?** false

### `maintenance_window_collection_query`

Query the maintenance window configurations.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `maintenance_window_instance_query`

Query one appliance maintenance window configuration.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the maintenance window configuration.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `maintenance_window_modify`

Configure maintenance window.

**Supports noop?** false

#### Parameters

##### `end_offset`

Data type: `Optional[Integer[0,172800]]`

Number of seconds from the current timestamp the maintenance window will expire. This value is required if is_enabled is passed as true, and may not be more than 172800 (48 hours).

##### `id`

Data type: `String`

Unique identifier of the maintenance window configuration.

##### `is_enabled`

Data type: `Optional[Boolean]`

Activate or deactivate the window for one appliance.

### `metrics_metrics`

Retrieves metrics for specified type.

**Supports noop?** false

#### Parameters

##### `entity`

Data type: `Enum['performance_metrics_by_appliance','performance_metrics_by_node','performance_metrics_by_volume','performance_metrics_by_cluster','performance_metrics_by_vm','performance_metrics_by_vg','performance_metrics_by_fe_fc_port','performance_metrics_by_fe_eth_port','performance_metrics_by_fe_eth_node','performance_metrics_by_fe_fc_node','wear_metrics_by_drive','space_metrics_by_cluster','space_metrics_by_appliance','space_metrics_by_volume','space_metrics_by_volume_family','space_metrics_by_vm','space_metrics_by_storage_container','space_metrics_by_vg','copy_metrics_by_appliance','copy_metrics_by_cluster','copy_metrics_by_vg','copy_metrics_by_remote_system','copy_metrics_by_volume','performance_metrics_by_file_system','performance_metrics_smb_by_node','performance_metrics_smb_builtinclient_by_node','performance_metrics_smb_branch_cache_by_node','performance_metrics_smb1_by_node','performance_metrics_smb1_builtinclient_by_node','performance_metrics_smb2_by_node','performance_metrics_smb2_builtinclient_by_node','performance_metrics_nfs_by_node','performance_metrics_nfsv3_by_node','performance_metrics_nfsv4_by_node']`

An enum describing the various entities supported by metrics.  * performance_metrics_by_appliance - Appliance performance metrics.  * performance_metrics_by_node - Node performance metrics.  * performance_metrics_by_volume - Volume performance metrics.  * performance_metrics_by_cluster - Cluster performance metrics.  * performance_metrics_by_vm - Virtual Machine performance metrics.  * performance_metrics_by_vg - Storage performance metrics for all volumes in a volume group  * performance_metrics_by_fe_fc_port - Frontend fibre channel port performance metrics.  * performance_metrics_by_fe_eth_port - Frontend ethernet port performance metrics.  * performance_metrics_by_fe_eth_node - Frontend ethernet performance metrics for node.  * performance_metrics_by_fe_fc_node - Frontend fibre channel performance metrics for node.  * wear_metrics_by_drive - Drive wear metrics.  * space_metrics_by_cluster - Cluster space metrics  * space_metrics_by_appliance - Appliance space metrics  * space_metrics_by_volume - Volume space metrics  * space_metrics_by_volume_family - Volume family space metrics  * space_metrics_by_vm - Virtual Machine space metrics  * space_metrics_by_storage_container - Storage Container space metrics  * space_metrics_by_vg - Volume space metrics in a volume group  * copy_metrics_by_appliance - Appliance copy metrics  * copy_metrics_by_cluster - Cluster copy metrics  * copy_metrics_by_vg - Copy metrics for each volume group  * copy_metrics_by_remote_system - Copy metrics for each remote system  * copy_metrics_by_volume - Copy metrics for each volume  * performance_metrics_by_file_system - Performance metrics for the file system.  * performance_metrics_smb_by_node - Performance metrics for the SMB protocol global  * performance_metrics_smb_builtinclient_by_node - Performance metrics for the SMB protocol built-in client  * performance_metrics_smb_branch_cache_by_node - Performance metrics for the SMB protocol Branch-Cache  * performance_metrics_smb1_by_node - Performance metrics for the SMB1 protocol basic  * performance_metrics_smb1_builtinclient_by_node - Performance metrics for the SMB1 protocol built-in client  * performance_metrics_smb2_by_node - Performance metrics for the SMB2 protocol basic  * performance_metrics_smb2_builtinclient_by_node - Performance metrics for the SMB2 protocol built-in client  * performance_metrics_nfs_by_node - Performance metrics for the NFS protocol  * performance_metrics_nfsv3_by_node - Performance metrics for the NFSv3 protocol  * performance_metrics_nfsv4_by_node - Performance metrics for the NFSv4 protocol

##### `entity_id`

Data type: `String`

Identifier for specific entity.

##### `interval`

Data type: `Optional[Enum['Twenty_Sec','Five_Mins','One_Hour','One_Day']]`

Intervals of which metrics can be provided.

### `migration_recommendation_collectionquery`

Get migration recommendations.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `migration_recommendation_create`

Generate a recommendation for redistributing storage utilization between appliances.

**Supports noop?** false

#### Parameters

##### `evacuate_appliance`

Data type: `Struct[{appliance_id => Optional[String], Optional[space_to_free] => Optional[Integer], Optional[target_appliance_ids] => Optional[Array[String]], }]`

Evacuate appliance by specifying optional space_to_free

### `migration_recommendation_create_migration_sessions`

Create the migration sessions to implement a migration recommendation. If the response contains a list of hosts to rescan, those hosts must be rescanned before starting the sessions or the host(s) may lose access to the data when the migration completes.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique ID of the migration recommendation.

### `migration_recommendation_delete`

Delete a migration recommendation.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique ID of the migration recommendation.

### `migration_recommendation_instancequery`

Get a single migration recommendation.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique ID of the migration recommendation.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `migration_recommendation_start_migration_sessions`

Start previously created migration sessions for recommendation. Ensure that any rescans specified in the create_migration_sessions response have been done before using this to start the sessions. Failure to do may result in data unavailability and/or data loss.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique ID of the migration recommendation.

### `migration_session_collection_query`

Query migration sessions.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `migration_session_create`

Create a new migration session. For virtual volumes (vVols), the background copy is completed during this phase and the ownership of the vVol is transferred to the new appliance. For volumes and application groups, a migration session is created in this phase and no background copy is performed until either the sync or cutover operation is invoked. There are no interruptions to any services during this phase.

**Supports noop?** false

#### Parameters

##### `automatic_cutover`

Data type: `Optional[Boolean]`

Indicates whether the migration session cutover is manual or automatic. Default for virtual_volume resource type migrations is automatic, otherwise the default is manual.

##### `destination_appliance_id`

Data type: `String`

Unique identifier of the destination appliance instance.

##### `family_id`

Data type: `String`

Family identifier designating the storage resource or resources to migrate. For volume or virtual_volume migrations, the family is moved together because they share data among the primary object, snapshots, and clones. For volume_group migration, the family of each volume in the group is moved because it is a grouping of volumes.

##### `name`

Data type: `Optional[String]`

User-specified friendly name of the migration session instance. The name can contain a maximum of 32 Unicode characters. It cannot contain unprintable characters, special HTTP characters, or whitespace.

##### `resource_type`

Data type: `Enum['volume','virtual_volume','volume_group']`

Storage resource types eligible for migration.

### `migration_session_cutover`

Final phase of the migration, when ownership of the volume, vVol, or volume group is transferred to the new appliance.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the migration session.

### `migration_session_delete`

Delete a migration session. With the force option, a migration session can be deleted regardless of its state. All background activity is canceled before deleting the session.

**Supports noop?** false

#### Parameters

##### `force`

Data type: `Optional[Boolean]`

Indicates whether all migration activities will be canceled before deleting the session.

##### `id`

Data type: `String`

Unique identifier of the migration session.

### `migration_session_instance_query`

Query a specific migration session.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the migration session.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `migration_session_pause`

Pause a migration session. Only migration sessions in the synchronizing state can be paused.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the migration session.

### `migration_session_resume`

Resume a paused migration session. You cannot resume a migration session in the failed state.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the migration session.

### `migration_session_sync`

Synchronize a migration session. During this phase, the majority of the background copy is completed and there are no interruptions to any services. Sync can be run multiple times to reduce the amount of data that must be copied during the cutover.

**Supports noop?** false

#### Parameters

##### `automatic_cutover`

Data type: `Optional[Boolean]`

Indicates whether the migration session cutover is manual or automatic. Default is manual.

##### `id`

Data type: `String`

Unique identifier of the migration session.

##### `rescan_complete`

Data type: `Optional[Boolean]`

Indicates whether a rescan will be performed during the sync operation. Default value is false. If the session creation completed with a message that rescan is required from one or more hosts, you must set this value to true during the subsequent sync operation. Otherwise, the sync operation will fail.

### `nas_server_collection_query`

Query all NAS servers.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `nas_server_create`

Create a NAS server.

**Supports noop?** false

#### Parameters

##### `current_unix_directory_service`

Data type: `Optional[Enum['None','NIS','LDAP','Local_Files','Local_Then_NIS','Local_Then_LDAP']]`

Define the Unix directory service used for looking up identity information for Unix such as UIDs, GIDs, net groups, and so on.

##### `default_unix_user`

Data type: `Optional[String[0,63]]`

Default Unix user name used for granting access in case of Windows to Unix user mapping failure. When empty, access in such case is denied.

##### `default_windows_user`

Data type: `Optional[String[0,1023]]`

Default Windows user name used for granting access in case of Unix to Windows user mapping failure. When empty, access in such case is denied.

##### `description`

Data type: `Optional[String[0,255]]`

Description of the NAS server.

##### `is_auto_user_mapping_enabled`

Data type: `Optional[Boolean]`

A Windows user must have a corresponding matching Unix user (uid) in order to connect.This attribute enables you to automatically generates this Unix user (uid), if that Windows user does not have any in the configured Unix directory service (UDS).In a pure SMB or non multi-protocol environment, this should be set to true.

##### `is_username_translation_enabled`

Data type: `Optional[Boolean]`

Enable the possibility to match a Windows account with an Unix account with different names.

##### `name`

Data type: `String[1,255]`

Name of the NAS server.

### `nas_server_delete`

Delete a NAS server.

**Supports noop?** false

#### Parameters

##### `domain_password`

Data type: `Optional[String]`

Administrator password used to unjoin the associated SMB servers from the Active Directory (AD) domain before deleting the NAS server. This parameter is required when the skipDomainUnjoin parameter is false or not set, and the NAS server has SMB servers joined to an AD domain.

##### `domain_user_name`

Data type: `Optional[String]`

Administrator login used to unjoin the associated SMB servers from the Active Directory (AD) domain before deleting the NAS server. This parameter is required when the skipDomainUnjoin parameter is false or not set, and the NAS server has SMB servers joined to an AD domain.

##### `id`

Data type: `String`

Unique identifier of the NAS server.

##### `is_skip_domain_unjoin`

Data type: `Optional[Boolean]`

Indicates whether to keep the associated SMB servers joined to the Active Directory when the NAS server is deleted. Values are:\n - true - Keep the associated SMB servers joined to the Active Directory when the NAS server is deleted. - false - (Default) Try to unjoin the associated SMB servers from the Active Directory before deleting the NAS server.

### `nas_server_download_group`

Download a NAS server group file containing the template or the actual (if already uploaded) group details.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the NAS server.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `nas_server_download_homedir`

Download a NAS server homedir file containing the template or the actual (if already uploaded) homedir configuration settings.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the NAS server.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `nas_server_download_hosts`

Download an NAS server host file containing template/actual(if already uploaded) host details.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the NAS server.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `nas_server_download_netgroup`

Download an NAS server netgroup file containing the template or the actual (if already uploaded) netgroup details.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the NAS server.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `nas_server_download_nsswitch`

Download a NAS server nsswitch file containing the template or the actual (if already uploaded) nsswitch configuration settings.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the NAS server.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `nas_server_download_ntxmap`

Download an NAS server ntxmap file containing the template or the actual (if already uploaded) ntxmap configuration settings.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the NAS server.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `nas_server_download_passwd`

Download a NAS server passwd file containing template or the actual (if already uploaded) passwd details.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the NAS server.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `nas_server_download_user_mapping_report`

Download the report generated by the update_user_mappings action.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the NAS server.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `nas_server_instance_query`

Query a specific NAS server.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the NAS server.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `nas_server_modify`

Modify the settings of a NAS server.

**Supports noop?** false

#### Parameters

##### `backup_i_pv4_interface_id`

Data type: `Optional[String]`

Unique identifier of the preferred IPv4 backup interface.

##### `backup_i_pv6_interface_id`

Data type: `Optional[String]`

Unique identifier of the preferred IPv6 backup interface.

##### `current_node_id`

Data type: `Optional[String]`

Unique identifier of the node on which the NAS server is running.

##### `current_unix_directory_service`

Data type: `Optional[Enum['None','NIS','LDAP','Local_Files','Local_Then_NIS','Local_Then_LDAP']]`

Define the Unix directory service used for looking up identity information for Unix such as UIDs, GIDs, net groups, and so on.

##### `default_unix_user`

Data type: `Optional[String[0,63]]`

Default Unix user name used for granting access in case of Windows to Unix user mapping failure. When empty, access in such case is denied.

##### `default_windows_user`

Data type: `Optional[String[0,1023]]`

Default Windows user name used for granting access in case of Unix to Windows user mapping failure. When empty, access in such case is denied.

##### `description`

Data type: `Optional[String[0,255]]`

Description of the NAS server.

##### `id`

Data type: `String`

Unique identifier of the NAS server.

##### `is_auto_user_mapping_enabled`

Data type: `Optional[Boolean]`

A Windows user must have a corresponding matching Unix user (uid) in order to connect.This attribute enables you to automatically generate this Unix user (uid), if that Windows user does not have any in the configured Unix directory service (UDS).In a pure SMB or non multi-protocol environment, this should be set to true.

##### `is_username_translation_enabled`

Data type: `Optional[Boolean]`

Enable the possibility to match a windows account to a Unix account with different names

##### `name`

Data type: `Optional[String[1,255]]`

Name of the NAS server.

##### `preferred_node_id`

Data type: `Optional[String]`

Unique identifier of the preferred node for the NAS server The initial value (on NAS server create) is taken from the current node.

##### `production_i_pv4_interface_id`

Data type: `Optional[String]`

Unique identifier of the preferred IPv4 production interface.

##### `production_i_pv6_interface_id`

Data type: `Optional[String]`

Unique identifier of the preferred IPv6 production interface.

### `nas_server_ping`

Ping destination from NAS server.

**Supports noop?** false

#### Parameters

##### `destination_address`

Data type: `Optional[String]`

Destination to ping, can be either an IP address (IPv4 or IPv6) or a hostname being resolved by the NAS server name resolvers.

##### `id`

Data type: `String`

Unique identifier of the NAS server.

##### `is_ipv6`

Data type: `Optional[Boolean]`

When true, and the destination is a hostname, it will be resolved to IPv6. Otherwise the hostname is resolved preferably to an IPv4 address.

### `nas_server_update_user_mappings`

Fix the user mappings for all file systems associated with the NAS server. This process updates file ownership on the NAS server's file systems to reflect changes to users' SIDs. A new UID/GID will be obtained from a Unix Directory Service for the user name of the object owner. A user mapping report is also generated. This operation can take a significant amount of time, depending of the size of the file systems.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the NAS server.

### `nas_server_upload_group`

Upload NAS server group file.

**Supports noop?** false

#### Parameters

##### `body`

Data type: `Optional[String]`

Upload NAS server group file.

##### `id`

Data type: `String`

Unique identifier of the NAS server.

### `nas_server_upload_homedir`

Upload the NAS server homedir file.

**Supports noop?** false

#### Parameters

##### `body`

Data type: `Optional[String]`

Upload the NAS server homedir file.

##### `id`

Data type: `String`

Unique identifier of the NAS server.

### `nas_server_upload_hosts`

Upload NAS server host file.

**Supports noop?** false

#### Parameters

##### `body`

Data type: `Optional[String]`

Upload NAS server host file.

##### `id`

Data type: `String`

Unique identifier of the NAS server.

### `nas_server_upload_netgroup`

Upload the NAS server netgroup file.

**Supports noop?** false

#### Parameters

##### `body`

Data type: `Optional[String]`

Upload the NAS server netgroup file.

##### `id`

Data type: `String`

Unique identifier of the NAS server.

### `nas_server_upload_nsswitch`

Upload the NAS server nsswitch file.

**Supports noop?** false

#### Parameters

##### `body`

Data type: `Optional[String]`

Upload the NAS server nsswitch file.

##### `id`

Data type: `String`

Unique identifier of the NAS server.

### `nas_server_upload_ntxmap`

The nas_server_upload_ntxmap task.

**Supports noop?** false

#### Parameters

##### `body`

Data type: `Optional[String]`

Upload the NAS server ntxmap file.

##### `id`

Data type: `String`

Unique identifier of the NAS server.

### `nas_server_upload_passwd`

Upload NAS server passwd file.

**Supports noop?** false

#### Parameters

##### `body`

Data type: `Optional[String]`

Upload NAS server passwd file.

##### `id`

Data type: `String`

Unique identifier of the NAS server.

### `network_collection_query`

Query the IP network configurations of the cluster.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `network_instance_query`

Query a specific IP network configuration.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the IP network.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `network_modify`

Modify IP network parameters, such as gateways, netmasks, VLAN identifiers, and IP addresses.

**Supports noop?** false

#### Parameters

##### `add_addresses`

Data type: `Optional[Array[String]]`

IP addresses to add in IPv4 or IPv6 format.

##### `cluster_mgmt_address`

Data type: `Optional[String]`

New cluster management IP address in IPv4 or IPv6 format, corresponding to the network's IP version.This can only be specified when reconfiguring the management network.Caution: Changing the cluster management IP address will lead to losing management sessions through this address.

##### `esxi_credentials`

Data type: `Optional[Array[Struct[{Optional[node_id] => Optional[String], Optional[password] => Optional[String], }]]]`

Credentials required for re-registering the ESXi hosts in the vCenter.Should be passed only when ESXi host addresses or management network VLAN / prefix / gateway are changedduring the reconfiguration of the PowerStore X model appliances.

##### `force`

Data type: `Optional[Boolean]`

Indicates whether to suppress network validation errors.The option is intended to suppress false errors caused by network environment constraints.Normally the command will fail with an error when:- some of system network ports are in degraded state or have cabling issues,- system top-of-rack switches have configuration issues leading to network unreachability,- network IP addresses have duplicates in the network environment,- or network gateway is unreachable.When force is true, the command will proceed instead.Caution: Only use this option when you are certain your requested settings are correct and you understand why they are failing at this time, and you want to apply the settings anyway.Improper network settings can make the system unreachable for data and management.

##### `gateway`

Data type: `Optional[String]`

Network gateway in IPv4 or IPv6 format, corresponding to the network's IP version.Specify empty string to remove the gateway.

##### `id`

Data type: `String`

Unique identifier of the IP network.

##### `mtu`

Data type: `Optional[Integer[1280,9000]]`

Maximum Transmission Unit (MTU) packet size set on network interfaces, in bytes.

##### `prefix_length`

Data type: `Optional[Integer[1,127]]`

Network prefix length. (Used for both IPv4 and IPv6).

##### `remove_addresses`

Data type: `Optional[Array[String]]`

IP addresses to remove in IPv4 or IPv6 format.

##### `storage_discovery_address`

Data type: `Optional[String]`

New storage discovery IP address in IPv4 or IPv6 format, corresponding to the network's IP version.This can only be specified when reconfiguring the storage network.Specify empty string to remove the storage discovery IP address.

##### `vasa_provider_credentials`

Data type: `Optional[Struct[{Optional[password] => Optional[String], Optional[username] => Optional[String], }]]`

Credentials required for re-registering the VASA vendor provider during the reconfiguration of the cluster management IP address.Should be passed only when reconfiguring cluster management IP address.

##### `vlan_id`

Data type: `Optional[Integer[0,4094]]`

VLAN identifier.

### `network_replace`

Reconfigure cluster management network settings from IPv4 to IPv6 or vice versa.

**Supports noop?** false

#### Parameters

##### `cluster_mgmt_address`

Data type: `String[1]`

New cluster management IP address in IPv4 or IPv6 format, corresponding to the network's IP version.

##### `dns_addresses`

Data type: `Array[String[1]]`

List of new DNS server IP addresses in IPv4 or IPv6 format.

##### `esxi_credentials`

Data type: `Optional[Array[Struct[{Optional[node_id] => Optional[String], Optional[password] => Optional[String], }]]]`

Credentials required for re-registering the ESXi hosts in the vCenter.Should be passed only when ESXi host addresses or management network VLAN / prefix / gateway are changedduring the reconfiguration of the PowerStore X model appliances.

##### `force`

Data type: `Optional[Boolean]`

Indicates whether to suppress network validation errors.The option is intended to suppress false errors caused by network environment constraints.Normally the command will fail with an error when:- some of system network ports are in degraded state or have cabling issues,- system top-of-rack switches have configuration issues leading to network unreachability,- network IP addresses have duplicates in the network environment,- or network gateway is unreachable.When force is true, the command will proceed instead.Caution: Only use this option when you are certain your requested settings are correct and you understand why they are failing at this time, and you want to apply the settings anyway.Improper network settings can make the system unreachable for data and management.

##### `gateway`

Data type: `String`

Network gateway in IPv4 or IPv6 format, corresponding to the network's IP version.Specify empty string to remove the gateway.

##### `id`

Data type: `String`

Unique identifier of the IP network.

##### `ip_pool_addresses`

Data type: `Array[String[1]]`

List of new IP addresses in IPv4 or IPv6 format.

##### `mtu`

Data type: `Integer[1280,9000]`

Maximum Transmission Unit (MTU) packet size set on network interfaces, in bytes.

##### `ntp_addresses`

Data type: `Array[String[1]]`

List of new NTP server FQDNs or IP addresses in IPv4 or IPv6 format.

##### `physical_switches`

Data type: `Optional[Array[Struct[{Optional[connections] => Optional[Array[Struct[{address => Optional[String], connect_method => Optional[Enum['SSH','SNMPv2c']], Optional[port] => Optional[Integer[0,65535]], Optional[snmp_community_string] => Optional[String], Optional[ssh_password] => Optional[String], Optional[username] => Optional[String], }]]], Optional[name] => Optional[String], Optional[purpose] => Optional[Enum['Data_and_Management','Management_Only']], }]]]`

List of new physical switches settings. If this property is omitted, physical switches configuration will not be modified.

##### `prefix_length`

Data type: `Integer[1,127]`

Network prefix length. (Used for both IPv4 and IPv6).

##### `smtp_config`

Data type: `Optional[Struct[{address => Optional[String], port => Optional[Integer[0,65535]], source_email => Optional[String], }]]`



##### `vasa_provider_credentials`

Data type: `Optional[Struct[{Optional[password] => Optional[String], Optional[username] => Optional[String], }]]`

Credentials required for re-registering the VASA vendor provider during the replacement of the cluster management IP address.Should be passed only when reconfiguring PowerStoreX cluster.

##### `vcenter_address`

Data type: `Optional[String[1]]`

New vCenter FQDNs or IP address in IPv4 or IPv6 format. Required only when reconfiguring PowerStoreX cluster.

##### `vlan_id`

Data type: `Integer[0,4094]`

VLAN identifier.

### `network_scale`

Add IP ports for use by the storage network, or remove IP ports so they can no longer be used.At least one IP port must be configured for use by the storage network.

**Supports noop?** false

#### Parameters

##### `add_port_ids`

Data type: `Optional[Array[String]]`

Unique identifiers of available IP ports to be used in the network.

##### `force`

Data type: `Optional[Boolean]`

Indicates whether to suppress network validation errors.The option is intended to suppress false errors caused by network environment constraints.Normally the command will fail with an error when:* system network ports on top of which IP ports are configured are in degraded state or have cabling issues,* or network IP addresses applied as a result of network scaling have duplicates in the network environment.When force is true, the command will proceed instead.Caution: Only use this option when you are certain your requested settings are correct and you understand why they are failing at this time, and you want to apply the settings anyway.Improper network settings can make the system unreachable for data.

##### `id`

Data type: `String`

Unique identifier of the IP network.

##### `remove_port_ids`

Data type: `Optional[Array[String]]`

Unique identifiers of IP ports to remove from use in the network.

### `nfs_export_collection_query`

List NFS Exports.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `nfs_export_create`

Create an NFS Export for a Snapshot.

**Supports noop?** false

#### Parameters

##### `anonymous_gid`

Data type: `Optional[Integer[-2147483648,2147483647]]`

Specifies the group ID of the anonymous account.

##### `anonymous_uid`

Data type: `Optional[Integer[-2147483648,2147483647]]`

Specifies the user ID of the anonymous account.

##### `default_access`

Data type: `Optional[Enum['No_Access','Read_Only','Read_Write','Root','Read_Only_Root']]`

Default access level for all hosts that can access the Export.* No_Access- Deny access to the Export for the hosts.* Read_Only- Allow read only access to the Export for the hosts.* Read_Write- Allow read write access to the Export for the hosts.* Root - Allow read write access to the Export for the hosts. Allow access to the Export for root user.* Read_Only_Root- Allow read only root access to the Export for the hosts.

##### `description`

Data type: `Optional[String[0,511]]`

User defined NFS Export description.

##### `file_system_id`

Data type: `String`

Unique identifier of the file system on which the NFS Export will be created.

##### `is_no_suid`

Data type: `Optional[Boolean]`

If set, do not allow access to set SUID. Otherwise, allow access.

##### `min_security`

Data type: `Optional[Enum['Sys','Kerberos','Kerberos_With_Integrity','Kerberos_With_Encryption']]`

NFS enforced security type for users accessing an NFS Export.* Sys - Allow the user to authenticate with any NFS security types: UNIX, Kerberos, Kerberos with integrity, or Kerberos with encryption.* Kerberos - Allow only Kerberos security for user authentication.* Kerberos_With_Integrity- Allow only Kerberos with integrity and Kerberos with encryption security for user authentication.* Kerberos_With_Encryption- Allow only Kerberos with encryption security for user authentication.

##### `name`

Data type: `String[1,80]`

NFS Export name.

##### `no_access_hosts`

Data type: `Optional[Array[String]]`

Hosts with no access to the NFS export or its snapshots. Hosts can be entered by Hostname, IP addresses (IPv4, IPv6, IPv4/PrefixLength, IPv6/PrefixLenght, or IPv4/subnetmask), or Netgroups prefixed with @.

##### `path`

Data type: `String[1,1023]`

Local path to export relative to the file system root directory. With NFS, each export of a file_system or file_snap must have a unique local path.Before you can create additional Exports within an NFS shared folder, you must create directories within it from a Linux/Unix host that is connected to the file system. After a directory has been created from a mounted host, you can create a corresponding Export and set access permissions accordingly.

##### `read_only_hosts`

Data type: `Optional[Array[String]]`

Hosts with read-only access to the NFS export and its snapshots. Hosts can be entered by Hostname, IP addresses (IPv4, IPv6, IPv4/PrefixLength, IPv6/PrefixLenght, or IPv4/subnetmask), or Netgroups prefixed with @.

##### `read_only_root_hosts`

Data type: `Optional[Array[String]]`

Hosts with read-only and ready-only for root user access to the NFS Export and its snapshots. Hosts can be entered by Hostname, IP addresses (IPv4, IPv6, IPv4/PrefixLength, IPv6/PrefixLenght, or IPv4/subnetmask), or Netgroups prefixed with @.

##### `read_write_hosts`

Data type: `Optional[Array[String]]`

Hosts with read and write access to the NFS export and its snapshots.Hosts can be entered by Hostname, IP addresses (IPv4, IPv6, IPv4/PrefixLength, IPv6/PrefixLenght, or IPv4/subnetmask), or Netgroups prefixed with @.

##### `read_write_root_hosts`

Data type: `Optional[Array[String]]`

Hosts with read and write and read and write for root user access to the NFS Export and its snapshots. Hosts can be entered by Hostname, IP addresses (IPv4, IPv6, IPv4/PrefixLength, IPv6/PrefixLenght, or IPv4/subnetmask), or Netgroups prefixed with @.

### `nfs_export_delete`

Delete NFS Export.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

NFS Export object id.

### `nfs_export_instance_query`

Get NFS Export properties.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

NFS Export object id.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `nfs_export_modify`

Modify NFS Export Properties.

**Supports noop?** false

#### Parameters

##### `add_no_access_hosts`

Data type: `Optional[Array[String]]`

Hosts to add to the no_access_host list. Hosts can be entered by Hostname, IP addresses (IPv4, IPv6, IPv4/PrefixLength, IPv6/PrefixLenght, or IPv4/subnetmask), or Netgroups prefixed with @. Error if the host already exists in the list. Cannot be combined with no_access_hosts.

##### `add_read_only_hosts`

Data type: `Optional[Array[String]]`

Hosts to add to the current read_only_hosts list. Hosts can be entered by Hostname, IP addresses (IPv4, IPv6, IPv4/PrefixLength, IPv6/PrefixLenght, or IPv4/subnetmask), or Netgroups prefixed with @. Error if the host already exists. Cannot combine with read_only_hosts.

##### `add_read_only_root_hosts`

Data type: `Optional[Array[String]]`

Hosts to add to the current read_only_root_hosts list. Hosts can be entered by Hostname, IP addresses (IPv4, IPv6, IPv4/PrefixLength, IPv6/PrefixLenght, or IPv4/subnetmask), or Netgroups prefixed with @. Error if the host already exists. Cannot combine with read_only_root_hosts.

##### `add_read_write_hosts`

Data type: `Optional[Array[String]]`

Hosts to add to the current read_write_hosts list. Hosts can be entered by Hostname, IP addresses (IPv4, IPv6, IPv4/PrefixLength, IPv6/PrefixLenght, or IPv4/subnetmask), or Netgroups prefixed with @. Error if Host is already exists. Cannot combine with read_write_hosts.

##### `add_read_write_root_hosts`

Data type: `Optional[Array[String]]`

Hosts to add to the current read_write_root_hosts list. Hosts can be entered by Hostname, IP addresses (IPv4, IPv6, IPv4/PrefixLength, IPv6/PrefixLenght, or IPv4/subnetmask), or Netgroups prefixed with @. Error if the host already exists. Cannot combine with read_write_root_hosts.

##### `anonymous_gid`

Data type: `Optional[Integer[-2147483648,2147483647]]`

Specifies the group ID of the anonymous account.

##### `anonymous_uid`

Data type: `Optional[Integer[-2147483648,2147483647]]`

Specifies the user ID of the anonymous account.

##### `default_access`

Data type: `Optional[Enum['No_Access','Read_Only','Read_Write','Root','Read_Only_Root']]`

Default access level for all hosts that can access the Export.* No_Access- Deny access to the Export for the hosts.* Read_Only- Allow read only access to the Export for the hosts.* Read_Write- Allow read write access to the Export for the hosts.* Root - Allow read write access to the Export for the hosts. Allow access to the Export for root user.* Read_Only_Root- Allow read only root access to the Export for the hosts.

##### `description`

Data type: `Optional[String[0,511]]`

NFS Export description.

##### `id`

Data type: `String`

NFS Export object id.

##### `is_no_suid`

Data type: `Optional[Boolean]`

If set, do not allow access to set SUID. Otherwise, allow access.

##### `min_security`

Data type: `Optional[Enum['Sys','Kerberos','Kerberos_With_Integrity','Kerberos_With_Encryption']]`

NFS enforced security type for users accessing an NFS Export.* Sys - Allow the user to authenticate with any NFS security types: UNIX, Kerberos, Kerberos with integrity, or Kerberos with encryption.* Kerberos - Allow only Kerberos security for user authentication.* Kerberos_With_Integrity- Allow only Kerberos with integrity and Kerberos with encryption security for user authentication.* Kerberos_With_Encryption- Allow only Kerberos with encryption security for user authentication.

##### `no_access_hosts`

Data type: `Optional[Array[String]]`

Hosts with no access to the NFS export or its snapshots. Hosts can be entered by Hostname, IP addresses (IPv4, IPv6, IPv4/PrefixLength, IPv6/PrefixLenght, or IPv4/subnetmask), or Netgroups prefixed with @.

##### `read_only_hosts`

Data type: `Optional[Array[String]]`

Hosts with read-only access to the NFS export and its snapshots. Hosts can be entered by Hostname, IP addresses (IPv4, IPv6, IPv4/PrefixLength, IPv6/PrefixLenght, or IPv4/subnetmask), or Netgroups prefixed with @.

##### `read_only_root_hosts`

Data type: `Optional[Array[String]]`

Hosts with read-only and ready-only for root user access to the NFS Export and its snapshots. Hosts can be entered by Hostname, IP addresses (IPv4, IPv6, IPv4/PrefixLength, IPv6/PrefixLenght, or IPv4/subnetmask), Netgroups prefixed with @.

##### `read_write_hosts`

Data type: `Optional[Array[String]]`

Hosts with read and write access to the NFS export and its snapshots. Hosts can be entered by Hostname, IP addresses (IPv4, IPv6, IPv4/PrefixLength, IPv6/PrefixLenght, or IPv4/subnetmask) or, Netgroups prefixed with @.

##### `read_write_root_hosts`

Data type: `Optional[Array[String]]`

Hosts with read and write and read and write for root user access to the NFS Export and its snapshots. Hosts can be entered by Hostname, IP addresses (IPv4, IPv6, IPv4/PrefixLength, IPv6/PrefixLenght, or IPv4/subnetmask), or Netgroups prefixed with @.

##### `remove_no_access_hosts`

Data type: `Optional[Array[String]]`

Hosts to remove from the current no_access_hosts list. Hosts can be entered by Hostname, IP addresses (IPv4, IPv6, IPv4/PrefixLength, IPv6/PrefixLenght, or IPv4/subnetmask), or Netgroups prefixed with @. Error if the host is not present. Cannot combine with no_access_hosts.

##### `remove_read_only_hosts`

Data type: `Optional[Array[String]]`

Hosts to remove from the current read_only_hosts list. Hosts can be entered by Hostname, IP addresses (IPv4, IPv6, IPv4/PrefixLength, IPv6/PrefixLenght, or IPv4/subnetmask), or Netgroups prefixed with @. Error if the host is not present. Cannot combine with read_only_hosts.

##### `remove_read_only_root_hosts`

Data type: `Optional[Array[String]]`

Hosts to remove from the current read_only_root_hosts list. Hosts can be entered by Hostname, IP addresses (IPv4, IPv6, IPv4/PrefixLength, IPv6/PrefixLenght, or IPv4/subnetmask), or Netgroups prefixed with @. Error if The host is not present. Cannot combine with read_only_root_hosts.

##### `remove_read_write_hosts`

Data type: `Optional[Array[String]]`

Hosts to remove from the current read_write_hosts list. Hosts can be entered by Hostname, IP addresses (IPv4, IPv6, IPv4/PrefixLength, IPv6/PrefixLenght, or IPv4/subnetmask), or Netgroups prefixed with @. Error if Host is not present. Cannot combine with read_write_hosts.

##### `remove_read_write_root_hosts`

Data type: `Optional[Array[String]]`

Hosts to remove from the current read_write_root_hosts list. Hosts can be entered by Hostname, IP addresses (IPv4, IPv6, IPv4/PrefixLength, IPv6/PrefixLenght, or IPv4/subnetmask), or Netgroups prefixed with @. Error if the host is not present. Cannot combine with read_write_root_hosts.

### `nfs_server_collection_query`

Query all NFS Servers.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `nfs_server_create`

Create an NFS server.

**Supports noop?** false

#### Parameters

##### `credentials_cache_ttl`

Data type: `Optional[Integer[0,2147483647]]`

Sets the Time-To-Live (in minutes) expiration time in minutes for a Windows entry in the credentials cache. When failed mapping entries expire, the system retries mapping the UID to the SID.

##### `host_name`

Data type: `Optional[String[1,255]]`

The name that will be used by NFS clients to connect to this NFS server. This name is required when using secure NFS, except when is_use_smb_config_enabled is true. In this case host_name is forced to the SMB server computer name, and must not be specified.

##### `is_extended_credentials_enabled`

Data type: `Optional[Boolean]`

Indicates whether the NFS server supports more than 16 Unix groups in a Unix credential. Valid values are,- true - NFS server supports more than 16 Unix groups in a Unix credential. The NFS server will send additional request to Unix Directory service to identify Unix groups.- false - NFS server supports more than 16 Unix groups in a Unix credential. The NFS server will send additional request to Unix Directory service to identify Unix groups. Note - The NFS server builds its own Unix credential when it supports more than 16 groups. This process can slow performance.

##### `is_nfsv3_enabled`

Data type: `Optional[Boolean]`

Indicates whether NFSv3 is enabled on the NAS server. When enabled, NFS shares can be accessed with NFSv3. When disabled, NFS shares can not be accessed with NFSv3 protocol.- true - NFSv3 is enabled on the specified NAS server.- false - NFSv3 is disabled on the specified NAS server.

##### `is_nfsv4_enabled`

Data type: `Optional[Boolean]`

Indicates whether NFSv4 is enabled on the NAS server. When enabled, NFS shares can be accessed with NFSv4. When disabled, NFS shares can not be accessed with NFSv4 protocol.- true - NFSv4 is enabled on the specified NAS server.- false - NFSv4 is disabled on the specified NAS server.

##### `is_secure_enabled`

Data type: `Optional[Boolean]`

Indicates whether secure NFS is enabled on the NFS server.- true - Secure NFS is Enabled.- false - Secure NFS is disabled.

##### `is_use_smb_config_enabled`

Data type: `Optional[Boolean]`

Indicates whether SMB authentication is used to authenticate to the KDC. Values are:- true: Indicates that the configured SMB Server settings are used for Kerberos authentication.- false: Indicates that Kerberos uses its own settings.

##### `nas_server_id`

Data type: `String`

Unique identifier of the NAS server.

### `nfs_server_delete`

Delete an NFS server.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the NFS server.

##### `is_skip_unjoin`

Data type: `Optional[Boolean]`

Allow to bypass NFS server unjoin. If false delete will fail if secure is enabled and current kdc_type is MS Windows. If secure is enabled either unjoin NFS server before doing delete or set value to true.

### `nfs_server_instance_query`

Query settings of an NFS server.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the NFS server.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `nfs_server_join`

Join the secure NFS server to the NAS server's AD domain, which is necessary for Secure NFS.

**Supports noop?** false

#### Parameters

##### `domain_password`

Data type: `String`

Password of the domain-user specified to join the Active Directory domain.

##### `domain_user_name`

Data type: `String`

Name of a domain-user with privileges to join the Active Directory domain.

##### `id`

Data type: `String`

Unique identifier of the NFS server.

### `nfs_server_modify`

Modify NFS server settings.

**Supports noop?** false

#### Parameters

##### `credentials_cache_ttl`

Data type: `Optional[Integer[0,2147483647]]`

Sets the Time-To-Live (in minutes) expiration stamp for a Windows entry in the credentials cache. When failed mapping entries expire, the system retries mapping the UID to the SID.

##### `host_name`

Data type: `Optional[String[1,255]]`

The name that will be used by NFS clients to connect to this NFS server. This name is required when using secure NFS, except when is_use_smb_config_enabled is true. In this case host_name is forced to the SMB server computer name, and must not be specified.

##### `id`

Data type: `String`

Unique identifier of the NFS server.

##### `is_extended_credentials_enabled`

Data type: `Optional[Boolean]`

Indicates whether the NFS server supports more than 16 Unix groups in a Unix credential. Valid values are,- true - NFS server supports more than 16 Unix groups in a Unix credential. The NFS server will send additional request to Unix Directory service to identify Unix groups.- false - NFS server supports more than 16 Unix groups in a Unix credential. The NFS server will send additional request to Unix Directory service to identify Unix groups. Note - The NFS server builds its own Unix credential when it supports more than 16 groups. This process can slow performance.

##### `is_nfsv3_enabled`

Data type: `Optional[Boolean]`

Indicates whether NFSv3 is enabled on the NAS server. When enabled, NFS shares can be accessed with NFSv3. When disabled, NFS shares cannot be accessed with NFSv3 protocol.- true - NFSv3 is enabled on the specified NAS server.- false - NFSv3 is disabled on the specified NAS server.

##### `is_nfsv4_enabled`

Data type: `Optional[Boolean]`

Indicates whether NFSv4 is enabled on the NAS server. When enabled, NFS shares can be accessed with NFSv4. When disabled, NFS shares cannot be accessed with NFSv4 protocol.- true - NFSv4 is enabled on the specified NAS server.- false - NFSv4 is disabled on the specified NAS server.

##### `is_secure_enabled`

Data type: `Optional[Boolean]`

Indicates whether secure NFS is enabled on the NFS server.- true - Secure NFS is Enabled.- false - Secure NFS is disabled.

##### `is_skip_unjoin`

Data type: `Optional[Boolean]`

Allow to bypass NFS server unjoin. If false modification will fail if secure is enabled and current kdc_type is MS Windows. If secure is enabled either unjoin NFS server before deleting or set value to true.

##### `is_use_smb_config_enabled`

Data type: `Optional[Boolean]`

Indicates whether SMB authentication is used to authenticate to the KDC. Values are:- true: Indicates that the the configured SMB Server settings are used for Kerberos authentication.- false: Indicates that Kerberos uses its own settings.

### `nfs_server_unjoin`

Unjoin the secure NFS server from the NAS server's Active Directory domain. If you unjoin with secure NFS exports active, exports will be unavailable to the clients.

**Supports noop?** false

#### Parameters

##### `domain_password`

Data type: `String`

Password of the domain-user specified to unjoin from the Active Directory domain.

##### `domain_user_name`

Data type: `String`

Name of a domain-user with privileges to unjoin from the Active Directory domain.

##### `id`

Data type: `String`

Unique identifier of the NFS server.

### `node_collection_query`

Query the nodes in a cluster.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `node_instance_query`

Query a specific node in a cluster.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the node.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `ntp_collection_query`

Query NTP settings for a cluster.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `ntp_instance_query`

Query a specific NTP setting.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the NTP setting.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `ntp_modify`

Modify NTP settings.

**Supports noop?** false

#### Parameters

##### `addresses`

Data type: `Array[String]`

NTP server addresses. This list may contain IPv4 addresses, IPv6 addresses, and host names.

##### `id`

Data type: `String`

Unique identifier of the NTP setting.

### `performance_rule_collectionquery`

Get performance rules.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `performance_rule_instancequery`

Get a performance rule by id.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Performance Rule id.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `physical_switch_collection_query`

Query physical switches settings for a cluster.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `physical_switch_create`

Create a physical switch settings.

**Supports noop?** false

#### Parameters

##### `connections`

Data type: `Array[Struct[{address => Optional[String[1,255]], connect_method => Optional[Enum['SSH','SNMPv2c']], Optional[port] => Optional[Integer[0,65535]], Optional[snmp_community_string] => Optional[String[0,128]], Optional[ssh_password] => Optional[String[0,128]], Optional[username] => Optional[String[0,128]], }]]`

Supported connections for a physical switch.

##### `name`

Data type: `String[1,128]`

Name of a physical switch.

##### `purpose`

Data type: `Enum['Data_and_Management','Management_Only']`

Physical switch purpose in network. Possible purposes are:  * Data_and_Management - Physical switch for all data and management networks.  * Management_Only - Physical switch for management network only.

### `physical_switch_delete`

Delete the physical switch settings.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the physical switch settings.

### `physical_switch_instance_query`

Query a specific physical switch settings.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the physical switch settings.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `physical_switch_modify`

Modify a physical switch settings.

**Supports noop?** false

#### Parameters

##### `connections`

Data type: `Optional[Array[Struct[{address => Optional[String[1,255]], connect_method => Optional[Enum['SSH','SNMPv2c']], Optional[port] => Optional[Integer[0,65535]], Optional[snmp_community_string] => Optional[String[0,128]], Optional[ssh_password] => Optional[String[0,128]], Optional[username] => Optional[String[0,128]], }]]]`

Supported connections for a physical switch.

##### `id`

Data type: `String`

Unique identifier of the physical switch settings.

##### `name`

Data type: `Optional[String[1,128]]`

Name of physical switch.

##### `purpose`

Data type: `Optional[Enum['Data_and_Management','Management_Only']]`

Physical switch purpose in network. Possible purposes are:  * Data_and_Management - Physical switch for all data and management networks.  * Management_Only - Physical switch for management network only.

### `policy_collection_query`

Query protection and performance policies.The following REST query is an example of how to retrieve protection policies along with their rules and associated resources:https://{{cluster_ip}}/api/rest/policy?select=name,id,type,replication_rules(id,name,rpo,remote_system(id,name,management_address)),snapshot_rules(id,name,interval,time_of_day,days_of_week),volume(id,name),volume_group(id,name)&type=eq.ProtectionThe following REST query is an example of how to retrieve performance policies along with their associated resources:   https://{{cluster_ip}}/api/rest/policy?select=name,id,type,volume(id,name),volume_group(id,name)&type=eq.Performance

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `policy_create`

Create a new protection policy. Protection policies can be assigned to volumes or volume groups. When a protection policy is assigned to a volume or volume group:* If the policy is associated with one or more snapshot rules, scheduled snapshots are created based on the schedule specified in each snapshot rule.* If the policy is associated with a replication rule, a replication session is created and synchronized based on the schedule specified in the replication rule.

**Supports noop?** false

#### Parameters

##### `description`

Data type: `Optional[String]`

Policy description.

##### `name`

Data type: `String`

Policy name.

##### `replication_rule_ids`

Data type: `Optional[Array[String]]`

Replication rule identifiers included in this policy. At least one snapshot rule or one replication rule must be specified to create a protection policy.

##### `snapshot_rule_ids`

Data type: `Optional[Array[String]]`

Snapshot rule identifiers included in this policy. At least one snapshot rule or one replication rule must be specified to create a protection policy.

### `policy_delete`

Delete a protection policy.Protection policies that are used by any storage resources can not be deleted.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the protection policy to be deleted.

### `policy_instance_query`

Query a specific policy.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the policy.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `policy_modify`

Modify a protection policy.

**Supports noop?** false

#### Parameters

##### `add_replication_rule_ids`

Data type: `Optional[Array[String]]`

Replication rule identifiers to be added to this policy.

##### `add_snapshot_rule_ids`

Data type: `Optional[Array[String]]`

Snapshot rule identifiers to be added to this policy.

##### `description`

Data type: `Optional[String]`

Policy description.

##### `id`

Data type: `String`

Unique identifier of the policy to be modified.

##### `name`

Data type: `Optional[String]`

Policy name.

##### `remove_replication_rule_ids`

Data type: `Optional[Array[String]]`

Replication rule identifiers to be removed from this policy.

##### `remove_snapshot_rule_ids`

Data type: `Optional[Array[String]]`

Snapshot rule identifiers to be removed from this policy.

##### `replication_rule_ids`

Data type: `Optional[Array[String]]`

Replication rule identifiers that should replace the current list of replication rule identifiers in this policy.

##### `snapshot_rule_ids`

Data type: `Optional[Array[String]]`

Snapshot rule identifiers that should replace the current list of snapshot rule identifiers in this policy.

### `remote_system_collection_query`

Query remote systems.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `remote_system_create`

Create a new remote system relationship. The type of remote system being connected requires different parameter sets. For PowerStore remote system relationships, include the following parameters:* Management address - Either an IPv4 or IPv6 address. FQDN is not supported.* Type of remote system * Data network latency typeFor PowerStore remote system relationships, the relationship is created in both directions. Remote protection policies can be configured using the PowerStore remote system instance on either of the systems. This enables remote replication for storage resources in either direction. The data connections take into account whether Challenge Handshake Authentication Protocol (CHAP) is enabled on local and remote PowerStore systems.For non-PowerStore remote system relationships, include the following parameters:* Management address - Either an IPv4 or IPv6 address. FQDN is not supported.* Type of remote system* Name* Description* Remote administrator credentials* iSCSI address - IPv4 address* CHAP mode for discovery or session * CHAP secrets detailsAfter the remote system relationship is created, the local system can communicate with the remote system, and open data connections for data transfer.

**Supports noop?** false

#### Parameters

##### `data_network_latency`

Data type: `Optional[Enum['Low','High']]`

Network latency choices for a remote system. Replication traffic can be tuned for higher efficiency depending on the expected network latency. This will only be used when the remote system type is PowerStore.* Low                      - Less than 5 milliseconds.* High                     - More than 5 milliseconds.

##### `description`

Data type: `Optional[String[0,256]]`

User-specified description of the remote system.

##### `discovery_chap_mode`

Data type: `Optional[Enum['Disabled','Single','Mutual']]`

Challenge Handshake Authentication Protocol (CHAP) status:* Disabled     * Single       - Enabled for initiator authentication.* Mutual       - Enabled for initiator and target authentication.

##### `import_chap_info`

Data type: `Optional[Struct[{Optional[initiator_discovery_password] => Optional[String], Optional[initiator_discovery_username] => Optional[String], Optional[initiator_session_password] => Optional[String], Optional[initiator_session_username] => Optional[String], Optional[target_discovery_password] => Optional[String], Optional[target_discovery_username] => Optional[String], Optional[target_session_password] => Optional[String], Optional[target_session_username] => Optional[String], }]]`

Information about the initiator, target session, or discovery CHAP secrets.

##### `iscsi_addresses`

Data type: `Optional[Array[String]]`

iSCSI target IP addresses for the data connection to the remote system. Must be specified when creating a non-PowerStore remote system.

##### `management_address`

Data type: `String`

Management IP address of the remote system instance. Only IPv4 is supported for non-PowerStore remote systems.Both IPv4 and IPv6 are supported for PowerStore remote systems.

##### `name`

Data type: `Optional[String[0,128]]`

User-specified name of the remote system. Used only for non-PowerStore systems. This value must contain 128 or fewer printable Unicode characters.

##### `remote_password`

Data type: `Optional[String]`

Password used to access the remote system. Used only for non-PowerStore systems.

##### `remote_username`

Data type: `Optional[String]`

Username used to access the remote system. Used only for non-PowerStore systems.

##### `session_chap_mode`

Data type: `Optional[Enum['Disabled','Single','Mutual']]`

Challenge Handshake Authentication Protocol (CHAP) status:* Disabled     * Single       - Enabled for initiator authentication.* Mutual       - Enabled for initiator and target authentication.

##### `type`

Data type: `Optional[Enum['PowerStore','Unity','VNX','PS_Equallogic','Storage_Center','XtremIO']]`

Remote system connection type between the local system and the following remote systems:      * PowerStore               - PowerStore system* Unity                    - Unity import system* VNX                      - VNX import system* PS_Equallogic            - PS EqualLogic import system* Storage_Center           - Storage Center import system* XtremIO                  - XtremIO import system

### `remote_system_delete`

Delete a remote system. Deleting the remote system deletes the management and data connections established with the remote system. You cannot delete a remote system if there are active import sessions, or if there are remote protection policies active in the system referencing the remote system instance.For PowerStore remote systems, the relationship is deleted in both directions if the remote system is up and connectable. You cannot delete a PowerStore remote system if there is no management connectivity between the local and remore systems. Only the local end of the relationship is deleted. Manually log in to the remote PowerStore system and remove the relationship.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the remote system.

### `remote_system_instance_query`

Query a remote system instance.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the remote system.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `remote_system_modify`

Modify a remote system instance. The list of valid parameters depends on the type of remote system.For PowerStore remote system relationships:* Description* Management address - An IPv4 or IPv6 address. FQDN is not supported.For non-PowerStore remote system relationships:* Name* Description* Management address - An IPv4 address. FQDN is not supported.* Remote administrator credentials* iSCSI address - An IPv4 address.After modifying the remote session instance, the system reestablishes the data connections as needed.

**Supports noop?** false

#### Parameters

##### `data_network_latency`

Data type: `Optional[Enum['Low','High']]`

Network latency choices for a remote system. Replication traffic can be tuned for higher efficiency depending on the expected network latency. This will only be used when the remote system type is PowerStore.* Low                      - Less than 5 milliseconds.* High                     - More than 5 milliseconds.

##### `description`

Data type: `Optional[String[0,256]]`

User-specified description of the remote system.

##### `id`

Data type: `String`

Unique identifier of the remote system.

##### `management_address`

Data type: `Optional[String]`

Management IP address of the remote system.

##### `name`

Data type: `Optional[String[0,128]]`

User-specified name of the remote system. Used only for non-PowerStore type remote systems. This value must contain 128 or fewer printable Unicode characters.

##### `remote_password`

Data type: `Optional[String]`

Password used to access the remote system. Used only for non-PowerStore systems.

##### `remote_username`

Data type: `Optional[String]`

Username used to access the remote system. Used only for non-PowerStore systems.

### `remote_system_verify`

Verify and update the remote system instance. Detects changes in the local and remote systems and reestablishes data connections, also taking the Challenge Handshake Authentication Protocol (CHAP) settings into account.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the remote system.

### `replication_rule_collection_query`

Query all replication rules.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `replication_rule_create`

Create a new replication rule.

**Supports noop?** false

#### Parameters

##### `alert_threshold`

Data type: `Optional[Integer[0,1440]]`

Acceptable delay in minutes between the expected and actual replication sync intervals. The system generates an alert if the delay between the expected and actual sync exceeds this threshold. Alert threshold has the default value of one RPO in minutes.

##### `name`

Data type: `String`

Name of the replication rule.

##### `remote_system_id`

Data type: `String`

Unique identifier of the remote system to which this rule will replicate the associated resources.

##### `rpo`

Data type: `Enum['Five_Minutes','Fifteen_Minutes','Thirty_Minutes','One_Hour','Six_Hours','Twelve_Hours','One_Day']`

Recovery point objective (RPO), which is the acceptable amount of data, measured in units of time, that may be lost in case of a failure.

### `replication_rule_delete`

Delete a replication rule.Deleting a rule is not permitted, if the rule is associated with a protection policy thatis currently applied to a storage resource.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the replication rule.

### `replication_rule_instance_query`

Query a specific replication rule.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the replication rule.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `replication_rule_modify`

Modify a replication rule.If the rule is associated with a policy that is currently applied toa storage resource, the modified rule is immediately appliedto the associated storage resource.Changing the remote_system_id is not permitted, if the rule is part of a policy thatis currently applied to a storage resource. To change the remote system associated with areplication rule, do either of the following:    Remove the protection policy association from the relevant storage resources, modify the replication rule, and then associate the storage resources with the relevant protection policies.        Remove the replication rule from the protection policies that use it, modify the replication rule,        and then associate it back with the relevant protection policies.

**Supports noop?** false

#### Parameters

##### `alert_threshold`

Data type: `Optional[Integer[0,1440]]`

Acceptable delay in minutes between the expected and actual replication sync intervals. The system generates an alert if the delay between the expected and actual sync exceeds this threshold.

##### `id`

Data type: `String`

Unique identifier of the replication rule.

##### `name`

Data type: `Optional[String]`

Name of the replication rule.

##### `remote_system_id`

Data type: `Optional[String]`

Unique identifier of the remote system to which this rule will replicate the associated resources.

##### `rpo`

Data type: `Optional[Enum['Five_Minutes','Fifteen_Minutes','Thirty_Minutes','One_Hour','Six_Hours','Twelve_Hours','One_Day']]`

Recovery point objective (RPO), which is the acceptable amount of data, measured in units of time, that may be lost in case of a failure.

### `replication_session_collection_query`

Query replication sessions.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `replication_session_failover`

Fail over a replication session instance. Failing over the replication session changes the role of the destination system. After a failover, the original destination system becomes the source system, and production access is enabled for hosts and applications for recovery. Failovers can be planned or unplanned. Planned failovers are issued from the source system and are indicated by setting the is_planned parameter to true. When you fail over a replication session from the source system, the destination system is fully synchronized with the source to ensure that there is no data loss. During a planned failover, stop I/O operations for any applications and hosts. If a synchronization error occurs during a planned failover, the replication session enters the System_Paused state. You cannot pause a replication session during a planned failover. The following operations can be performed during planned failover:* Unplanned failover* Delete the replication session by removing the protection policy on the storage resourceAfter a planned failover, the replication session is in an inactive state. You can use the reprotect action to synchronize the destination storage resource, and then resume the replication session. The auto-reprotect feature can also be used after a planned failover by using the reverse parameter, which activates the session in the reverse direction. Unplanned failures are events such as source system failure or an event on the source system that leads to downtime for production access.Unplanned failovers are issued from the destination system, and are indicated by setting the is_planned parameter to false. Unplanned failovers provide production access to the original destination resource from a preview synchronized point-in-time snapshot referred to as replication common-base. After an unplanned failover, you can restore the system from any point-in-time snapshots on the new source resource. Unplanned failovers place the original source resource into destination mode once it reestablishes a connection to the source system.  You can use the reprotect action to synchronize the destination storage resource, and then resume the replication session.After the replication session has failed over, you can resize the volume group or change the volume group membership on the new source resource.

**Supports noop?** false

#### Parameters

##### `force`

Data type: `Optional[Boolean]`

Indicates whether an unplanned failover needs to be done for a session that is already in failed over state

##### `id`

Data type: `String`

Unique identifier of the replication session.

##### `is_planned`

Data type: `Optional[Boolean]`

Indicates whether the replication session failover is planned or unplanned. For planned failovers, the value is true. For unplanned failovers, the value is false.

##### `reverse`

Data type: `Optional[Boolean]`

Indicates whether the system is auto-reprotected. Auto-reprotect is combination of failover and reprotect. 

### `replication_session_instance_query`

Query a replication session instance.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the replication session.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `replication_session_pause`

Pause a replication session instance. You can pause a replication session when you need to modify the source or destination system. For example, you can pause the replication session to take the source or destination system down for maintenance. The session can be paused when it is in the following states:* OK - Remembers the replication session state before pausing, and resumes to OK state* Synchronizing - Remembers the restart address before pausing, and resumes from the restart address* System_Paused - Remembers the restart address before pausing, and resumes from the restart address as recorded when the system entered the System_Paused stateIn case of loss of network connectivity between two sites, the replication session is paused only on the local system where it is issued. Pause the replication session again to pause both sites. The following operations are not allowed while only the replication session on the local system is paused:* Resume* Sync* Planned FailoverThe following operations are allowed while only the replication session on the local system is paused:* Pause - Use to place both sites into the **Paused** state* Failover - Use to get production access from the disaster recovery site* Delete the replication session by removing the protection policy on the storage resourceThe following system operations may also pause, and subsequently resume, a replication session:* Non-disruptive upgrade* Intra-cluster migration Leaving replication session in a paused state results in change accumulations on the source system, and consume more storage on the source system. Resuming a replication session that has been paused for a long time can result in long synchronization times.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the replication session.

### `replication_session_reprotect`

Reprotect a replication session instance. Activates the replication session and starts synchronization. This can only be used when the session is in the has been failed over.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the replication session.

### `replication_session_resume`

Resume a replication session instance that is paused. Resuming the replication session schedules a synchronization cycle if the session was in the following states when the session was paused:* Synchronizing* System_Paused When only the replication session on the local system is paused, resuming the session pauses both sites.You cannot resume replication sessions paused by the system. The following system operations may also pause, and subsequently resume, a replication session. * Paused_for_NDU* Paused_for_Migration

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the replication session.

### `replication_session_sync`

Synchronize the destination resource with changes on source resource from the previous synchronization cycle. Synchronization happens either automatically according to a set schedule, or manually. User and scheduler-created snapshots are synchronized from the source system to the destination system while maintaining block sharing efficiency.  Also synchronizes any size changes, membership changes, or both, on the source resource. At the end of the synchronization cycle, the destination resource reflects the state as it was when synchronization began. Any size changes, membership changes, or both, to source resource done during the synchronization cycle are replicated in next synchronization cycle.Synchronization is allowed when the replication session is in the following states:* OK* System_PausedDuring synchronization, you can take the following actions:* Planned failover from the source system* Failover from the destination system* Pause replication sessions from the source or destination system* Delete a replication session by removing a protection policySynchronization failure places the replication session in a System_Paused state. When the system recovers, the replication session continues from the same point as when the system paused, using the restart address.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the replication session.

### `role_collection_query`

Query roles. This resource type collection query does not support filtering, sorting or pagination

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `role_instance_query`

Query a specific role.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the role.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `sas_port_collection_query`

Query the SAS port configuration for all cluster nodes.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `sas_port_instancequery`

Query a specific SAS port configuration.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the SAS port.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `security_config_collection_query`

Query system security configurations. This resource type collection query does not support filtering, sorting or pagination

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `security_config_instance_query`

Query a specific system security configuration.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the system security configuration.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `service_config_collection_query`

Query the service configuration instances for the cluster. This resource type collection query does not support filtering, sorting or pagination

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `service_config_instance_query`

Query the service configuration instances for an appliance.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the instance.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `service_config_modify`

Modify the service configuration for an appliance.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the instance.

##### `is_ssh_enabled`

Data type: `Boolean`

Current SSH service access state.* true  - Enables SSH access* false - Disables SSH access

### `service_user_collection_query`

Query the service user account instance. This resource type collection query does not support filtering, sorting or pagination

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `service_user_instance_query`

Query the service user account using the unique identifier.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the service user.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `service_user_modify`

Modify the properties of the service user account.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the service user account.

##### `password`

Data type: `String`

New password for the service user account. The password value can be 8 to 40 UTF-8 characters long, and include as a minimum one uppercase character, one lowercase character, one numeric character, and one special character from this list  [!,@#$%^*>_~].

### `smb_server_collection_query`

Query all SMB servers.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `smb_server_create`

Create an SMB server.

**Supports noop?** false

#### Parameters

##### `computer_name`

Data type: `Optional[String[1,63]]`

DNS name of the associated computer account when the SMB server is joined to an Active Directory domain.This name is limited to 63 bytes and must not contain the following characters -  - comma (.)  - tilde (~)  - colon (:)  - exclamation point (!)  - at sign (@)  - number sign (#)  - dollar sign ($)  - percent (%)  - caret (^)  - ampersand (&)  - apostrophe (')  - period (.) - note that if you enter string with period only the first word will be kept  - parentheses (())  - braces ({})  - underscore (_)  - white space (blank)as defined by the Microsoft naming convention (see https://support.microsoft.com/en-us/help/909264/)

##### `description`

Data type: `Optional[String[0,48]]`

Description of the SMB server in UTF-8 characters.

##### `domain`

Data type: `Optional[String[1,255]]`

Domain name where SMB server is registered in Active Directory, if applicable.

##### `is_standalone`

Data type: `Boolean`

Indicates whether the SMB server is standalone. Values are:- true - SMB server is standalone.- false - SMB server is joined to the Active Directory.

##### `local_admin_password`

Data type: `String[0,512]`

Regardless of the type of the SMB server, standalone or in the domain, a local administrator user must be created. local_admin_password is the password of this user.

##### `nas_server_id`

Data type: `String`

Unique identifier of the NAS server.

##### `netbios_name`

Data type: `Optional[String[1,15]]`

NetBIOS name is the network name of the standalone SMB server.SMB servers joined to Active Directory also have NetBIOS Name, defaulted to the 15 first characters of the computer_name attribute.Administrators can specify a custom NetBIOS Name for a SMB server using this attribute.NetBIOS name is limited to 15 characters and cannot contain the following characters -  - backslash (\)  - slash mark (/)  - colon (:)  - asterisk (*)  - question mark (?)  - quotation mark ('')  - less than sign (<)  - greater than sign (>)  - vertical bar (|)as defined by the Microsoft naming convention (see https://support.microsoft.com/en-us/help/909264/)

##### `workgroup`

Data type: `Optional[String[1,15]]`

Applies to standalone SMB servers only.Windows network workgroup for the SMB server.Workgroup names are limited to 15 alphanumeric ASCII characters.

### `smb_server_delete`

Delete a SMB server. The SMB server must not be joined to a domain to be deleted.

**Supports noop?** false

#### Parameters

##### `force`

Data type: `Optional[Boolean]`

If false, the delete will fail if the SMB server is still joined, else the SMB server is deleted but AD account is not removed.

##### `id`

Data type: `String`

Unique identifier of the SMB server.

### `smb_server_instance_query`

Query settings of a specific SMB server.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the SMB server.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `smb_server_join`

Join the SMB server to an Active Directory domain.

**Supports noop?** false

#### Parameters

##### `domain_password`

Data type: `String`

Password of the domain-user specified to join the Active Directory domain.

##### `domain_user_name`

Data type: `String`

Name of a domain-user with sufficient privileges to join the Active Directory domain.

##### `id`

Data type: `String`

Unique identifier of the SMB server.

##### `organizational_unit`

Data type: `Optional[String]`

Organizational unit of the SMB server in Active Directory, if applicable.

##### `reuse_computer_account`

Data type: `Optional[Boolean]`

If set to yes: try to reuse the existing SMB server account in the Active Directory when joining.

### `smb_server_modify`

Modify an SMB server's settings.

**Supports noop?** false

#### Parameters

##### `computer_name`

Data type: `Optional[String[1,63]]`

DNS Name of the associated Computer Account when the SMB server is joined to an Active Directory domain.This name is limited to 63 bytes and must not contain the following characters -  - comma (.)  - tilde (~)  - colon (:)  - exclamation point (!)  - at sign (@)  - number sign (#)  - dollar sign ($)  - percent (%)  - caret (^)  - ampersand (&)  - apostrophe (')  - period (.) - note that if you enter string with period only the first word will be kept  - parentheses (())  - braces ({})  - underscore (_)  - white space (blank)as defined by the Microsoft naming convention (see https://support.microsoft.com/en-us/help/909264/)

##### `description`

Data type: `Optional[String[0,48]]`

Description of the SMB server in UTF-8 characters.

##### `domain`

Data type: `Optional[String[1,255]]`

Domain name where SMB server is registered in Active Directory, if applicable.

##### `id`

Data type: `String`

Unique identifier of the SMB server.

##### `is_standalone`

Data type: `Optional[Boolean]`

Indicates whether the SMB server is standalone. Values are:- true - SMB server is standalone.- false - SMB server is joined to the Active Directory.

##### `local_admin_password`

Data type: `Optional[String[0,512]]`

Password for the local administrator account of the SMB server.

##### `netbios_name`

Data type: `Optional[String]`

NetBIOS name is the network name of the standalone SMB server.SMB servers joined to Active Directory also have NetBIOS Name, defaulted to the 15 first characters of the computer_name attribute.Administrators can specify a custom NetBIOS Name for an SMB server using this attribute.NetBIOS name is limited to 15 characters and cannot contain the following characters -  - backslash (\)  - slash mark (/)  - colon (:)  - asterisk (*)  - question mark (?)  - quotation mark ('')  - less than sign (<)  - greater than sign (>)  - vertical bar (|)as defined by the Microsoft naming convention (see https://support.microsoft.com/en-us/help/909264/)

##### `workgroup`

Data type: `Optional[String[1,15]]`

Applies to standalone SMB servers only.Windows network workgroup for the SMB server.Workgroup names are limited to 15 alphanumeric ASCII characters.

### `smb_server_unjoin`

Unjoin the SMB server from an Active Directory domain.

**Supports noop?** false

#### Parameters

##### `domain_password`

Data type: `Optional[String]`

Password of the domain-user specified to unjoin from the Active Directory domain.

##### `domain_user_name`

Data type: `Optional[String]`

Name of a domain-user with sufficient privileges to unjoin from the Active Directory domain.

##### `id`

Data type: `String`

Unique identifier of the SMB server.

##### `is_skip_ad_unjoin`

Data type: `Optional[Boolean]`

If set to yes: Will not remove the account from the Active Directory. This is to be used in case that no DC is available.

### `smb_share_collection_query`

List SMB shares.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `smb_share_create`

Create an SMB share.

**Supports noop?** false

#### Parameters

##### `description`

Data type: `Optional[String[0,511]]`

SMB share description.

##### `file_system_id`

Data type: `String`

Unique identifier of the file system on which the SMB Share will be created.

##### `is_abe_enabled`

Data type: `Optional[Boolean]`

Indicates whether Access-based Enumeration (ABE) is enabled. ABE filters the list of available files and folders on a server to include only those to which the requesting user has access. Values are:- true - ABE is enabled.- false - ABE is disabled.

##### `is_branch_cache_enabled`

Data type: `Optional[Boolean]`

Indicates whether BranchCace optimization is enabled. BranchCache optimization technology copies content from your main office or hosted cloud content servers and caches the content at branch office locations, allowing client computers at branch offices to access the content locally rather than over the WAN. Values are:- true - BranchCache is enabled.- false - BranchCache is disabled.

##### `is_continuous_availability_enabled`

Data type: `Optional[Boolean]`

Indicates whether continuous availability for Server Message Block (SMB) 3.0 is enabled for the SMB Share. Values are:- true - Continuous availability for SMB 3.0 is enabled for the SMB Share.- false - Continuous availability for SMB 3.0 is disabled for the SMB Share.

##### `is_encryption_enabled`

Data type: `Optional[Boolean]`

Indicates whether encryption for Server Message Block (SMB) 3.0 is enabled at the shared folder level. Values are:- true - encryption for SMB 3.0 is enabled.- false - encryption for SMB 3.0 is disabled.

##### `name`

Data type: `String[1,80]`

SMB share name.

##### `offline_availability`

Data type: `Optional[Enum['Manual','Documents','Programs','None']]`

Defines valid states of Offline Availability,   * Manual - Only specified files will be available offline.   * Documents - All files that users open will be available offline.   * Programs - Program will preferably run from the offline cache even when connected to the network. All files that users open will be available offline.   * None - Prevents clients from storing documents and programs in offline cache (default).

##### `path`

Data type: `String`

Local path to the file system or any existing sub-folder of the file system that is shared over the network.This path is relative to the NAS Server and must start with the filesystem's mountpoint path, which is the filesystem name.For example to share the top-level of a filesystem named svr1fs1, which is on the /svr1fs1 mountpoint of the NAS Server, use /svr1fs1 in the path parameter.SMB shares allow you to create multiple network shares for the same local path.

##### `umask`

Data type: `Optional[String]`

The default UNIX umask for new files created on the Share. If not specified the umask defaults to 022.

### `smb_share_delete`

Delete an SMB Share.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

SMB Share object id.

### `smb_share_instance_query`

Get an SMB Share.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

SMB Share object id.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `smb_share_modify`

Modify SMB share properties.

**Supports noop?** false

#### Parameters

##### `description`

Data type: `Optional[String[0,511]]`

NFS Share description.

##### `id`

Data type: `String`

SMB share object id.

##### `is_abe_enabled`

Data type: `Optional[Boolean]`

Indicates whether Access-based Enumeration (ABE) is enabled. ABE filters the list of available files and folders on a server to include only those, that the requesting user has access to. Values are:- true - ABE is enabled.- false - ABE is disabled.

##### `is_branch_cache_enabled`

Data type: `Optional[Boolean]`

Indicates whether BranchCace optimization is enabled. BranchCache optimization technology copies content from your main office or hosted cloud content servers and caches the content at branch office locations, allowing client computers at branch offices to access the content locally rather than over the WAN. Values are:- true - BranchCache is enabled.- false - BranchCache is disabled.

##### `is_continuous_availability_enabled`

Data type: `Optional[Boolean]`

Indicates whether continuous availability for Server Message Block (SMB) 3.0 is enabled for the SMB Share. Values are:- true - Continuous availability for SMB 3.0 is enabled for the SMB Share.- false - Continuous availability for SMB 3.0 is disabled for the SMB Share.

##### `is_encryption_enabled`

Data type: `Optional[Boolean]`

Indicates whether encryption for Server Message Block (SMB) 3.0 is enabled at the shared folder level. Values are:- true - encryption for SMB 3.0 is enabled.- false - encryption for SMB 3.0 is disabled.

##### `offline_availability`

Data type: `Optional[Enum['Manual','Documents','Programs','None']]`

Defines valid states of Offline Availability,   * Manual - Only specified files will be available offline.   * Documents - All files that users open will be available offline.   * Programs - Program will preferably run from the offline cache even when connected to the network. All files that users open will be available offline.   * None - Prevents clients from storing documents and programs in offline cache (default).

##### `umask`

Data type: `Optional[String]`

The default UNIX umask for new files created on the Share.

### `smtp_config_collection_query`

Query the SMTP configuration. There is always exactly one smtp_config instance.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `smtp_config_instance_query`

Query the specific SMTP configuration.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the SMTP configuration.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `smtp_config_modify`

Configure the outgoing SMTP information.

**Supports noop?** false

#### Parameters

##### `address`

Data type: `Optional[String]`

IP address of the SMTP server.

##### `id`

Data type: `String`

Unique identifier of the SMTP configuration.

##### `port`

Data type: `Optional[Integer[0,65535]]`

Port used for sending SMTP messages.

##### `source_email`

Data type: `Optional[String]`

Source email address used for sending SMTP messages.

### `smtp_config_test`

Test the SMTP configuration.

**Supports noop?** false

#### Parameters

##### `email_address`

Data type: `Optional[String]`

Destination email address for the test.

##### `id`

Data type: `String`

Unique identifier of the SMTP configuration.

### `snapshot_rule_collection_query`

Query all snapshot rules.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `snapshot_rule_create`

Create a new snapshot rule.

**Supports noop?** false

#### Parameters

##### `days_of_week`

Data type: `Optional[Array[Enum['Monday','Tuesday','Wednesday','Thursday','Friday','Saturday','Sunday']]]`

Days of the week when the rule should be applied. Applies only for rules where the time_of_day parameter is set.

##### `desired_retention`

Data type: `Integer[1,8760]`

Desired snapshot retention period in hours. The system will retain snapshots for this time period, if space is available.

##### `interval`

Data type: `Optional[Enum['Five_Minutes','Fifteen_Minutes','Thirty_Minutes','One_Hour','Two_Hours','Three_Hours','Four_Hours','Six_Hours','Eight_Hours','Twelve_Hours','One_Day']]`

Interval between snapshots. Either the interval parameter or the time_of_day parameter may be set. Setting one clears the other parameter.

##### `name`

Data type: `String`

Snapshot rule name.

##### `time_of_day`

Data type: `Optional[String]`

Time of the day to take a daily snapshot, with format 'hh:mm' in 24 hour time format. Either the interval parameter or the time_of_day parameter may be set, but not both.

### `snapshot_rule_delete`

Delete a snapshot rule

**Supports noop?** false

#### Parameters

##### `delete_snaps`

Data type: `Optional[Boolean]`

Specify whether all snapshots previously created by this rule should also be deleted when this rule is removed.

##### `id`

Data type: `String`

Unique identifier of the snapshot rule.

### `snapshot_rule_instance_query`

Query a specific snapshot rule.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the snapshot rule.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `snapshot_rule_modify`

Modify a snapshot rule.If the rule is associated with a policy that is currently applied toa storage resource, the modified rule is immediately appliedto that associated storage resource.

**Supports noop?** false

#### Parameters

##### `days_of_week`

Data type: `Optional[Array[Enum['Monday','Tuesday','Wednesday','Thursday','Friday','Saturday','Sunday']]]`

Days of the week when the rule should be applied. Applies only for rules where the time_of_day parameter is set.

##### `desired_retention`

Data type: `Optional[Integer[1,8760]]`

Desired snapshot retention period in hours. The system will retain snapshots for this time period, if space is available.

##### `id`

Data type: `String`

Unique identifier of the snapshot rule.

##### `interval`

Data type: `Optional[Enum['Five_Minutes','Fifteen_Minutes','Thirty_Minutes','One_Hour','Two_Hours','Three_Hours','Four_Hours','Six_Hours','Eight_Hours','Twelve_Hours','One_Day']]`

Interval between snapshots. Either the interval parameter or the time_of_day parameter may be set. Setting one clears the other parameter.

##### `name`

Data type: `Optional[String]`

Snapshot rule name.

##### `time_of_day`

Data type: `Optional[String]`

Time of the day to take a daily snapshot, with format 'hh:mm' in 24 hour time format. Either the interval parameter or the time_of_day parameter may be set, but not both.

### `software_installed_collection_query`

Query the software that is installed on each appliance. The output returns a list of JSON objects representing the software that is installed on each appliance and one entry representing the common software installed version that is supported for all appliances in the cluster.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `software_installed_instance_query`

Query a specific item from the list of installed software.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the installed software to query.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `software_package_collection_query`

Query the software packages that are known by the cluster. The output returns a list of JSON objects representing the packages.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `software_package_delete`

Delete the specified software package from the cluster. This operation may take some time to complete.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the software package to delete.

### `software_package_install`

Start a software upgrade background job for the specified appliance within the cluster. If an  appliance is not specified, the upgrade is performed on all appliances in the cluster.Only specify a subset of appliances to upgrade if the time required to upgrade the entire cluster does not fit within a desired maintenance window. When upgrading a subset of appliances, you must adhere to the following ordering rules:* The primary appliance must always be upgraded first.* The secondary appliance, which is used as the cluster management database fail-over target, must be upgraded second.* After the primary and secondary appliances are upgraded, any remaining appliances in the cluster may be upgraded. By default, the process upgrades the appliances in the order they were added to the cluster if possible.Because this operation takes a long time to complete, using the 'is_async flag' is recommended. If the 'is_reboot_required' flag is set to true, the primary appliance reboots before the install completes and the operation cannot return synchronously.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the instance.

### `software_package_instance_query`

Query a specific software package.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the software package to query.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `software_package_puhc`

Run the pre-upgrade health check for a software package. This operation may take some time to respond.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the software package.

### `software_package_upload`

Push a software package file from the client to the cluster. When successfully uploaded and verified, the result is a software_package in the downloaded state, ready to install.

**Supports noop?** false

#### Parameters

##### `upload_file`

Data type: `Optional[String]`

Name of the software package file to upload.

### `storage_container_collection_query`

List storage containers.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `storage_container_create`

Create a virtual volume (vVol) storage container.

**Supports noop?** false

#### Parameters

##### `name`

Data type: `String[1,64]`

Name for the storage container that is unique across all storage containers in the cluster. The name must be between 1 and 64 UTF-8 characters (inclusive), and not more than 127 bytes.

##### `quota`

Data type: `Optional[Integer[0,4611686018427387904]]`

The number of bytes that can be provisioned against this storage container. This must be a value greater than 10Gb and the default is 0 which means no limit.

### `storage_container_delete`

Delete a storage container.

**Supports noop?** false

#### Parameters

##### `force`

Data type: `Optional[Boolean]`

Normally, deletion of a storage container that is mounted or still contains virtual volumes will be rejected. This option overrides that error and allows the delete to continue. Use with great caution.

##### `id`

Data type: `String`

Storage container ID.

### `storage_container_instance_query`

Query a specific instance of storage container.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Storage container ID.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `storage_container_modify`

Modify a storage container.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Storage container ID.

##### `name`

Data type: `Optional[String[1,64]]`

New name for the storage container that is unique across all storage containers in the cluster. The name must be between 1 and 64 UTF-8 characters (inclusive), and not more than 127 bytes.

##### `quota`

Data type: `Optional[Integer[0,4611686018427387904]]`

The number of bytes that can be provisioned against this storage container. It cannot be set lower than the current used space or 10Gb.  A value of 0 means unlimited.

### `storage_container_mount`

Mount a storage container as a vVol datastore in vCenter.

**Supports noop?** false

#### Parameters

##### `datastore_name`

Data type: `Optional[String]`

This will be the vVol datastore name in vCenter when it is mounted.

##### `id`

Data type: `String`

Storage container ID.

### `storage_container_unmount`

Unmount a storage container, which removes the vVol datastore from vCenter.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Storage container ID.

### `vcenter_collection_query`

Query registered vCenters.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `vcenter_create`

Add a vCenter. Not allowed in Unified+ deployments.

**Supports noop?** false

#### Parameters

##### `address`

Data type: `Optional[String]`

IP address of vCenter host, in IPv4, IPv6, or hostname format.

##### `password`

Data type: `Optional[String]`

Password to login to vCenter.

##### `username`

Data type: `Optional[String]`

User name to login to vCenter.

### `vcenter_delete`

Delete a registered vCenter. Deletion of vCenter disables functionality that requires communication with vCenter. Not allowed in Unified+ deployments.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the vCenter to delete.

### `vcenter_instance_query`

Query a specific vCenter instance.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the vCenter to query.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `vcenter_modify`

Modify a vCenter settings.

**Supports noop?** false

#### Parameters

##### `address`

Data type: `Optional[String]`

IP address of vCenter host, in IPv4, IPv6, or hostname format. Must be a new address of the same vCenter.

##### `id`

Data type: `String`

Unique identifier of the vCenter to modify.

##### `password`

Data type: `Optional[String]`

Password to login to vCenter.

##### `username`

Data type: `Optional[String]`

User name to login to vCenter. Password needs to be provided to modify the user name.

### `veth_port_collection_query`

Query virtual Ethernet port configurations.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `veth_port_instance_query`

Query a specific virtual Ethernet port configuration.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the virtual Ethernet port.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `virtual_machine_collection_query`

Query virtual machines that use storage from the cluster.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `virtual_machine_delete`

Delete a virtual machine snapshot. This operation cannot be used on a base virtual machine or virtual machine template.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the virtual machine snapshot to delete.

### `virtual_machine_instance_query`

Query a specific virtual machine instance.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the virtual machine to query.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `virtual_machine_modify`

Modify a virtual machine. This operation cannot be used on virtual machine snapshots or templates.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the virtual machine to modify.

##### `protection_policy_id`

Data type: `Optional[String]`

Unique identifier of the protection policy.

### `virtual_machine_snapshot`

Create a snapshot of a virtual machine. This operation cannot be used on a virtual machine snapshot or template.

**Supports noop?** false

#### Parameters

##### `description`

Data type: `Optional[String[0,2000]]`

Description of the snapshot. This value must contain 2000 or fewer printable Unicode characters.

##### `id`

Data type: `String`

Unique identifier of the virtual machine to create a snapshot of.

##### `name`

Data type: `Optional[String[0,80]]`

Name of the snapshot. This value must contain 80 or fewer printable Unicode characters.

### `virtual_volume_collection_query`

Get virtual volumes.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `virtual_volume_delete`

Delete a virtual volume.

**Supports noop?** false

#### Parameters

##### `force`

Data type: `Optional[Boolean]`

Normally, attempting to delete a bound virtual volume is not permitted. This option overrides that error and allows the delete to continue.

##### `id`

Data type: `String`

Unique identifier of the virtual volume to delete.

### `virtual_volume_instance_query`

Get a specific virtual volume.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Id of the virtual volume.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `volume_attach`

Attach a volume to a host or host group.

**Supports noop?** false

#### Parameters

##### `host_group_id`

Data type: `Optional[String]`

Unique identifier of the host group to be attached to the volume. Only one of host_id or host_group_id can be supplied.

##### `host_id`

Data type: `Optional[String]`

Unique identifier of the host to be attached to the volume. Only one of host_id or host_group_id can be supplied.

##### `id`

Data type: `String`

Unique identifier of volume to attach.

##### `logical_unit_number`

Data type: `Optional[Integer[0,16383]]`

Logical unit number for the host volume access.

### `volume_clone`

Create a clone of a volume or snapshot.

**Supports noop?** false

#### Parameters

##### `description`

Data type: `Optional[String[0,128]]`

Description of the clone. This value must contain 128 or fewer printable Unicode characters.

##### `host_group_id`

Data type: `Optional[String]`

Unique identifier of the host group to be attached to the clone. Only one of host_id or host_group_id can be supplied.

##### `host_id`

Data type: `Optional[String]`

Unique identifier of the host to be attached to the clone. Only one of host_id or host_group_id can be supplied.

##### `id`

Data type: `String`

Unique identifier of the volume or snapshot to create a clone of.

##### `logical_unit_number`

Data type: `Optional[Integer[0,16383]]`

Optional logical unit number when creating a mapped volume.  If no host_id or host_group_id is specified, this property is ignored.

##### `name`

Data type: `Optional[String[0,128]]`

Name of the clone. This value must contain 128 or fewer printable Unicode characters.

##### `performance_policy_id`

Data type: `Optional[String]`

Unique identifier of the  performance policy.

##### `protection_policy_id`

Data type: `Optional[String]`

Unique identifier of the protection policy.

### `volume_collection_query`

Query volumes that are provisioned on the appliance.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `volume_create`

Create a volume on the appliance.

**Supports noop?** false

#### Parameters

##### `appliance_id`

Data type: `Optional[String]`

Identifier of the appliance on which the volume is provisioned.

##### `description`

Data type: `Optional[String[0,128]]`

Description of the volume. This value must contain 128 or fewer printable Unicode characters.

##### `host_group_id`

Data type: `Optional[String]`

Unique identifier of the host group to be attached to the volume. If not specified, an unmapped volume is created. Only one of host_id or host_group_id can be supplied.

##### `host_id`

Data type: `Optional[String]`

Unique identifier of the host to be attached to the volume. If not specified, an unmapped volume is created. Only one of host_id or host_group_id can be supplied.

##### `logical_unit_number`

Data type: `Optional[Integer[0,16383]]`

Optional logical unit number when creating a  attached volume.  If no host_id or host_group_id is specified, this property is ignored.

##### `min_size`

Data type: `Optional[Integer[0,9223372036854775807]]`

Optional minimum size for the volume, in bytes.

##### `name`

Data type: `String[0,128]`

Unique name for the volume to be created. This value must contain 128 or fewer printable Unicode characters.

##### `performance_policy_id`

Data type: `Optional[String]`

Unique identifier of the performance policy assigned to the volume.

##### `protection_policy_id`

Data type: `Optional[String]`

Unique identifier of the protection policy assigned to the volume.

##### `sector_size`

Data type: `Optional[Integer[512,4096]]`

Optional sector size, in bytes. Only 512-byte and 4096-byte sectors are supported.

##### `size`

Data type: `Integer[1048576,281474976710656]`

Size of the volume to be created, in bytes. Minimum volume size is 1MB. Maximum volume size is 256TB. Size must be a multiple of 8192.

##### `volume_group_id`

Data type: `Optional[String]`

Volume group to add the volume to.  If not specified, the volume is not added to a volume group.

### `volume_delete`

Delete a volume. * A volume which is attached to a host or host group or is a member of a volume group cannot be deleted.* A volume which has protection policies attached to it cannot be deleted.* A volume which has snapshots that are part of a snapset cannot be deleted.* Clones of a deleted production volume or a clone are not deleted.* Snapshots of the volume are deleted along with the volume being deleted.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the volume to delete.

### `volume_detach`

Detach a volume from a host or host group.

**Supports noop?** false

#### Parameters

##### `host_group_id`

Data type: `Optional[String]`

Unique identifier of the host group to be detached from this volume. Only one of host_id or host_group_id can be supplied.

##### `host_id`

Data type: `Optional[String]`

Unique identifier of the host to be detached from this volume. Only one of host_id or host_group_id can be supplied.

##### `id`

Data type: `String`

Unique identifier of volume to detach.

### `volume_group_add_members`

Add member volumes to an existing primary or clone volume group.This cannot be used to add members to a snapshot set. Members cannot be added to a volume group that is acting as the destination in a replication session.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the volume group.

##### `volume_ids`

Data type: `Array[String]`

A list of primary or clone volumes to be added to the volume group. Snapshots cannot be added to a volume group. All the volumes should be on the same appliance as the current members of the volume group.This list cannot be empty.

### `volume_group_clone`

Clone a volume group. The clone volume group will be created on the same appliance as the source volume group.A clone of a volume group will result in a new volume group of __Clone__ type. The clone will belong to the same family as the source volume group.When the source of a clone operation is a either primary or clone volume group, * __source_id__ will be set to the identifier of the source volume group. * __source_time__ will be set to the time at which the clone will be created.When the source of a clone operation is a snapshot set, * __source_id__ will be set to the source_id of the source snapshot set. * __source_time__ will be set to the source_time of the source snapshot set.The clone volume group will inherit the value of the __is_write_order_consistent__ property from the source volume group. A clone of a snapshot set is modeled as a clone of the snapshot set's source, created at the same time instant as when the source snapshot set was created.

**Supports noop?** false

#### Parameters

##### `description`

Data type: `Optional[String]`

Description for the clone volume group.If description is not specified, the description for the snapshot set will not be set.

##### `id`

Data type: `String`

Unique identifier of the volume group.

##### `is_replication_destination`

Data type: `Optional[Boolean]`

A boolean flag to indicate whether the clone volume group is a destination of a replication session.This parameter defaults to false, if not specified.

##### `name`

Data type: `String`

Unique name for the clone volume group.

##### `protection_policy_id`

Data type: `Optional[String]`

Unique identifier of the protection policy you want to assign to the clone volume group.

### `volume_group_collection_query`

Query all volume groups, including snapshot sets and clones of volume groups.

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `volume_group_create`

Create a new volume group. The resulting volume group will have a type of Primary.

**Supports noop?** false

#### Parameters

##### `description`

Data type: `Optional[String[0,256]]`

Description for the volume group. The description should not be more than 256characters long and should not have any unprintable characters.If description is not specified, the description for the volume group will not be set.

##### `is_write_order_consistent`

Data type: `Optional[Boolean]`

A boolean flag to indicate whether snapshot sets of the volume group will be write-order consistent.This parameter defaults to true, if not specified.

##### `name`

Data type: `String[0,128]`

Unique name for the volume group. The name should contain no special HTTP characters and no unprintable characters. Although the case of the name provided is reserved, uniqueness check is case-insensitive, so the same name in two different cases is not considered unique.

##### `protection_policy_id`

Data type: `Optional[String]`

Unique identifier of an optional protection policy to assign to the volume group.

##### `volume_ids`

Data type: `Optional[Array[String]]`

A list of identifiers of existing volumes that should be added to the volume group. All the volumes must be on the same Cyclone appliance and should not be part of another volume group.If a list of volumes is not specified or if the specified list is empty, anempty volume group of type Volume will be created.

### `volume_group_delete`

Delete a volume group, snapshot set, or clone.Before you try deleting a volume group, snapshot set, or clone, ensure that you first detach it from all hosts. Note the following:* When a volume group or clone is deleted, all related snapshot sets will also be deleted.* When a snapshot set is deleted, all of its constituent snapshots will also be deleted.

**Supports noop?** false

#### Parameters

##### `delete_members`

Data type: `Optional[Boolean]`

By default, the members of a volume group being deleted are only removed. Set this optional parameter to true to override this behavior and also delete the members after they are removed from the volume group.This parameter defaults to false, if not specified.

##### `id`

Data type: `String`

Unique identifier of the volume group.

### `volume_group_instance_query`

Query a specific volume group, snapshot set, or clone.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the volume group.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `volume_group_modify`

Modify a volume group, snapshot set, or clone.

**Supports noop?** false

#### Parameters

##### `description`

Data type: `Optional[String[0,256]]`

New description for the volume group. The description should not have any unprintable characters.If an empty string is specified, the description will be cleared.

##### `force`

Data type: `Optional[Boolean]`

Normally a replication destination volume group cannot be modified since it is controlled by replication. However, there can be cases where replication has failed or is no longer active and the replication destination volume group needs to be cleaned up.With the force option, the user will be allowed to remove the protection policy from the replication destination volume group provided that the replication session has never been synchronized.This parameter defaults to false, if not specified.

##### `id`

Data type: `String`

Unique identifier of the volume group.

##### `is_replication_destination`

Data type: `Optional[Boolean]`

New value for is_replication_destination property. is_replication_destination property of all the volumes in the volume group will be modified to the specified value. Modification of is_replication will not be transactional in nature. If the command only succeeds in modifying the is_replication_destination property of a subset of volumes, is_replication_destination property for the volume group will be set to true.Modification of this property is idempotent.This parameter is only valid when modifying a primary or a clone volume group, only when the volume group is no longer the destination of a replication session, and may only be set to false.

##### `is_write_order_consistent`

Data type: `Optional[Boolean]`

A boolean flag to indicate whether snapshot sets of the volume group will be write-order consistent.This parameter is only valid when modifying a primary or a clone volume group.

##### `name`

Data type: `Optional[String[0,128]]`

New name for the volume group. The name should contain no special HTTP characters and no unprintable characters. Although the case of the name provided is reserved, uniqueness check is case-insensitive, so the same name in two different cases is not considered unique.

##### `protection_policy_id`

Data type: `Optional[String]`

Unique identifier of the protection policy to assign to a primary or clone volume group. If an empty string is specified, protection policy will be removed from the volume group.

### `volume_group_refresh`

Refresh the contents of a volume group (the target volume group) from another volume group in the same family.A backup snapshot set of the target volume group will be created before refresh is attempted. This behavior can be overridden by setting the __create_backup_snap__ property to false. The profile for the backup snapshot set will be auto-generated, unless a custom profile is specified. The auto-generated profile only initializes the name to an auto-generated, unique value. Other optional parameters are not specified.The table below outlines supported modes of operation and resulting updates to __source_id__ and __source_time__ attributes of __protection_data__.|Target volume group|Source volume group|New source_id|New source_time||-|-|-|-||Primary (P1) |Clone (C1)|id of clone (C1)|Current time||Primary (P1) |snapshot set (C1S1) of clone (C1)|id of source snapshot set (C1S1)|source_time of source snapshot set (C1S1)||Clone (C1) |Primary (P1)|id of primary (P1)|Current time||Clone (C1) |snapshot set (S1) of primary (P1)|id of source snapshot set (S1)|source_time of source snapshot set (S1)||Clone (C1) |Clone (C2)|id of source clone(C2)|Current time||Clone (C1) |snapshot set (C2S1) of clone (C2)|id of source snapshot set (C2S1)|source_time of source snapshot set (C2S1)|Refresh operation is only supported if there are no membership changes between the source and target volume groups of the refresh operation. You can refresh a volume group even when the sizes of the volumes in the target volume group have changed. This represents a case where the source volumes have been modified over time and you want to refresh the target to the new state of the source volume group. A volume group that is acting as the destination in a replication session cannot be refreshed.

**Supports noop?** false

#### Parameters

##### `backup_snap_profile`

Data type: `Optional[Struct[{Optional[description] => Optional[String], name => Optional[String], }]]`

Snapshot volume group request.

##### `create_backup_snap`

Data type: `Optional[Boolean]`

This parameter specifies whether a backup snapshot set of the target volume group needs to be created before refreshing it.This parameter defaults to true, if not specified.

##### `from_object_id`

Data type: `String`

Unique identifier of the volume group to refresh from. This is referred to as the source volume group.

##### `id`

Data type: `String`

Unique identifier of the volume group.

### `volume_group_remove_members`

Remove members from an existing primary or clone volume group.This cannot be used to remove members from a snapshot set. Members cannot be removed from a volume group that is a acting as the destination in a replication session.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the volume group.

##### `volume_ids`

Data type: `Array[String]`

A list of volumes that need to be removed from the volume group.This list cannot be empty.

### `volume_group_restore`

Restore a volume group from a snapshot set. A primary or a clone volume group can only be restored from one of its immediate snapshot sets.A backup snapshot set of the target volume group will be created before restore is attempted. This behavior can be overridden by setting the __create_backup_snap__ property to false. The profile for the backup snapshot set will be auto-generated unless a custom profile is specified. The auto-generated profile only initializes the name to an auto-generated, unique value. Other optional parameters are not specified.Restore operation is only supported if there are no membership changes between the target volume group and source snapshot set.You can restore a volume group even when the sizes of the volumes in the target volume group have changed. This represents a case where the target volumes have been modified over time, but you want to revert them back to their old state captured in the source snapshot set.When a volume group is restored, * __source_time__ is set to the __source_time__ of the snapshot set it is being restored from.A volume group that is acting as the destination in a replication session cannot be restored.

**Supports noop?** false

#### Parameters

##### `backup_snap_profile`

Data type: `Optional[Struct[{Optional[description] => Optional[String], name => Optional[String], }]]`

Snapshot volume group request.

##### `create_backup_snap`

Data type: `Optional[Boolean]`

This parameter specifies whether a backup snapshot set of the target volume group needs to be created before attempting restore. This parameter defaults to true, if not specified.

##### `from_snap_id`

Data type: `String`

Unique identifier of the snapshot set to restore from. This is referred to as the source volume group.

##### `id`

Data type: `String`

Unique identifier of the volume group.

### `volume_group_snapshot`

Create a new snapshot set for a volume group.When a snapshot of a volume group is created, the resultant snapshot volume group is referred to as a 'snapshot set' and it represents a point-in-time copy of the members in the volume group. The snapshot set will be created on the same appliance as the source volume group.A snapshot of a volume group will result in a new volume group of __Snapshot__ type. The snapshot set will belong to the same family as the source volume group.When the source of a snapshot operation is a primary or clone volume group, * __source_id__ of the snapshot set will be set to the identifier of the source volume group. * __source_time__ of the snapshot set will be set to the time at which the snapshot set will be created.The __is_write_order_consistent__ property of the source volume group determines whether the snapshot set will be write-order consistent.

**Supports noop?** false

#### Parameters

##### `description`

Data type: `Optional[String]`

Optional description for the snapshot set.If description is not specified, the description for the snapshot set will not be set.

##### `id`

Data type: `String`

Unique identifier of the volume group.

##### `name`

Data type: `String`

Unique name of the snapshot set to be created.

### `volume_instance_query`

Query a specific volume instance.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the volume to query.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `volume_modify`

Modify the parameters of a volume.

**Supports noop?** false

#### Parameters

##### `description`

Data type: `Optional[String[0,128]]`

New description of the volume. This value must contain 128 or fewer printable Unicode characters.

##### `expiration_timestamp`

Data type: `Optional[String]`

New expiration time of the snapshot. Expired snapshots are deleted by the snapshot aging service that runs periodically in the background. If not specified, the snapshot never expires.Use a maximum timestamp value to set an expiration to never expire.

##### `force`

Data type: `Optional[Boolean]`

Normally a replication destination volume cannot be modified since it is controlled by replication. However, there can be cases where replication has failed or is no longer active and the replication destination volume needs to be cleaned up.With the force option, the user will be allowed to remove the protection policy from the replication destination volume provided that the replication session has never been synchronized and the last_sync_timestamp property is empty.This parameter defaults to false, if not specified.

##### `id`

Data type: `String`

Unique identifier of the volume to modify.

##### `is_replication_destination`

Data type: `Optional[Boolean]`

New value for is_replication_destination property. The modification is only supported for primary and clone volume, only when the current value is true and there is no longer a replication session using this volume as a destination, and only to false.

##### `name`

Data type: `Optional[String[0,128]]`

New name of the volume. This value must contain 128 or fewer printable Unicode characters.

##### `node_affinity`

Data type: `Optional[Enum['System_Select_At_Attach','System_Selected_Node_A','System_Selected_Node_B','Preferred_Node_A','Preferred_Node_B']]`

This attribute shows which node will be advertised as the optimized IO path to the volume. It is initially set to System_Select_At_Attach and can be modified to other values. When a volume is first attached to a host, if node_affinity is System_Select_At_Attach then the system will make the assignment to either System_Selected_Node_A or System_Selected_Node_B. The node_affinity may be modified to one of System_Select_At_Attach or Preferred_Node_A or Preferred_Node_B. Both System_Selected_Node_A and System_Selected_Node_B are reserved for system use only and cannot be set as the volume's node_affinity.Possible affinity for a volume. * System_Select_At_Attach - Volume currently has no node affinity, affinity will be assigned when the volume is first attached. * System_Selected_Node_A - System selected Node A as the optimized IO path to volume. * System_Selected_Node_B - System selected Node B as the optimized IO path to volume. * Preferred_Node_A - Node A will always advertise as the optimized IO path to volume. * Preferred_Node_B - Node B will always advertise as the optimized IO path to volume.

##### `performance_policy_id`

Data type: `Optional[String]`

Unique identifier of the performance policy assigned to the volume.

##### `protection_policy_id`

Data type: `Optional[String]`

Unique identifier of the protection policy assigned to the volume.

##### `size`

Data type: `Optional[Integer[8192,281474976710656]]`

New size of the volume in bytes,  must be a multiple of 8192, must be bigger than the current volume size. Maximum volume size is 256TB.

### `volume_refresh`

Refresh the contents of the target volume from another volume in the same family. By default, a backup snapshot of the target volume is not created before the refresh is attempted. To create a snapshot before refreshing, set __create_backup_snap__ to true. If a snapshot is taken, the response includes the resulting snapshot id; otherwise it is empty. If a custom profile is not specified, the profile for the backup snapshot is automatically generated. The automatically generated profile only provides the name as an automatically generated, unique value. Other optional parameters are not specified. When a volume is refreshed, the source_time is the source_time of the volume from which it is refreshed.

**Supports noop?** false

#### Parameters

##### `backup_snap_profile`

Data type: `Optional[Hash]`



##### `create_backup_snap`

Data type: `Optional[Boolean]`

Indicates whether to create a backup snapshot of the volume before refreshing.

##### `from_object_id`

Data type: `String`

Unique identifier of the source object of the refresh operation. The refresh operation only refreshes the data.

##### `id`

Data type: `String`

Unique identifier of volume for which to refresh contents.

### `volume_restore`

Restore a volume from a snapshot. A primary or clone volume can only be restored from one of its immediate snapshots.  By default, a backup snapshot of the target snapshot is created before the restore is attempted. To skip creating a snapshot before restoring, set create_backup_snap to false. If a snapshot is taken, the response includes the resulting snapshot id; otherwise it is empty. If a custom profile is not specified, the profile for the backup snapshot is automatically generated. The automatically generated profile only provides the name as an automatically generated, unique value. Other optional parameters are not specified. When a volume is restored, the source_time is the source_time of the snapshot from which it is restored.

**Supports noop?** false

#### Parameters

##### `backup_snap_profile`

Data type: `Optional[Hash]`



##### `create_backup_snap`

Data type: `Optional[Boolean]`

Indicates whether to create a backup snapshot of the volume before restoring.

##### `from_snap_id`

Data type: `String`

Unique identifier of the source snapshot for the restore operation.

##### `id`

Data type: `String`

Unique identifier of the volume to restore.

### `volume_snapshot`

Create a snapshot of a volume or a clone. The source id of the snapshot is the id of source volume or clone. The source time is the time when the snapshot is created.

**Supports noop?** false

#### Parameters

##### `creator_type`

Data type: `Optional[Enum['User','System','Scheduler']]`

Creator type of the storage resource. * User - A resource created by a user. * System - A resource created by the replication engine. * Scheduler - A resource created by the snapshot scheduler.

##### `description`

Data type: `Optional[String[0,128]]`

Description of the snapshot. This value must contain 128 or fewer printable Unicode characters.

##### `expiration_timestamp`

Data type: `Optional[String]`

Expiration time of the snapshot. Expired snapshots are deleted by the snapshot aging service that runs periodically in the background. If not specified, the snapshot never expires.Use a maximum timestamp value to set an expiration to never expire.

##### `id`

Data type: `String`

Unique identifier of the volume or clone to create a snapshot of.

##### `name`

Data type: `Optional[String[0,128]]`

Name of the snapshot to be created. This value must contain 128 or fewer printable Unicode characters. The default name of the volume snapshot is the date and time when the snapshot is taken.

##### `performance_policy_id`

Data type: `Optional[String]`



### `x509_certificate_collection_query`

Query to list X509 Certificates instances. This resource type collection query does not support filtering, sorting or pagination

**Supports noop?** false

#### Parameters

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

### `x509_certificate_decommission_certificates`

Decommission x509 certificates for one service type (currently only Replication_HTTP is supported) of one scope (for example remote system)

**Supports noop?** false

#### Parameters

##### `scope`

Data type: `String`

Scope of the certificate to be decommissioned, for example, remote system global id, serial number and such.

##### `service`

Data type: `Enum['Management_HTTP','Replication_HTTP','VASA_HTTP','Import_HTTP']`

Type of the service for which the certificate is used:* Management HTTP - Management Web server* Replication HTTP - Remote Replication service* VASA HTTP - VASA provider service* Import HTTP - External web service

### `x509_certificate_exchange_certificates`

Exchange certificates between two clusters. Add CA certificates to the trust store of each cluster and assign roles to the client certificates. After this process, certificate-based authentication can be used for communication between clusters. This exchange REST API can only be triggered with service Replication_HTTP.

**Supports noop?** false

#### Parameters

##### `address`

Data type: `String`

Peer's ip v4 or v6 address or dns name.

##### `password`

Data type: `String`

Password used in basic authentication to remote PowerStore cluster.

##### `port`

Data type: `Integer[0,65535]`

Peer's port number.

##### `service`

Data type: `Enum['Management_HTTP','Replication_HTTP','VASA_HTTP','Import_HTTP']`

Type of the service for which the certificate is used:* Management HTTP - Management Web server* Replication HTTP - Remote Replication service* VASA HTTP - VASA provider service* Import HTTP - External web service

##### `username`

Data type: `String`

Username used in basic authentication to remote PowerStore cluster.

### `x509_certificate_instance_query`

Query a specific X509 Certificate instance.

**Supports noop?** false

#### Parameters

##### `id`

Data type: `String`

Unique identifier of the X509 Certificate.

##### `query_string`

Data type: `Optional[String]`

API query string (optional)

## Plans

### `powerstore::capacity_volumes`

list volumes with more than given capacity

#### Parameters

The following parameters are available in the `powerstore::capacity_volumes` plan.

##### `threshold`

Data type: `Variant[Numeric,String]`

Volume capacity needed (in bytes or MB/GB/TB)

##### `targets`

Data type: `TargetSpec`



### `powerstore::create_assign_protection_policy`

A Bolt Plan that creates a set of "organization default" snapshot rules,
uses them to create a protection policy, then assigns that new protection
policy to an existing volume

* **See also**
  * https://github.com/puppetlabs/dellemc-powerstore

#### Examples

##### Ensures a default set of snapshot rules have been created and assigned to the existing volume, `db_backups`

```puppet
bolt plan run powerstore::create_assign_protection_policy --targets powerstore volume_name=db_backups
```

#### Parameters

The following parameters are available in the `powerstore::create_assign_protection_policy` plan.

##### `volume_name`

Data type: `String`

The name of an already existing volume on the array that we'll attach
our protection policy to

##### `ensure`

Data type: `Enum['present', 'absent']`

Determines if the protection policy created by this plan is or is not
assigned to the provided volume

Default value: `'present'`

##### `targets`

Data type: `TargetSpec`



### `powerstore::create_multiple_volumes`

This plan creates multiple volumes

#### Parameters

The following parameters are available in the `powerstore::create_multiple_volumes` plan.

##### `volume_count`

Data type: `Integer[1,100]`

Number of volumes to create. The volume names are "vol_${i}" with $i ranging from 1 to $volume_count.

##### `targets`

Data type: `TargetSpec`



### `powerstore::create_volume`

A Bolt Plan that creates or deletes a volume

* **See also**
  * https://github.com/puppetlabs/dellemc-powerstore

#### Examples

##### Creates a new volume named `db_backups`

```puppet
bolt plan run powerstore::create_volume --targets powerstore volume_name=db_backups
```

#### Parameters

The following parameters are available in the `powerstore::create_volume` plan.

##### `volume_name`

Data type: `String`

A name for the new volume

##### `size`

Data type: `Integer`

Override the default size (25GB) of the new volume

Default value: `26843545600`

##### `description`

Data type: `String`

A simple description to explain the purpose of the volume

Default value: `'Created via Puppet powerstore_volume resource'`

##### `ensure`

Data type: `Enum['present', 'absent']`

If the volume should exist or be deleted

Default value: `'present'`

##### `targets`

Data type: `TargetSpec`



### `powerstore::create_volume_attach_host_with_fs`

A Bolt Plan that creates a volume, maps that new volume to an existing
host, scans that host's iSCSI bus to ensure device nodes have been created,
computes the device name as viewed by the host, partitions the new disk
device, puts new file system on partition, mounts fresh file system at
designated location

* **See also**
  * https://github.com/puppetlabs/dellemc-powerstore

#### Examples

##### Create a volume of the name `db_backups` and mount it upon the host `backup1` with the size of 250GB

```puppet
bolt plan run powerstore::create_volume_attach_host_with_fs --targets powerstore host=backup1 volume_name=db_backups $volume_size=268435456000
```

#### Parameters

The following parameters are available in the `powerstore::create_volume_attach_host_with_fs` plan.

##### `host_name`

Data type: `String`

An host as defined within the Bolt inventory that will be have the new
volume mapped to mounted on with file systems created

##### `volume_name`

Data type: `String`

Name for the new volume that will be created on the powerstore array

##### `mount_point`

Data type: `String`

Override the default mount point of where the created volume will be
mounted on the host once a file system has successfully been created

Default value: `"/mnt/${volume_name}"`

##### `volume_size`

Data type: `Integer`

Override the default size (25G) of the newly created volume

Default value: `26843545600`

##### `targets`

Data type: `TargetSpec`



### `powerstore::delete_multiple_volumes`

This plan deletes multiple volumes after first removing them from a group if they are a group member.

#### Parameters

The following parameters are available in the `powerstore::delete_multiple_volumes` plan.

##### `volume_count`

Data type: `Integer[1,100]`

Number of volumes to delete. The volume names are "vol_${i}" with $i ranging from 1 to $volume_count.

##### `targets`

Data type: `TargetSpec`



### `powerstore::find_empty_volume_groups`

Find empty volume groups - Puppet language plan example

#### Parameters

The following parameters are available in the `powerstore::find_empty_volume_groups` plan.

##### `targets`

Data type: `TargetSpec`



### `powerstore::get_fs_used_size_greaterthan_threshold`

List filesystems using more than $threshold percent of storage. Note: currently limited to one target.

#### Parameters

The following parameters are available in the `powerstore::get_fs_used_size_greaterthan_threshold` plan.

##### `threshold`

Data type: `Integer[1,99]`

A usage threshold as percentage

Default value: `90`

##### `format`

Data type: `Enum['json','table']`

Output format: json (for automation use) or table (human-readable)

Default value: `'table'`

##### `targets`

Data type: `TargetSpec`



### `powerstore::multi_create_volume_attach_host_with_fs`

This Bolt Plan makes is possible to create volumes, map them to multiple
hosts, create XFS file systems upon them and mount them at a specific
location by wrapping another plan that is capable of doing this for a single
host

* **See also**
  * https://github.com/puppetlabs/dellemc-powerstore

#### Examples

##### Create a volume of the name `customer_app_database` and mount it upon two hosts, `database1` and `database2`

```puppet
bolt plan run powerstore::multi_create_volume_attach_host_with_fs --targets powerstore hosts='[ "database1", "database2" ]' volume_name=customer_app_database
```

#### Parameters

The following parameters are available in the `powerstore::multi_create_volume_attach_host_with_fs` plan.

##### `hosts`

Data type: `Array[String[1]]`

An array of hosts defined within the Bolt inventory that will be have the
new volumes mapped to and mounted on with file systems created

##### `volume_name`

Data type: `String`

A base name of the volumes that will be used to create unique volume names
on the powerstore array, actual volume sames end up being of the pattern
${host}_${volume_name}

##### `mount_point`

Data type: `String`

Override the default mount point of where the created volumes will be
mounted on the host once file systems have successfully be created

Default value: `"/mnt/${volume_name}"`

##### `targets`

Data type: `TargetSpec`



